#define AIDAR ASSADULLIN
#define SNUS OFORMIT VKID

#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define pii pair<int, int>

using namespace std;
typedef long long ll;
typedef long double ld;

#define int ll

const int maxn = 1e6 + 10;
int f[maxn];
int used2[maxn];
int used[maxn];
vector<int> r[maxn];
int t = 1;

int dfs(int v) {
    if (used[v] == t)
        return 0;
    used[v] = t;
    for (auto &u : r[v]) {
        if (f[u] == -1) {
            f[u] = v;
            return 1;
        }
    }
    for (auto &u : r[v]) {
        if (dfs(f[u])) {
            f[u] = v;
            return 1;
        }
    }
    return 0;
}

void solve() {
    memset(f, -1, sizeof(f));
    int n, m;
    cin >> n >> m;
    string a[n];
    for (auto &i : a)
        cin >> i;
    auto make = [&] (int x1, int y1, int x2, int y2) {
        int l = x1 * m + y1;
        int r = x2 * m + y2;
//        cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
        if ((x1 + y1) & 1)
            swap(l, r);
        ::r[l].pb(r);
    };
    auto good = [&] (int x1, int y1, int x2, int y2) {
        int l = x1 * m + y1;
        int r = x2 * m + y2;
//        cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
        if ((x1 + y1) & 1)
            swap(l, r);
        return f[r] == l;

    };
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i + 1 < n && a[i][j] == a[i + 1][j] && a[i][j] != '.') {
                if (j > 0 && a[i][j - 1] == a[i + 1][j - 1] && a[i + 1][j - 1] == '.' && a[i][j] == tolower(a[i][j])) {
                    make(i, j - 1, i + 1, j - 1);
                } else if (j + 1 < m && a[i][j + 1] == a[i + 1][j + 1] && a[i + 1][j + 1] == '.' && a[i][j] == toupper(a[i][j])) {
                    make(i, j + 1, i + 1, j + 1);
                }
            } else if (j + 1 < m && a[i][j] == a[i][j + 1] && a[i][j] != '.') {
                if (i > 0 && a[i - 1][j] == a[i - 1][j + 1] && a[i - 1][j + 1] == '.' && a[i][j] == tolower(a[i][j])) {
                    make(i - 1, j, i - 1, j + 1);
                } else if (i + 1 < n && a[i + 1][j] == a[i + 1][j + 1] && a[i + 1][j + 1] == '.' && a[i][j] == toupper(a[i][j])) {
                    make(i + 1, j, i + 1, j + 1);
                }
            }
        }
    }
    int ans = 0;
//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            if ((i + j) % 2 == 0)
//                for (auto &u : r[i * m + j]) {
//                    if (f[u] == -1) {
//                        f[u] = i * m + j;
//                        ans += 1;
//                        break;
//                    }
//                }
//        }
//    }
    auto child = [&] (int x, int y) {
        vector<pii> v;
        if (x - 1 >= 0)
            v.pb({x - 1, y});
        if (x - 1 >= 0 && y + 1 < m)
            v.pb({x - 1, y + 1});
        if (y + 2 < m)
            v.pb({x, y + 2});
        if (y + 2 < m && x + 1 < n)
            v.pb({x + 1, y + 2});
        if (x + 2 < n)
            v.pb({x + 2, y});
        if (x + 2 < n && y + 1 < m)
            v.pb({x + 2, y + 1});
        if (y - 1 >= 0)
            v.pb({x, y - 1});
        if (y - 1 >= 0 && x + 1 < n)
            v.pb({x + 1, y - 1});
        return v;
    };
    for (int i = 0; i < n * m; ++i) {
        if (f[i] != -1)
            used2[f[i]] = 1;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; ++j, t++) {
            if ((i + j) % 2 == 0 && used2[i * m + j] == 0)
                ans += dfs(i * m + j);
        }
    }
    vector<string> str(n, string(m, '.'));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i + 1 < n && a[i][j] == a[i + 1][j] && a[i][j] != '.') {
                if (j > 0 && good(i, j - 1, i + 1, j - 1)) {
                    auto v = child(i, j - 1);
                    set<char> s = {'.', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
                    for (auto &u : v)
                        if (s.count(str[u.f][u.s])) {
                            s.erase(str[u.f][u.s]);
                        }
                    str[i][j] = str[i][j - 1] = str[i + 1][j] = str[i + 1][j - 1] = *s.begin();
                } else if (j + 1 < m && good(i, j + 1, i + 1, j + 1)) {
                    auto v = child(i, j);
                    set<char> s = {'.', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
                    for (auto &u : v)
                        if (s.count(str[u.f][u.s])) {
                            s.erase(str[u.f][u.s]);
                        }
                    str[i][j] = str[i][j + 1] = str[i + 1][j] = str[i + 1][j + 1] = *s.begin();
                }
            } else if (j + 1 < m && a[i][j] == a[i][j + 1] && a[i][j] != '.') {
                if (i > 0 && good(i - 1, j, i - 1, j + 1)) {

                    auto v = child(i - 1, j);
                    set<char> s = {'.', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
                    for (auto &u : v)
                        if (s.count(str[u.f][u.s])) {
                            s.erase(str[u.f][u.s]);
                        }
                    str[i - 1][j] = str[i - 1][j + 1] = str[i][j] = str[i][j + 1] = *s.begin();
                } else if (i + 1 < n && good(i + 1, j, i + 1, j + 1)) {

                    auto v = child(i, j);
                    set<char> s = {'.', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
                    for (auto &u : v)
                        if (s.count(str[u.f][u.s])) {
                            s.erase(str[u.f][u.s]);
                        }
                    str[i][j] = str[i][j + 1] = str[i + 1][j] = str[i + 1][j + 1] = *s.begin();
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i + 1 < n && a[i][j] == a[i + 1][j] && a[i][j] != '.' && str[i][j] == '.') {
                vector<pii> v;
                v.pb({i - 1, j});
                v.pb({i, j + 1});
                v.pb({i, j - 1});
                v.pb({i + 1, j + 1});
                v.pb({i + 1, j - 1});
                v.pb({i + 2, j});
                set<char> s = {'.', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};

                for (auto &u : v)
                    if (u.f >= 0 && u.s >= 0 && u.f < n && u.s < m && s.count(str[u.f][u.s])) {
                        s.erase(str[u.f][u.s]);
                    }
                str[i][j] = str[i + 1][j] = *s.begin();
            } else if (j + 1 < m && a[i][j] == a[i][j + 1] && a[i][j] != '.' && str[i][j] == '.') {
                vector<pii> v;
                v.pb({i - 1, j});
                v.pb({i - 1, j + 1});
                v.pb({i, j - 1});
                v.pb({i, j + 2});
                v.pb({i + 1, j});
                v.pb({i + 1, j + 1});
                set<char> s = {'.', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};

                for (auto &u : v)
                    if (u.f >= 0 && u.s >= 0 && u.f < n && u.s < m && s.count(str[u.f][u.s])) {
                        s.erase(str[u.f][u.s]);
                    }
                str[i][j] = str[i][j + 1] = *s.begin();
            }
        }
    }
    cout << ans << '\n';
    for (auto &i : str)
        cout << i << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
