#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
//#ifdef DEBUG
//    freopen("input.txt", "r", stdin);
//#endif
    solve();
    return 0;
}

#define int long long

const int N = 2e5 + 100;

struct point {
    int x, y;

    point(int x, int y) : x(x), y(y) {}

    point operator+(point b) {
        return point(x + b.x, y + b.y);
    }

    point operator-(point b) {
        return point(x - b.x, y - b.y);
    }

    int operator%(point b) {
        return x * b.y - b.x * y;
    }

};

bool sign(int a, int b) {
    if (a > 0 && b > 0) return false;
    if (a < 0 && b < 0) return false;
    if (a == 0 || b == 0) return false;
    return true;
}

bool segment(point a, point b, point c, point d) {
    point ac = c - a;
    point ad = d - a;
    point ca = a - c;
    point cb = b - c;
    point ab = b - a;
    point cd = d - c;
    if (sign(ab % ac, ab % ad) && sign(cd % ca, cd % cb)) {
        return true;
    } else {
        return false;
    }
}


int n;
vector < point > a;

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.push_back({x, y});
    }
    int cnt = 0, f = 0;
    vector < pair < int, int > > b;
    while (f < n) {
        bool ok = false;
        for (int i = 0; i < n; i++) {
            if (i == f) continue;
            bool fl = false;
            for (int j = 0; j < b.size(); j++) {
                if ((f == b[j].first && i == b[j].second) || (f == b[j].second && i == b[j].first) || segment(a[f], a[i], a[b[j].first], a[b[j].second])) {
                    fl = true;
                    break;

                }
            }
            if (!fl) {
                b.push_back({f, i});
                ok = true;
                break;
            }
        }
        if (!ok) {
            f++;
        }
    }
    cnt = b.size();
    b.clear();
    if (cnt % 2 == 1) {
        cout << 1 << endl;
    } else {
        cout << 2 << endl;
        int f, s;
        cin >> f >> s;
        f--, s--;
        b.push_back({f, s});
    }
    f = 0;
    while (f < n) {
        bool ok = false;
        for (int i = 0; i < n; i++) {
            if (i == f) continue;
            bool fl = false;
            for (int j = 0; j < b.size(); j++) {
                if ((f == b[j].first && i == b[j].second) || (f == b[j].second && i == b[j].first) || segment(a[f], a[i], a[b[j].first], a[b[j].second])) {
                    fl = true;
                    break;
                }
            }
            if (!fl) {
                cout << f + 1 << " " << i + 1 << endl;
                b.push_back({f, i});
                ok = true;
                break;
            }
        }
        if (!ok) {
            f++;
        } else {
            int q, w;
            cin >> q >> w;
            q--, w--;
            b.push_back({q, w});
        }
    }
}