#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <queue>
#include <ctime>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>
#include <chrono>
#include <list>
using namespace std;

//#define int ll

typedef long long ll;
typedef long double ld;
typedef pair <int , int> pii;
typedef pair <ll , ll> pll;


#define ff first
#define ss second
#define mp make_pair
#define pf push_front
#define pb push_back
#define IO ios_base::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
#define print(x) { for (auto xxxxxxxxx : (x)) cout << xxxxxxxxx << ' '; cout << '\n'; }
#define printp(x) { for (auto xxxxxxxxx : (x)) cout << "{" << xxxxxxxxx.ff << ", " << xxxxxxxxx.ss << "} "; cout << '\n'; }
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const ll mod=1e9+7;
const ll inf=2e18+5;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll random(ll l, ll r){ return uniform_int_distribution<ll>(l, r)(rng);}

int n , m;
vector <string> a;
vector < vector <int> > id , type;
vector < vector <bool> > can;
vector <pii> pos[2];
vector <set <int> > g;

vector <int> nxti = {1 , -1 , 0 , 0} , nxtj = {0 , 0 , 1 , -1};

bool F(char c) {
    if (c >= 'A' && c <= 'Z')
        return true;
    return false;
}

// A - right or down
// a - left or up

vector <int> ans;
vector <bool> was;

void dfs(int v , int cnt = 0) {
    was[v] = true;
    if (cnt % 2 == 0)
        ans.pb(v);
    for (auto to : g[v]) {
        if (was[to])
            continue;
        dfs(to , cnt + 1);
    }
}

void solve(){
    cin >> n >> m;
    a.resize(n);
    id.resize(n , vector <int> (m , -1));
    type.resize(n , vector <int> (m));
    can.resize(n , vector <bool> (m , true));
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }


    int T = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int t = 0; t < 4; t++) {
                int x = i + nxti[t] , y = j + nxtj[t];
                if (x < 0 || x >= n || y < 0 || y >= m || a[i][j] == '.' || a[x][y] == '.' || !can[i][j] || !can[x][y])
                    continue;

                if (a[i][j] == a[x][y]) {
                    id[i][j] = id[x][y] = T++;
                    if (F(a[i][j])) {
                        if (t < 2) {
                            // x +- 1
                            type[i][j] = 2;
                            type[x][y] = 2;
                        } else {
                            // y +- 1
                            type[i][j] = 0;
                            type[x][y] = 0;
                        }
                    } else {
                        if (t < 2) {
                            // x +- 1
                            type[i][j] = 3;
                            type[x][y] = 3;
                        } else {
                            // y +- 1
                            type[i][j] = 1;
                            type[x][y] = 1;
                        }
                    }
                    pos[0].emplace_back(i , j);
                    pos[1].emplace_back(x , y);
                    can[i][j] = can[x][y] = false;
                }
            }
        }
    }
    /*
    cout << T << endl;
    for (int i = 0; i < n; i++) {
        print(id[i]);
    }
    */
    g.resize(T);
    was.resize(T , false);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int x = max(0 , i - 4); x < min(n , i + 5); x++) {
                for (int y = max(0 , j - 4); y < min(m , j + 5); y++) {
                    if (id[i][j] == -1 || id[x][y] == -1 || id[x][y] == id[i][j])
                        continue;

                    int x1 = x , y1 = y;
                    int k = id[x][y];
                    int t = type[x][y];
                    x += nxti[t] , y += nxtj[t];
                    int curi = nxti[type[i][j]] + i , curj = nxtj[type[i][j]] + j;
                    int curid = id[i][j];
                    if (mp(curi , curj) == mp(x , y)) {
                        g[k].insert(curid);
                        g[curid].insert(k);
                    }
                    if (mp(x , y) == mp(i , j) || mp(x1 , y1) == mp(curi , curj)) {
                        g[k].erase(curid);
                        g[curid].erase(k);
                    }

                    x = x1 , y = y1;
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int x = max(0 , i - 4); x < min(n , i + 5); x++) {
                for (int y = max(0 , j - 4); y < min(m , j + 5); y++) {
                    if (id[i][j] == -1 || id[x][y] == -1 || id[x][y] == id[i][j])
                        continue;

                    int x1 = x , y1 = y;
                    int k = id[x][y];
                    int t = type[x][y];
                    x += nxti[t] , y += nxtj[t];
                    int curi = nxti[type[i][j]] + i , curj = nxtj[type[i][j]] + j;
                    int curid = id[i][j];
                    if (mp(x , y) == mp(i , j) || mp(x1 , y1) == mp(curi , curj)) {
                        g[k].erase(curid);
                        g[curid].erase(k);
                    }

                    x = x1 , y = y1;
                }
            }
        }
    }


    for (int i = 0; i < T; i++) {
        if (g[i].size() < 2 && !was[i]) {
            dfs(i);
        }
    }

    for (int i = 0; i < T; i++) {
        if (!was[i]) {
            dfs(i);
        }
    }

    for (auto x : ans) {
        for (int t = 0; t < 2; t++) {
            pii cur = pos[t][x];
            int r = type[cur.first][cur.second];
            cur.first += nxti[r] , cur.second += nxtj[r];
            id[cur.first][cur.second] = id[pos[t][x].first][pos[t][x].second];
        }
    }
    cout << ans.size() << '\n';
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (id[i][j] == -1)
                continue;
            set <int> p;
            for (int i = 0; i <= 9; i++) {
                p.insert(i);
            }
            for (int x = max(0 , i - 2); x < min(n , i + 2); x++) {
                for (int y = max(0 , j - 2); y < min(m , j + 2); y++) {
                    p.erase(id[x][y]);
                }
            }
            id[i][j] = *p.begin() + 1;
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (id[i][j] == 0)
                cout << ".";
            else
                cout << id[i][j] - 1;
        }
        cout << '\n';
    }
}
/*
4 4
.AA.
A..a
A..a
.aa.

3 4
.XX.
....
YYZZ

3 4
.XX.
....
yyzz
 */
signed main() {
    IO
    //freopen(".in" , "r" , stdin);freopen(".out" , "w" , stdout);
    int t=1;
    //cin >> t;
    while(t--) solve();
}