#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::pair;
using std::string;

using ll = long long;
using ld = long double;

vector<vector<int>> g;
vector<int> color;
vector<int> used;


bool dfs (int u, int c = 0, int p = -1) {
	color[u] = c;
	used.push_back(u);
	bool f = false;
	int ans = c;
	for (int v : g[u]) {
		if (color[v] == -1)
			if (dfs(v, c ^ 1))
				f = true;
		if (color[v] == color[u])
			f = true;
	}
	return f;
}


signed main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<vector<char>> f(n, vector<char> (m));

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			cin >> f[i][j];


	vector<vector<pair<int, int>>> v;
	vector<pair<int, int>> move = {{1, 0}, {0, 1}};
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j) {
			if (f[i][j] != '.') {
				for (auto p : move) {
					int i1 = i + p.first, j1 = j + p.second;
					if (i1 >= 0 && i1 < n && j1 >= 0 && j1 < m && f[i][j] == f[i1][j1]) {
						v.push_back({{i, j}, {i1, j1}});
						if (f[i][j] <= 'Z') {
							if (i1 == i + 1) {
								if (j + 1 < m && f[i][j + 1] == '.' && j1 + 1 < m && f[i1][j1 + 1] == '.') {
									v.back().push_back({i, j + 1});
									v.back().push_back({i1, j1 + 1});
								}
							} else {
								if (i + 1 < n && f[i + 1][j] == '.' && i1 + 1 < n && f[i1 + 1][j1] == '.') {
									v.back().push_back({i + 1, j});
									v.back().push_back({i1 + 1, j1});
								}
							}
						} else {
							if (i1 == i + 1) {
								if (j > 0 && f[i][j - 1] == '.' && j1 > 0 && f[i1][j1 - 1] == '.') {
									v.back().push_back({i, j - 1});
									v.back().push_back({i1, j1 - 1});
								}
							} else {
								if (i > 0 && f[i - 1][j] == '.' && i1 > 0 && f[i1 - 1][j1] == '.') {
									v.back().push_back({i - 1, j});
									v.back().push_back({i1 - 1, j1});
								}
							}
						}
						// f[i][j] = '.';
						// f[i1][j1] = '.';
					}
				}
			}
		}

	vector<vector<int>> v1(n, vector<int> (m, -1));
	g.resize(v.size());
	for (int i = 0; i < v.size(); ++i)
		for (int j = 2; j < v[i].size(); ++j) {
			int &a = v1[v[i][j].first][v[i][j].second];
			if (a != -1) {
				g[i].push_back(a);
				g[a].push_back(i);
			} else {
				a = i;
			}
		}

	color.resize(g.size(), -1);
	for (int i = 0; i < g.size(); ++i)
		if (color[i] == -1 && v[i].size() > 2) {
			if (!dfs(i)) {
				int cnt = 0;
				for (int i : used)
					cnt += color[i];
				if (2 * cnt < used.size())
					for (int i : used)
						color[i] ^= 1;
				used.clear();
			}
		} else if (v[i].size() <= 2) {
			color[i] = 0;
		}

	int sum = 0;
	for (int i : color)
		sum += i;


	for (int i = 0; i < v.size(); ++i) {
		int ml = n + 1, mr = m + 1;
		for (auto p : v[i])
			ml = std::min(ml, p.first), mr = std::min(mr, p.second);
		int c = (ml % 3) * 3 + mr % 3;
		for (int j = 0; j < 2; ++j)
			f[v[i][j].first][v[i][j].second] = '0' + c;
		if (color[i])
			for (int j = 2; j < v[i].size(); ++j)
				f[v[i][j].first][v[i][j].second] = '0' + c;
	}

	cout << sum << '\n';

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j)
			cout << f[i][j];
		cout << '\n';
	}
	
	return 0;
}