#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair 
#define pb push_back 

#include <iostream>
#include <algorithm>
#include <math.h>
#include <stack>
#include <vector>
#include <queue>
#include <iomanip>
#include <cassert>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 2e5 + 1;
const int alp = 30;
const ll inf = 1e9 + 10;
const int mod = 1e9 + 7;

struct str{
	ll first, second;
	int num;
	
};

vector < str > a, b;

ll prefw[maxn], prefc[maxn];

bool cmp(str f, str s) {
	return f.second * s.first > s.second * f.first;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen("notepad.in", "r", stdin);
	//freopen("notepad.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		a.clear();
		b.clear();
		int n, W;
		cin >> n >> W;
		for (int i = 1; i <= n; ++i) {
			ll w, cost;
			cin >> w >> cost;
			if (w > W)
				continue;
			if (w * 2 > W) {
				b.push_back({ w, cost, i });
			}
			else {
				a.push_back({ w, cost, i });
			}
		}
		sort(a.begin(), a.end(), cmp);

		ll ans = 0;

		for (int i = 1; i <= a.size(); ++i) {
			prefw[i] = prefw[i - 1] + a[i - 1].first;
			prefc[i] = prefc[i - 1] + a[i - 1].second;
			if (prefw[i] * 2 <= W * 3) {
				ans = max(ans, prefc[i]);
			}
		}

		

		for (auto t : b) {
			int l = 0, r = a.size() + 1;
			while (r - l > 1) {
				int m = (l + r) / 2;
				if ((prefw[m] + t.first) * 2ll <= W * 3ll) {
					l = m;
				}
				else {
					r = m;
				}
			}
			ans = max(ans, prefc[l] + t.second);
			
		}

		bool done = false;

		for (int i = 1; i <= a.size(); ++i) {
			if (prefw[i] * 2 <= W * 3) {
				if (ans == prefc[i]) {
					cout << i << '\n';
					for (int j = 0; j < i; ++j) {
						cout << a[j].num << ' ';
					}

					cout << '\n';
					done = true;
					break;
				}
			}
		}

		if (done)
			continue;

		for (auto t : b) {
			int l = 0, r = a.size() + 1;
			while (r - l > 1) {
				int m = (l + r) / 2;
				if ((prefw[m] + t.first) * 2ll <= W * 3ll) {
					l = m;
				}
				else {
					r = m;
				}
			}
			if (ans == prefc[l] + t.second) {
				cout << l + 1 << '\n';
				cout << t.num << ' ';
				for (int j = 0; j < l; ++j) {
					cout << a[j].num << ' ';
				}
				cout << '\n';
				done = true;
				break;
			}

		}

		assert(done);

	}
	

}