#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;
template <typename T1, typename T2>
bool chkmax(T1& a, T2 b) { if (b > a) { a = b; return true; } return false; }
template <typename T1, typename T2>
bool chkmin(T1& a, T2 b) { if (b < a) { a = b; return true; } return false; }
int max(int a, int b) { return a > b ? a : b; }
ld sqr(ld a) { return a * a; }
const int INF = 1e18;

void solve() {
    int n;
    cin >> n;
    vector <int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int asd = 0; asd < 10000; asd++) {
        int removei = rand() % n;

        int ap = 0, bp = b[removei];
        for (int i = 0; i < n; ++i) {
            if (i == removei) {
                continue;
            }
            int to1 = min(ap, b[i]);
            int to2 = min(bp, a[i]);
            int na = a[i];
            int nb = b[i];
            ap -= to1;
            na -= to1;
            bp -= to2;
            nb -= to2;
            bp += nb;
            ap += na;
        }
        if (ap == 0) {
            cout << "YES\n";
            return;
        }
    }
    cout << "NO\n";

}

int32_t main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
}
