#include <bits/stdc++.h>

#include <random>

using namespace std;
#define int long long
#define fastio ios_base::sync_with_stdio(0); cin.tie(0);
#define fileio freopen("output.txt", "w", stdout); freopen("input.txt", "r", stdin);

bool cmp1(tuple<int, int, int> l, tuple<int, int, int> r) {
    if (get<1>(l) * get<0>(r) == get<1>(r) * get<0>(l)) {
        if (get<1>(l) - get<0>(l) != get<1>(r) - get<0>(r)) return get<1>(l) - get<0>(l) > get<1>(r) - get<0>(r);
        if (get<1>(l) != get<1>(r)) return get<1>(l) > get<1>(r);
        if (get<0>(l) != get<0>(r)) return get<0>(l) < get<1>(l);
        return get<2>(l) < get<2>(r);
    }
    return get<1>(l) * get<0>(r) > get<1>(r) * get<0>(l);
}

bool cmp2(tuple<int, int, int> l, tuple<int, int, int> r) {
    if (get<1>(l) - get<0>(l) == get<1>(r) - get<0>(r)) {
        if (get<1>(l) / get<0>(l) != get<1>(r) / get<0>(r)) return get<1>(l) / get<0>(l) > get<1>(r) / get<0>(r);
        if (get<1>(l) != get<1>(r)) return get<1>(l) > get<1>(r);
        if (get<0>(l) != get<0>(r)) return get<0>(l) < get<1>(l);
        return get<2>(l) < get<2>(r);
    }
    return get<1>(l) - get<0>(l) > get<1>(r) - get<0>(r);
}

bool cmp3(tuple<int, int, int> l, tuple<int, int, int> r) {
    if (get<1>(l) / get<0>(l) == get<1>(r) / get<0>(r)) {
        if (get<1>(l) - get<0>(l) != get<1>(r) - get<0>(r)) return get<1>(l) - get<0>(l) > get<1>(r) - get<0>(r);
        if (get<1>(l) != get<1>(r)) return get<1>(l) > get<1>(r);
        if (get<0>(l) != get<0>(r)) return get<0>(l) < get<1>(l);
        return get<2>(l) < get<2>(r);
    }
    return get<1>(l) / get<0>(l) > get<1>(r) / get<0>(r);
}

bool cmp4(tuple<int, int, int> l, tuple<int, int, int> r) {
    if (get<0>(l) == get<0>(r)) {
        if (get<1>(l) == get<1>(r)) return get<2>(l) < get<2>(r);
        return get<1>(l) > get<1>(r);
    }
    return get<0>(l) < get<0>(r);
}

bool cmp5(tuple<int, int, int> l, tuple<int, int, int> r) {
    if (get<1>(l) == get<1>(r)) {
        if (get<0>(l) == get<0>(r)) return get<2>(l) < get<2>(r);
        return get<0>(l) < get<0>(r);
    }
    return get<1>(l) > get<1>(r);
}

signed main() {
    fastio
//    fileio
    int q;
    cin >> q;
    while (q--) {
        int n, W;
        cin >> n >> W;
        vector<tuple<int, int, int>> wc(n);
        int del = 1;
        if (W >= 100000000000) {
            del = 100000;
            W /= del;
        } else if (W >= 1000000000) {
            del = 10000;
            W /= del;
        }
        for (int i = 0; i < n; ++i) {
            int w, c;
            cin >> w >> c; w = (w + del - 1) / del;
            wc[i] = {w, c, i};
        }
        if (n * W <= 500000000) {
            vector<vector<int>> dp(W + 1, vector<int>(n + 1, -1));
            vector<vector<int>> parent(W + 1, vector<int>(n + 1, -1));
            dp[0][0] = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = W; j >= 0; --j) {
                    dp[j][i + 1] = dp[j][i];
                    if (j - get<0>(wc[i]) < 0 || dp[j - get<0>(wc[i])][i] == -1) continue;
                    int c1 = j - get<0>(wc[i]);
                    if (dp[j][i + 1] < dp[c1][i] + get<1>(wc[i])) {
                        parent[j][i + 1] = 0;
                        dp[j][i + 1] = dp[c1][i] + get<1>(wc[i]);
                    }
                }
            }
            int mx = 0;
            for (int i = 1; i <= W; ++i) {
                if (dp[mx][n] < dp[i][n]) mx = i;
            }
            int who = n;
            vector<int> ans;
            while (who != 0) {
                if (parent[mx][who] == -1) {
                    --who;
                    continue;
                }
                ans.push_back(get<2>(wc[who - 1]));
                mx -= get<0>(wc[who - 1]);
                --who;
            }
            cout << ans.size() << '\n';
            for (int i = 0; i < ans.size(); ++i) {
                cout << ans[i] + 1 << ' ';
            }
            cout << '\n';
        } else {
            sort(wc.begin(), wc.end(), cmp1);
            int sm1 = 0;
            int c1 = 0;
            vector<int> who;
            for (int i = 0; i < n; ++i) {
                if (sm1 + get<0>(wc[i]) <= 3 * W / 2) {
                    who.push_back(get<2>(wc[i]));
                    ++i;
                    sm1 += get<0>(wc[i]);
                    c1 += get<1>(wc[i]);
                }
            }
            sort(wc.begin(), wc.end(), cmp2);
            int sm2 = 0;
            int c2 = 0;
            vector<int> who2;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who2.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                c1 = c2;
                who = who2;
            }
            sort(wc.begin(), wc.end(), cmp3);
            sm2 = 0;
            c2 = 0;
            vector<int> who3;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who3.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who3;
                c1 = c2;
            }
            sort(wc.begin(), wc.end(), cmp4);
            sm2 = 0;
            c2 = 0;
            vector<int> who4;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who4.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who4;
                c1 = c2;
            }
            sort(wc.begin(), wc.end(), cmp5);
            sm2 = 0;
            c2 = 0;
            vector<int> who5;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who5.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who5;
                c1 = c2;
            }
            shuffle(wc.begin(), wc.end(), std::mt19937(std::random_device()()));
            sm2 = 0;
            c2 = 0;
            vector<int> who6;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who6.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who6;
                c1 = c2;
            }
            shuffle(wc.begin(), wc.end(), std::mt19937(std::random_device()()));
            sm2 = 0;
            c2 = 0;
            vector<int> who7;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who7.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who7;
                c1 = c2;
            }

            shuffle(wc.begin(), wc.end(), std::mt19937(std::random_device()()));
            sm2 = 0;
            c2 = 0;
            vector<int> who8;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who8.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who8;
                c1 = c2;
            }

            shuffle(wc.begin(), wc.end(), std::mt19937(std::random_device()()));
            sm2 = 0;
            c2 = 0;
            vector<int> who9;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who9.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who9;
                c1 = c2;
            }

            shuffle(wc.begin(), wc.end(), std::mt19937(std::random_device()()));
            sm2 = 0;
            c2 = 0;
            vector<int> who10;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who10.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who10;
                c1 = c2;
            }

            shuffle(wc.begin(), wc.end(), std::mt19937(std::random_device()()));
            sm2 = 0;
            c2 = 0;
            vector<int> who11;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who11.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who11;
                c1 = c2;
            }

            shuffle(wc.begin(), wc.end(), std::mt19937(std::random_device()()));
            sm2 = 0;
            c2 = 0;
            vector<int> who12;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who12.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who12;
                c1 = c2;
            }


            shuffle(wc.begin(), wc.end(), std::mt19937(std::random_device()()));
            sm2 = 0;
            c2 = 0;
            vector<int> who13;
            for (int i = 0; i < n; ++i) {
                if (sm2 + get<0>(wc[i]) <= 3 * W / 2) {
                    who13.push_back(get<2>(wc[i]));
                    ++i;
                    sm2 += get<0>(wc[i]);
                    c2 += get<1>(wc[i]);
                }
            }
            if (c1 < c2) {
                who = who13;
                c1 = c2;
            }
            cout << who.size() << '\n';
            for (int i = 0; i < who.size(); ++i) {
                cout << who[i] + 1 << ' ';
            }
            cout << '\n';
        }
    }
}