#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, k;
int res = 0;
vector<int> cur;
int dp[16][16];
vector<int> precalc(16, 0);

void solve(int sm) {
    if (sm == 0) {
        vector<int> cnt(n, 0);
        for (auto e : cur) {
            cnt[e - 1]++;
        }

        int cur_res = 1;
        for (int i = 0; i < n; ++i) {
            cur_res *= precalc[cnt[i]];
        }
        res += cur_res;

        return;
    }

    int mn = 0;
    if (!cur.empty()) {
        mn = cur[cur.size() - 1];
    }

    for (int i = max(mn, 1LL); i <= sm; ++i) {
        cur.push_back(i);
        solve(sm - i);
        cur.pop_back();
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cin >> n >> k;


    for (int i = 0; i < n + 1; ++i) {
        for (int j = 0; j < k + 1; ++j) {
            dp[i][j] = 0;
        }
    }

    dp[0][k] = 1;

    for (int i = 1; i < n + 1; ++i) {
        for (int j = 0; j < k; ++j) {
            for (int l = j; l <= k; ++l) {
                dp[i][j] += dp[i - 1][l];
            }
        }
    }


    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= k; ++j) {
            precalc[i] += dp[i][j];
        }

//        cerr << precalc[i] << '\n';
    }

    solve(n);

    cout << res;
}