#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <climits>
#include <random>
#include <unordered_set>
#include <queue>
#include <bitset>

using namespace std;

#pragma warning (disable : 4996)

void resolve()
{
    long long n;
    cin >> n;
    vector<pair<long long, long long>> v(n);
    for (long long i = 0; i < n; i++)
        cin >> v[i].second;
    for (long long i = 0; i < n; i++)
        cin >> v[i].first;
    sort(v.rbegin(), v.rend());
    long long sum1 = 0, sum2 = 0;
    for (long long i = 0; i < n; i++)
        sum1 += v[i].second;
    for (long long i = 1; i < n; i++)
        sum2 += v[i].first;
    if (sum1 < sum2) {
        cout << "NO";
        return;
    }
    for (long long i = 1; i < n; i++) {
        if (sum1 - v[i].second < v[i].first) {
            cout << "NO";
            return;
        }
    }
    cout << "YES";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef  _DEBUG
    freopen("input.txt", "r", stdin);
#endif 
    long long t;
    cin >> t;
    for (long long i = 0; i < t; i++)
    {
        resolve();
        cout << '\n';
    }
    return 0;
}