﻿/*#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")*/

#include <algorithm>
#include <iomanip>
#include <cmath>
#include <iostream>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>

using namespace std;


#define ll long long
#define ld long double
#define int long long

#define pii pair<int, int>
#define pll pair<int, ll>
#define vi vector<int>
#define vl vector<ll>
#define vb vector<bool>
#define vs vector<string>
#define vvi vector<vector<int>>
#define vvl vector<vector<ll>>
#define vpii vector<pii>
#define vpll vector<pll>

const int N = 50;
const int inf = 1e9;
const ll INF = 1e18;
const ll M = 1e9 + 7;
const string io[2]{ "NO", "YES" };

int gcd(int a, int b)
{
    if (!b) return a;
    return gcd(b, a % b);
}
void vcin(vector<int>& x)
{
    for (int& element : x)
    {
        cin >> element;
    }
}
void vcout(vector<int>& x)
{
    for (int& element : x)
    {
        cout << element;
    }
}

int can(vector <int>& v, int mid, int need, int i, int s) {
    int r = upper_bound(v.begin(), v.end(), mid + need - 1) - v.begin() - 1;
    if (s + r - (i - 1) >= need) return 1;
    else return 0;

}
void solve()
{
    int n, m, s;
    cin >> n >> m >> s;
    vector <int> v(m);
    for (int i = 0; i < m; i++) cin >> v[i];

    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    int need = m;
    m = v.size();
    int ans = 0;
    for (int i = 0; i < m; i++) {
        int L = (i ? v[i - 1] + 1 : 1), R = v[i] + 1, mid;
        while (L != R - 1) {
            mid = (L + R) / 2;
            if (can(v, mid, need, i, s)) R = mid;
            else L = mid;
        }
        //  cout << i << " " << L << endl;
        if (!can(v, L, need, i, s)) continue;
        if (v[i] + need - 1 > n) {
            for (int j = v[i]; v[i] - j + 1 >= need && j > (i ? v[i - 1] : 0); j--) {
                if (j + need - 1 <= n) ans += can(v, j, need, i, s);
           }
            break;
        }
        ans += v[i] - L + 1;
        //cout << i << " " << L << " " << can << " " << r2 << " " << r1 << endl;
    }
    cout << ans << endl;
}

signed main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;// cin >> t;
    while (t--)
        solve();
}