#include <functional>
#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,avx")

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = 2e5 + 1;
const ll mod = 1000000007;

void ex(ll exitCode = 0) {
#ifdef _DEBUG
	//system("pause");
#endif // _DEBUG
	exit(exitCode);
}

ll n, k;

ll ans = 0;

ll cnt[16];

ll dp[16][16];

void bc(ll q, ll pr = inf) {
	if (q == 0) {
		ll curr = 1;
		for (ll i = 1; i <= n; i++) {
			if (cnt[i] == 0) continue;
			curr *= dp[cnt[i]][k];
		}
		ans += curr;
		return;
	}
	for (ll i = min(q, pr); i >= 1; i--) {
		cnt[i]++;
		bc(q - i, i);
		cnt[i]--;
	}
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n >> k;
	dp[0][0] = 1;
	for (ll q = 1; q <= k; q++) {
		dp[0][q] = 1;
		for (ll i = 1; i <= n; i++) {
			for (ll j = 0; j <= i; j++) dp[i][q] += dp[i - j][q - 1];
		}
	}
	bc(n);
	cout << ans;
	ex();
}