#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m, s;
    cin >> n >> m >> s;
    vector<int> cards(m, 0);
    for(int i = 0; i < m; ++i){
        cin >> cards[i];
    }
    sort(cards.begin(), cards.end());
    cards.erase(unique(cards.begin(), cards.end()), cards.end());
    int last = 0;
    int ans = 0;
    for(int i = 0; i + m - s - 1 < cards.size(); ++i){
        int l = cards[i + m - s - 1] - cards[i] + 1;
        if(s >= l - m + s){
            int maxl = max(last + 1, cards[i] - s + l - m + s),
            minr = min(n, cards[i + m - s - 1] + s - l + m - s);
            ans += max(minr - maxl + 2 - m, 0);
            last = cards[i];
        }
    }
    cout << ans;

    return 0;
}