﻿#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("rename-registers")
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <bitset>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <cctype>
#include <cassert>
#include <climits>
#include <ctime>
#include <cstdlib>
#include <fstream>
#include <functional>
#include <iostream>
#include <iomanip>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>

using namespace std;

#define all(x) x.begin(), x.end()
#define int long long

const int INF = LLONG_MAX;
const int mod = 1e9 + 7;
const double eps = 1e-7;

template <class T>
istream& operator >>(istream& in, vector<T>& arr) {
	for (T& cnt : arr) {
		in >> cnt;
	}
	return in;
};

//void solveJ() {
//	int n, m, s; cin >> n >> m >> s;
//	vector<int> a(m), new_a; cin >> a;
//	sort(all(a));
//	new_a.push_back(a[0]);
//	for (int i = 1; i < m; i++) {
//		if (a[i] != a[i - 1]) new_a.push_back(a[i]);
//	}
//	a.resize((int)new_a.size());
//	a = new_a;
//	int maxi = a[(int)a.size() - 1];
//	for (int i = 1; i <= s; i++) {
//		if (maxi + i > n) break;
//		a.push_back(maxi + i);
//	}
//	int new_m = a.size();
//	vector<int> pref(new_m);
//	pref[0] = a[0] - 1;
//	for (int i = 1; i < new_m; i++) {
//		pref[i] = a[i] - a[i - 1] - 1 + pref[i - 1];
//	}
//	int ans = 0;
//	for (int i = 0; i < new_m; i++) {
//		if (a[i] >= m) {
//			int l = 0, r = i + 1;
//			while (r - l > 1) {
//				int mid = (l + r) / 2;
//				if (pref[mid] <= pref[i] - m) l = mid;
//				else r = mid;
//			}
//			int add, first_elem = a[i] - m;
//			if (a[i] - a[l] < m) add = pref[i];
//			else if (a[l] == first_elem && l > 0)
//				add = pref[i] - pref[l - 1];
//			else if (a[l] == first_elem && l == 0)
//				add = pref[i];
//			else if(l < n - 1)
//				add = pref[i] - pref[l + 1] + a[l + 1] - first_elem;
//			if (add <= s) ans++;
//		}
//	}
//	cout << ans;
//}

//vector<vector<string>> All(21);
//
//void solveB() {
//	int n; cin >> n;
//	All[1].push_back("1"), All[1].push_back("0");
//	for (int i = 2; i <= 20; i++) {
//		for (int j = 0; j < All[i - 1].size(); j++) {
//			All[i].push_back("0" + All[i - 1][j]);
//		}
//		for (int j = 0; j < All[i - 1].size(); j++) {
//			All[i].push_back("1" + All[i - 1][j]);
//		}
//	}
//	if (n == 1) cout << "01";
//	else if (n == 2) cout << "0110";
//	set<string> had;
//	string cur = "0110";
//	for (int i = 3; i <= n; i++) {
//		string g = "";
//		for (int j = 0; j < cur.size(); j++) {
//			g += cur[j];
//			if ((j + 1) % (i - 1) == 0) {
//				had.insert(g);
//				g = "";
//			}
//		}
//		for (int j = 0, add = 0; j < All[i - 1].size() && add < 2; j++) {
//			string s = All[i - 1][j];
//			if (!had.count(s)) cur += s, add++;
//		}
//	}
//	cout << cur;
//}

int n, k; 
vector<vector<int>> total;

void gen(int sum, vector<int>a, int last) {
	if (sum > n) return;
	if (sum == n) {
		total.push_back(a);
		return;
	}
	for (int i = last; i <= 15; i++) {
		a.push_back(i);
		gen(sum + i, a, i);
		a.pop_back();
	}
}

int cnt(int n, int k) {
	if (k == 1) return 1;
	int rostislavich = 0;
	for (int i = 0; i <= n; i++) {
		rostislavich += cnt(n - i, k - 1);
	}
	return rostislavich;
}

void solveD() {
	cin >> n >> k;
	int ans = 0;
	for (int i = 0; i < total.size(); i++) {
		map<int, int> mp;
		for (int j = 0; j < total[i].size(); j++) {
			mp[total[i][j]]++;
		}
		int len = (int)mp.size();
		ans += pow(k, len);
		for (auto i : mp) {
			ans += cnt(mp[i.first], k);
		}
	}
	cout << ans;
}

//void solveC() {
//	int n; cin >> n;
//	vector<int> a(n), b(n); cin >> a >> b;
//	int sum1 = 0, sum2 = 0, maxi = -2e9;
//	for (int i = 0; i < n; i++) {
//		sum1 += a[i];
//		sum2 += b[i];
//		maxi = max(maxi, b[i]);
//	}
//	if (sum2 - maxi <= sum1) cout << "YES\n";
//	else cout << "NO\n";
//}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _tests = 1;
	//cin >> _tests;
	while (_tests--) {
		solveD();
	}
}