﻿#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("rename-registers")
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <bitset>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <cctype>
#include <cassert>
#include <climits>
#include <ctime>
#include <cstdlib>
#include <fstream>
#include <functional>
#include <iostream>
#include <iomanip>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>

using namespace std;

#define all(x) x.begin(), x.end()
#define int long long

const int INF = LLONG_MAX;
const int mod = 1e9 + 7;
const double eps = 1e-7;

template <class T>
istream& operator >>(istream& in, vector<T>& arr) {
	for (T& cnt : arr) {
		in >> cnt;
	}
	return in;
};

void solveJ() {
	int n, m, s; cin >> n >> m >> s;
	vector<int> a(m), new_a; cin >> a;
	sort(all(a));
	new_a.push_back(a[0]);
	for (int i = 1; i < m; i++) {
		if (a[i] != a[i - 1]) new_a.push_back(a[i]);
	}
	a.resize((int)new_a.size());
	a = new_a;
	int maxi = a[(int)a.size() - 1];
	for (int i = 1; i <= s; i++) {
		if (maxi + i > n) break;
		a.push_back(maxi + i);
	}
	int new_m = a.size();
	vector<int> pref(new_m);
	pref[0] = a[0] - 1;
	for (int i = 1; i < new_m; i++) {
		pref[i] = a[i] - a[i - 1] - 1 + pref[i - 1];
	}
	int ans = 0;
	for (int i = 0; i < new_m; i++) {
		if (a[i] >= m && pref[i] <= s) ans++;
	}
	cout << ans;
}

//void solveB() {
//	int n; cin >> n;
//	string cur = "01";
//	for (int i = 2; i <= n; i++) {
//		string add = cur;
//		for (int j = 0; j < add.size(); j++) {
//			if (add[j] == '0') add[j] = '1';
//			else add[j] = '0';
//		}
//		cur += add;
//	}
//	cout << cur;
//}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _tests = 1;
	//cin >> _tests;
	while (_tests--) {
		solveJ();
	}
}