/*
         ,--"""",--.__,---[],-------._
       ,"   __,'            \         \--""""""==;-
     ," _,-"  "/---.___     \       ___\   ,-'',"
    /,-'      / ;. ,.--'-.__\  _,-"" ,| `,'   /
   /``""""-._/,-|:\       []\,' ```-/:;-. `. /
             `  ;:::      ||       /:,;  `-.\
                =.,'__,---||-.____',.=
                =(:\_     ||__    ):)=
               ,"::::`----||::`--':::"._
             ,':::::::::::||::::::::::::'.
    .__     ;:::.-.:::::__||___:::::.-.:::\     __,
       """-;:::( O )::::>_|| _<::::( O )::::-"""
   =======;:::::`-`:::::::||':::::::`-`:::::\=======
    ,--"";:::_____________||______________::::""----.          , ,
         ; ::`._(    |    |||     |   )_,'::::\_,,,,,,,,,,____/,'_,
       ,;    :::`--._|____[]|_____|_.-'::::::::::::::::::::::::);_
      ;/ /      :::::::::,||,:::::::::::::::::::::::::::::::::::/
     /; ``''''----------/,'/,__,,,,,____:::::::::::::::::::::,"
     ;/                :);/|_;| ,--.. . ```-.:::::::::::::_,"
    /;                :::):__,'//""\\. ,--.. \:::,:::::_,"
   ;/              :::::/ . . . . . . //""\\. \::":__,"
   ;/          :::::::,' . . . . . . . . . . .:`::\
   ';      :::::::__,'. ,--.. . .,--. . . . . .:`::`
   ';   __,..--'''-. . //""\\. .//""\\ . ,--.. :`:::`
   ;    /  \\ .//""\\ . . . . . . . . . //""\\. :`::`
   ;   /       . . . . . . . . . . . . . . . . .:`::`
   ;   (          . . . . . . . . . . . . . . . ;:::`
   ,:  ;,            . . . . . . . . . . . . . ;':::`
   ,:  ;,             . . . . . . . . . . . . .;`:::
   ,:   ;,             . . . . . . . . . . . . ;`::;`
    ,:  ;             . . . . . . . . . . . . ;':::;`
     :   ;             . . . . . . . . . . . ,':::;
      :   '.          . . . . . . . .. . . .,':::;`
       :    `.       . . . . . . . . . . . ;::::;`
        '.    `-.   . . . . . . . . . . ,-'::::;
          `:_    ``--..___________..--'':::::;'`
             `._::,.:,.:,:_ctr_:,:,.::,.:_;'`
________________`"\/"\/\/'""""`\/"\/""\/"____________________________
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstdio>
#include <set>
#include <fstream>
#include <climits>
#include <cmath>
#include <deque>
#include <map>
#include <ctime>
#include <random>
#include <unordered_set>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <cassert>
#include <bits/stdc++.h>

#define ff first
#define ss second
#define pb push_back
#define pp pop_back
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define IO ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define out(a) cout << a << " ";
#define in(x) cin >> x;
#define ends cout << endl;
#define here cout << "here" << endl;
using namespace std;
int n, k;
vector <vector <ll>> p;
ll res = 0;
void gen(int last, int sum, vector <int> &arr) {
    if (sum + last > n) return;
    if (sum + last == n) {
        vector <int> l(n + 1, 0);
        for (int i = 0; i < arr.size(); i++) {
            l[arr[i]]++;
        }
        ll tmp = 1;
        for (int i = 0; i <= n; i++) {
            if (l[i] != 0) {
                tmp *= p[l[i]][k];
            }
        }
        res += tmp;
        return;
    }
    for (int i = last; i <= n; i++) {
        arr.push_back(i);
        gen(i, sum + last, arr);
        arr.pop_back();
    }
}

ll rec(int i, int  j) {
    if (i == 1) {
        p[i][j] = j;
        return j;
    }
    if (j == 1) {
        p[i][j] = 1;
        return 1;
    }
    ll sum = 0;
    for (int q = j; q >= 1; q--) {
        if (p[i - 1][q] != 0) sum += p[i - 1][q];
        else sum += rec(i - 1, q);
    }
    p[i][j] = sum;
    return sum;
}

void solve() {
    cin >> n >> k;
    vector <int> arr;
    p.resize(17, vector <ll> (17, 0));
    rec(16, 16);
    for (int i = 1; i <= n; i++) {
        arr.push_back(i);
        gen(i, 0, arr);
        arr.pop_back();
    }
    cout << res;
}

int main(){
    solve();
    return 0;
}