#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = 3.1415926535897932384626433832795;
const int MAXN = 5e5;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;
ld START_TIME, TIME;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

string getBin(int n, int x) {
    string res(x, '0');
    for (int i = 0; i < x; ++i) {
        res[i] = '0' + ((n >> i) & 1);
    }
    reverse(all(res));
    return res;
}

void solve() {
    vector<int> m = {1, 3, 6, 11, 20};
    int n;
    cin >> n;
    int i;
    for (i = 0; i < 5 && (1 << i) + i <= n; ++i);
    int x = i - 1;
    int lenRes = 0;
    int len = (1 << x);
    vector<int> numbers;
    set<int> set;
    vector<int> res;
    for (int mask = 0; mask < (1 << len); ++mask) {
        lenRes += len;
        numbers.push_back(mask);
    }
    for (int i = 0; i + 1 < numbers.size(); i += 2) {
        int newNum = (numbers[i] << len) + numbers[i + 1]; // ?
        res.push_back(newNum);
        set.insert(newNum);
    }
    len *= 2;
    for (int mask = 0; mask < (1 << len) && lenRes < (1 << n); ++mask) {
        if (set.find(mask) == set.end()) {
            set.insert(mask);
            lenRes += len;
            res.push_back(mask);
        }
    }
    for (auto &elem : res) {
        cout << getBin(elem, len);
    }
}

int main() {
    START_TIME = clock();
    fast_in_out();
#ifdef __APPLE__
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
#endif
    int TESTS = 1;
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
#ifdef __APPLE__
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << en << TIME * 1000 << " ms." << en;
#endif
    return 0;
}
