#include <bits/stdc++.h>
using namespace std;
#define int long long
int n;
struct Point
{
	int x;
	int y;
};
struct Seg
{
	Point a;
	Point b;
};
Point operator-(Point a, Point b)
{
	return (Point){a.x - b.x, a.y - b.y};
}
bool operator==(Point a, Point b)
{
	return a.x == b.x && a.y == b.y;
}
int proz(Point a, Point b)
{
	return a.x * b.y - b.x * a.y;
}
int sign(int a)
{
	if(a > 0)
	{
		return 1;
	}
	if(a < 0)
	{
		return -1;
	}
	return 0;
}
bool inter(Seg a, Seg b)
{
	if((a.a == b.a && a.b == b.b) || (a.b == b.a && a.a == b.b))
	{
		return true;
	}
	if(a.a == b.a || a.a == b.b || a.b == b.a || a.b == b.b)
	{
		return false;
	}
	if(sign(proz(a.b - a.a, b.a - a.a)) != sign(proz(a.b - a.a, b.b - a.a)) &&
	sign(proz(b.b - b.a, a.a - b.a)) != sign(proz(b.b - b.a, a.b - b.a)))
	{
		return true;
	}
	return false;
}
vector<Seg> used;
int pointer = 0;
vector<Seg> segs;
vector<pair<int, int> > ch;
vector<Point> p;

bool emulate(bool print = false)
{
	while(pointer < segs.size())
	{
		bool ok = true;
		for(int i = 0; i < used.size(); i++)
		{
			if(inter(used[i], segs[pointer]))
			{
				ok = false;
				break;
			}
		}
		pointer++;
		if(ok)
		{
			used.push_back(segs[pointer - 1]);
			if(print)
			{
				cout << ch[pointer - 1].first << " " << ch[pointer - 1].second << endl;
			}
			return true;
		}
	}
	return false;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
	p.resize(n);
	for(int i = 0; i < n; i++)
	{
		cin >> p[i].x >> p[i].y;
	}
	for(int i = 0; i < n; i++)
	{
		for(int j = i + 1; j < n; j++)
		{
			segs.push_back((Seg){p[i], p[j]});
		}
	}
	int it = 0;
	while(emulate())
	{
		it++;
	}
	if(it % 2 == 0)
	{
		cout << 2 << endl;
	}
	else
	{
		cout << 1 << endl;
	}
	segs.resize(0);
	for(int i = 0; i < n; i++)
	{
		for(int j = i + 1; j < n; j++)
		{
			segs.push_back((Seg){p[i], p[j]});
			ch.push_back({i + 1, j + 1});
		}
	}
	used.resize(0);
	pointer = 0;
	if(it % 2 == 1)
	{
		emulate(true);
	}
	while(true)
	{
		int a1, a2;
		cin >> a1 >> a2;
		a1--;
		a2--;
		if(a1 == -1 && a2 == -1)
		{
			return 0;
		}
		used.push_back((Seg){p[a1], p[a2]});
		emulate(true);
	}
}
