#include <bits/stdc++.h>

using namespace std;

int n;
vector <pair <int, int> > p;
vector <int> u;
vector <vector <int> > segs;

int product(int x1, int y1, int x2, int y2) {
    return x1 * y2 - x2 * y1;
}

bool intersect(vector <int> a, vector <int> b) {
    int x1 = a[0], y1 = a[1], x2 = a[2], y2 = a[3];
    int x3 = b[0], y3 = b[1], x4 = b[2], y4 = b[3];
    if (((x1 == x3 && y1 == y3) && (x2 == x4 && y2 == y4)) || ((x2 == x3 && y2 == y3) && (x1 == x4 && y1 == y4)))
        return true;
    if ((x1 == x3 && y1 == y3) || (x1 == x4 && y1 == y4) || (x2 == x3 && y2 == y3) || (x2 == x4 && y2 == y4))
        return false;
    int fl1 = product(x3 - x1, y3 - y1, x2 - x1, y2 - y1) > 0;
    int fl2 = product(x4 - x1, y4 - y1, x2 - x1, y2 - y1) > 0;
    int fl3 = product(x1 - x4, y1 - y4, x3 - x4, y3 - y4) > 0;
    int fl4 = product(x2 - x4, y2 - y4, x3 - x4, y3 - y4) > 0;
    return (fl1 != fl2) && (fl3 != fl4);
}

bool check(vector <int> cur_seg) {
    for (auto el : segs) {
        if (intersect(cur_seg, el))
            return false;
    }
    return true;
}

pair <bool, pair <int, int> > add() {
    for (int i = 0; i < n; i++) {
        while (u[i] < n) {
            vector <int> cur_seg = {p[i].first, p[i].second, p[u[i]].first, p[u[i]].second};
            if (check(cur_seg)) {
                segs.push_back(cur_seg);
                u[i]++;
                return {true, {i, u[i] - 1}};
            }
            u[i]++;
        }
    }
    return {false, {}};
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    p.resize(n);
    u.resize(n);
    for (int i = 0; i < n; i++)
        u[i] = i + 1;
    for (int i = 0; i < n; i++)
        cin >> p[i].first >> p[i].second;
    bool fl = true;
    while (fl)
        fl = add().first;
    int sz = (int)segs.size();
    segs.clear();
    for (int i = 0; i < n; i++)
        u[i] = i + 1;
    if (sz % 2) {
        cout << "1" << endl;
        auto kek = add();
        cout << kek.second.first + 1 << " " << kek.second.second + 1 << endl;
    }
    else
        cout << "2" << endl;
    for (int c = 0; c < sz / 2; c++) {
        int i, j;
        cin >> i >> j;
        if (!i)
            return 0;
        i--;
        j--;
        segs.push_back({p[i].first, p[i].second, p[j].first, p[j].second});
        auto kek = add();
        cout << kek.second.first + 1 << " " << kek.second.second + 1 << endl;
    }
    cin >> n >> n;
    return 0;
}

