#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <deque>
#include <iomanip>
#include <queue>

using namespace std;
vector <int> c, gl;
vector <vector <int>> g;
vector <bool> used;

void dfs(int v) {
    used[v] = true;
    for (int i : g[v]) {
        if (!used[i]) {
            gl[i] = gl[v] + 1;
            dfs(i);
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n);
    c.resize(n);
    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        g[x - 1].push_back(y - 1);
        g[y - 1].push_back(x - 1);
    }
    used.resize(n);
    gl.resize(n);
    dfs(0);
    for (int i = 0; i < n; ++i) {
        if (k == 1) cout << 1 << " ";
        else cout << gl[i] % 2 + 1 << " ";
    }
}