//
// Created by watemus on 06.12.2020.
//

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define FF first
#define SS second

using ll = long long;
using ld = long double;

#define int ll

template<typename T>
using vec = std::vector<T>;

template<typename T>
using uset = std::unordered_set<T>;

template<typename T1, typename T2>
using umap = std::unordered_map<T1, T2>;

constexpr ll INFL = 1000000000000000069;
constexpr int INFI = 1000000069;
const ld PI = acos(-1);

#ifdef LOCAL
std::mt19937 rnd(69);
#else
std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());
#endif

vec<pair<int, int>> DD = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

#ifdef LOCAL
#else
#endif

void run() {
  int n, s, m;
  cin >> n >> m >> s;
  vector<int> v(m);
  set<int> ans;
  for (int i = 0; i < m; ++i) {
    cin >> v[i];
  }
  sort(ALL(v));
  v.erase(unique(ALL(v)), v.end());
  auto get = [&] (int x) {
    int y = x + m - 1;
    if (y > n) return 0;
    auto R = upper_bound(ALL(v), y);
    auto L = lower_bound(ALL(v), x);
    int cnt = 0;
    if (R == L) {
      cnt = 0;
    } else {
      if (R == v.end()) {
        cnt = v.end() - L;
      } else {
        cnt = R - L + 1;
      }
    }
    if (m - cnt <= s) return 1;
    return 0;
  };
  int X = -1;
  vector<int> interesting = {1};
  for (auto i : v) {
    interesting.push_back(i);
    if (i - 1 > 0) interesting.push_back(i - 1);
    if (i + 1 <= n) interesting.push_back(i + 1);
  }

  for (auto i : interesting) {
    X = i;
    while (ans.count(X) == 0 && get(X) == 1) {
      ans.insert(X);
      X++;
    }
    X = i - 1;
    while (X > 0 && ans.count(X) == 0 && get(X) == 1) {
      ans.insert(X);
      X--;
    }
  }
  cout << (int) ans.size() << '\n';
}

signed main() {
#ifdef LOCAL
  std::freopen("input.txt", "r", stdin);
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  int t = 1;
  // cin >> t;
  while (t--) {
    run();
  }
  return 0;
}


