#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef vector<ll> vll;
typedef complex<double> cd;

const char el = '\n';
const int inf = 1000'000'000, mod = 1000'000'007, mod2 = 998'244'353;
const ll llinf = 1e18;
const ld pi = 3.141592653589793238462643383279502884197169399375105820974944592307816406286208998628034825;

//#define forn(i, n) for (int i = 0; i < (int)n; ++i)
//#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)
#define firn(i, n) for (int (i) = 1; (i) != (n); (i)++)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << el
#define popcount(x) __builtin_popcount(x)
#define popcountll(x) __builtin_popcountll(x)
#define fi first
#define se second
#define re return
#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())
#define int long long

template<typename T> bool uin(T &a, T b) { if (b < a) { a = b; return true; } return false; }
template<typename T> bool uax(T &a, T b) { if (b > a) { a = b; return true; } return false; }
template<class iterator> void output(iterator begin, iterator end, char p = ' ', ostream & out = cout) { while (begin != end) { out << (*begin) << p; begin++; } out << el; }
template<class T> void output(T x, char p = ' ', ostream & out = cout) { output(all(x), p, out); }

mt19937 rnd(time(nullptr));
mt19937_64 rnd_64(time(nullptr));

const int INF = 2e18;

int get_len(int x) {
    if (x == 0) return 1;
    int len = 0;
    while (x) {
        x /= 10;
        ++len;
    }
    return len;
}

int get_eq(int len, int d) {
    int res = 0;
    for (int i = 0; i < len; ++i) {
        res = res * 10 + d;
    }
    return res;
}

vector<int> to_vector(int x) {
    if (x == 0) return {0};
    vector<int> res;
    while(x) {
        res.emplace_back(x % 10);
        x /= 10;
    }
    reverse(res.begin(), res.end());
    return res;
}

int get_atleast(int len, int l) {
    int n = get_len(l);
    vector<int> a = to_vector(l);
    int ans = INF;
    for (int d = 0; d < 10; ++d) {
        for (int pos = 1 + (d == 0); pos <= n - len + 1; ++pos) {
            int cur = 0;
            for (int i = 1; i <= n; ++i) {
                if (pos <= i && i <= pos + len - 1) {
                    cur = cur * 10 + d;
                } else {
                    cur = cur * 10 + a[i - 1];
                }
            }
            if (cur >= l) uin(ans, cur);
            cur = 0;
            int lali = 0;
            for (int i = 1; i < pos; ++i) {
                lali = lali * 10 + a[i - 1];
            }
            lali += 1;
            cur = lali;
            if (get_len(lali) == pos - 1) {
                for (int i = pos; i <= n; ++i) {
                    if (pos <= i && i <= pos + len - 1) {
                        cur = cur * 10 + d;
                    } else {
                        cur = cur * 10 + a[i - 1];
                    }
                }
                if (cur >= l) {
                    uin(ans, cur);
                }
            }
        }
    }
    return ans;
}

int get_answer(int l, int r) {
    if (get_len(l) < get_len(r)) {
        int n = get_len(r);
        for (int d = 1; d <= 9; ++d) {
            if (l <= get_eq(n, d) && get_eq(n, d) <= r) {
                return get_len(r);
            }
        }
        return get_len(r) - 1;
    }
    int n = get_len(l);
    for (int len = n; len >= 1; --len) {
        int A = get_atleast(len, l);
        if (A <= r) {
            return len;
        }
    }
    return 1;
}

long long dp[20][10][2][2];

long long calc(int F, long long r)
{
    if (r == 0)
    {
        if (F == 1) return 1;
        return 0;
    }
    vector<ll> d;
    while (r > 0)
    {
        d.push_back(r % 10);
        r /= 10;
    }
    d.push_back(0);
    reverse(all(d));
    for (int i = 0; i < 20; i++)
        for (int j = 0; j < 10; j++)
            for (int k = 0; k < 2; k++)
                for (int l = 0; l < 2; l++)
                    dp[i][j][k][l] = 0;
    dp[0][0][0][0] = 1;
    for (int i = 0; i < d.size(); i++)
    {
        for (int j = 0; j < 10; j++)
        {
            //cout << i << " " << j << " " << dp[i][j][0][0] << endl;
            //cout << i << " " << j << " " << dp[i][j][0][1] << endl;
            //cout << i << " " << j << " " << dp[i][j][1][0] << endl;
            //cout << i << " " << j << " " << dp[i][j][1][1] << endl;
            for (int dt = 0; dt < 10; dt++)
            {
                if (dt == j) continue;
                int iscut = 0;
                for (int cntd = 1; i + cntd < d.size(); cntd++)
                {
                    if (iscut == 0 && dt < d[i + cntd])
                        iscut = 1;
                    if (iscut == 0 && dt > d[i + cntd])
                        break;
                    //cout << "went " << i + cntd << " " << dt << " " << iscut << " " << (cntd == F) << endl;
                    dp[i + cntd][dt][iscut][(cntd == F)] += dp[i][j][0][0];
                    dp[i + cntd][dt][iscut][1] += dp[i][j][0][1];
                }
                for (int cntd = 1; i + cntd < d.size(); cntd++)
                {
                    dp[i + cntd][dt][1][(cntd == F)] += dp[i][j][1][0];
                    dp[i + cntd][dt][1][1] += dp[i][j][1][1];
                }
            }
        }
    }
    ll res = 0;
    for (int ld = 0; ld < 10; ld++)
        res += dp[d.size() - 1][ld][1][1] + dp[d.size() - 1][ld][0][1];
    return res;
}

ll func[20][20];

ll calc2(ll l, ll r, ll F)
{
    ll ans = calc(F, r) - calc(F, l - 1);

    ans += func[get_len(r) - 1][F] - func[get_len(l - 1) - 1][F];
    //cout << func[get_len(r)][F] << " " << func[get_len(l - 1)][F] << endl;

    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll D = 1;
    for (ll deg = 0; deg < 20; deg++)
    {
        for (int F = 2; F < 20; F++)
        {
            func[deg][F] = calc(F, D - 1);
        }
        D *= 10;
    }
    for (ll deg = 1; deg < 20; deg++)
    {
        for (int F = 2; F < 20; F++)
            func[deg][F] += func[deg - 1][F];
    }

    int t;
    cin >> t;
    while(t--) {
        int l, r;
        cin >> l >> r;
        int F = get_answer(l, r);
        cout << F << " ";
        if (F == 1)
        {
            cout << r - l + 1 << "\n";
        }
        else
        {
            cout << calc2(l, r, F) << "\n";
            assert(calc2(l, r, F + 1) == 0);
        }
    }
    return 0;
}
