// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,unroll-all-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>

#define ll long long
#define int ll
#define ld long double
#define pb push_back
#define pll pair<ll, ll>
#define ff first
#define ss second
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define mp make_pair

using namespace std;

const int p = 31;
const int mod = 1e9 + 7;
const int max_n = 2e3 + 5;
const int log_n = 20;
const int inf = 1e17;
const long double pi = acos(-1);
const ld eps = 1e-11;
const int len = 400;

std::mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int ans = 0;

vector<vector<int>> c;
void c_build() {
    c.resize(31, vector<int> (31, 0));
    c[0][0] = 1;
    c[1][0] = 1;
    rep(i, 31) {
        c[i][0] = 1;
    }
    rep(i, 31) {
        if (i == 0) continue;
        rep(j, i + 1) {
            if (j == 0) continue;   
            c[i][j] = c[i - 1][j - 1] + c[i - 1][j];
        }
    }
}

vector<int> cur(20);
int k;
void gen(int sum, int last) {
    if (sum == 0) {
        int res = 1;
        rep(i, 20) {
            res *= c[cur[i] + k - 1][k - 1];
        }
        ans += res;
    }
    for (int i = last; i <= sum; ++i) {
        cur[i]++;
        gen(sum - i, i);
        cur[i]--;
    }
}

void run() {
    int n;
    cin >> n >> k;
    c_build();
    gen(n, 1);
    cout << ans;
}

signed main() {
#ifndef ONLINE_JUDGE
    // files("input.txt", "output.txt");
#endif
    // files("optimize.in", "optimize.out");
    // srand(time(0));
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        run();
    return 0;
}