#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, w;

int calc(const vector< tuple<int, int, int> >& aa) {
	int curw = 0;
	int curc = 0;
	for(auto [ww, cc, ii]: aa) {
		if(curw + ww <= w) {
			curw += ww;
			curc += cc;
		}
	}
	return curc;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;

	for(int q = 0; q < t; q++) {
		cin >> n >> w;

		vector< tuple<int, int, int> > aa(n);
		for(int i = 0; i < n; i++) {
			cin >> get<0>(aa[i]) >> get<1>(aa[i]);
			get<2>(aa[i]) = i;
		}

		if(n < 20) {
			int besttc = 0;
			int bestmask = 0;
			for(int mask = 0; mask < (1 << n); mask++) {
				int tc = 0;
				int tw = 0;
				for(int i = 0; i < n; i++) {
					if((mask >> i) & 1) {
						tw += get<0>(aa[i]);
						tc += get<1>(aa[i]);
					}
				}
				if(tw <= w && tc > besttc) {
					besttc = tc;
					bestmask = mask;
				}
			}
			cout << __builtin_popcount(bestmask) << "\n";
			for(int i = 0; i < n; i++) {
				if((bestmask >> i) & 1) {
					cout << get<2>(aa[i]) + 1 << " ";
				}
			}
			cout << "\n";
			continue;
		}

		if(w < 1000) {
			vector<vector<int>> dp(n, vector<int>(w + 1, -1000000000000000000LL));
			vector<vector<int>> p(n, vector<int>(w + 1, -1));
			dp[0][0] = 0;
			for(int i = 0; i < n; i++) {
				for(int j = 0; j <= w; j++) {
					dp[i][j] = (i == 0 ? (j == 0 ? 0 : -1000000000000000000LL) : dp[i - 1][j]);
					p[i][j] = i == 0 ? -1 : p[i - 1][j];
					if(j >= get<0>(aa[i])) {
						int cur = (i == 0 ? (j == get<0>(aa[i]) ? 0 : -1000000000000000000LL) : dp[i - 1][j - get<0>(aa[i])]) + get<1>(aa[i]);
						if(cur > dp[i][j]) {
							dp[i][j] = cur;
							p[i][j] = i;
						}
					}
				}
			}
			int bestc = 0;
			int bestj = 0;
			for(int j = 0; j <= w; j++) {
				if(dp[n - 1][j] > bestc) {
					bestc = dp[n - 1][j];
					bestj = j;
				}
			}
			int i = n - 1;
			vector<int> lst;
			while(i >= 0 && p[i][bestj] >= 0) {
				lst.push_back(get<2>(aa[p[i][bestj]]));
				int newbestj = bestj - get<0>(aa[p[i][bestj]]);
				i = p[i][bestj] - 1;
				bestj = newbestj;
			}
			cout << lst.size() << "\n";
			for(int x: lst) {
				cout << x + 1 << " ";
			}
			cout << "\n";
			continue;
		}

		w = w + w / 2;

		sort(aa.begin(), aa.end(), [](auto a, auto b) {
			return get<0>(b) * get<1>(a) > get<0>(a) * get<1>(b);
		});

		vector< tuple<double, int, int, int> > bb;
		for(auto [ww, cc, ii]: aa) {
			bb.emplace_back((double)ww / cc, ww, cc, ii);
			bb.emplace_back((double)ww / cc * 1.5, ww, cc, ii);
		}
		sort(bb.begin(), bb.end());
		vector<bool> take1(n);
		int curw = 0;
		int curc = 0;
		for(auto [_, ww, cc, ii]: bb) {
			if(!take1[ii] && curw + ww <= w) {
				take1[ii] = true;
				curw += ww;
				curc += cc;
			}
		}

		int oldans = calc(aa);

		double temp = 1;
		for(int i = 0; i < 200; i++) {
			auto aanew = aa;
			for(int j = 0; j < (int)(temp * 1.5 * (n + 1)); j++) {
				swap(aanew[rand() % n], aanew[rand() % n]);
			}
			int newans = calc(aanew);
			if(newans > oldans || rand() < RAND_MAX * exp(-(oldans - newans) / temp)) {
				aa = aanew;
				oldans = newans;
			}
			temp *= 0.99;
		}

		vector<int> ans;
		if(curc > oldans) {
			for(int i = 0; i < n; i++) {
				if(take1[i]) {
					ans.push_back(i);
				}
			}
		} else {
			for(auto [ww, cc, ii]: aa) {
				if(w >= ww) {
					w -= ww;
					ans.push_back(ii);
				}
			}
		}

		cout << ans.size() << "\n";

		for(int x: ans) {
			cout << x + 1 << " ";
		}
		cout << "\n";
	}

	return 0;
}