#include <iostream>
#include <vector>

#ifdef LOCAL
    #include <dir.h>
#endif

#include <set>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define pasrange(i, n) for (int i = 1; i <= (n); ++i)
#define rrange(i, n) for (int i = n - 1; i >= 0; --i)
#define fi first
#define se second
typedef pair<int, int> pii;
typedef vector<int> vi;
#define pb push_back
#define pf push_front
typedef long long ll;


void setup(){
#ifdef LOCAL
    chdir(R"(C:\Users\oOrml\CLionProjects\VKOSHP)");
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

void solve();
int main(){
    setup();
    int t = 1;
//    cin >> t;
    range(_, t) {
        solve();
    }
}

const int MAXN = 2e6;
const int LOG = 21;
bool in[LOG][MAXN];
vector<int> arr;

void get_k(int y){
    int now = 0;
    int j = 0;
    range(i, arr.size()){
        now *= 2;
        now += arr[i];
        if (++j == (1 << y)){
            j = 0;
            in[y][now] = 1;
            now = 0;
        }
    }
}

void push_i(int y, int m){
    rrange(i, (1 << y)) {
        arr.push_back((m >> i) & 1);
    }
}

void solve() {
    int n; cin >> n;
    n = 1 << n;
    arr.reserve(n);
    int y = 0;
    int m = 0;
    while (arr.size() < n) {
        while (in[y][m]) ++m;
        if (m >= (1 << (1 << y))) {
            ++y;
            get_k(y);
            m = 0;
            continue;
        }
        in[y][m] = 1;
        push_i(y, m);
    }
    range(i, n) {
        cout << arr[i];
    }
}
