//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("fma,avx,avx2")
#include <iostream>
#include <random>
#include <vector>
#include <cstring>
#include <set>
#include <map>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
//#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

//using namespace __gnu_pbds;
using namespace std;

mt19937 rnd(6547389847627);

typedef long long ll;

#define int long long
#define ld double
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define sqr(a) (a) * (a)
#define debug(x) cout << #x << ": " << x << '\n'

template<class t, class u>
void amax(t &a, u b) { if (a < b) a = b; }

template<class t, class u>
void amin(t &a, u b) { if (b < a) a = b; }

template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

#define one(x) memset(x, -1, sizeof(x))
#define zero(x) memset(x, 0, sizeof(x))
#define MAX_SZ 300
int q = 1791791791;
int m = 1000000000000000007;

int hsh(pair<int, int> p) {
    return (p.first * q + p.second) % m;
}

void solve() {
    int n, W;
    cin >> n >> W;
    //c,w
    vpi inp;
    for (int i = 0; i < n; ++i) {
        int w,c;
        cin >> w >> c;
        inp.push_back({w,c});
    }
    sort(inp.rbegin(),inp.rend());
    map<int, pair<pi, int>> mp;
    vector<pair<int, int>> dp = {{0, 0}};
    for (int i = 0; i < n; i++) {
        int w = inp[i].first, c = inp[i].second;
        int sz = dp.size();
        for (int j = 0; j < sz; ++j) {
            //cout << dp[j].first << " " << dp[j].second << "\n";
            int cn = dp[j].first + c;
            int wn = dp[j].second + w;
            if (wn * 2 <= 3 * W) {
                if (mp.count(hsh({cn, wn}))) {
                    continue;
                }
                mp[hsh({cn, wn})] = {dp[j], i};
                dp.push_back({cn, wn});
            }
        }
        //cout << "\n";
        sort(dp.rbegin(), dp.rend());
        while (dp.size() > MAX_SZ) {
            dp.pop_back();
        }
    }/*
for (int i = 0; i < dp.size(); ++i) {
cout << dp[i].first << " " << dp[i].second << "\n";

}*/
    pi best = dp[0];
    vi ans;
    while (best.x != 0) {
        auto tmp = mp[hsh(best)];
        ans.push_back(tmp.y);
        best = tmp.x;
    }
    cout << sz(ans) << '\n';
    for (auto &el : ans) {
        cout << el + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}