#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define INF 0x3f3f3f3f
#define INFLL (int64_t)(1e18)
#define EPS 1e-9
#define MOD 1000000007

template <class T> istream &operator>>(istream &is, vector<T> &a) {
    for (size_t i = 0; i < a.size(); ++i)
        is >> a[i];
    return is;
}

string getBit(int a, int n) {
    string ans;
    for (int i = n - 1; i >= 0; --i)
        ans += ((a & (1 << i)) ? '1' : '0');
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, s;
    cin >> n >> m >> s;
    vector<int> c(m);
    cin >> c;
    c.push_back(0);
    sort(all(c));
    c.resize(unique(all(c)) - c.begin());
    int ans = 0;

    for (int i = 1; i + m - s - 1 < c.size(); ++i) {
        if (c[i + m - s - 1] -c[i] > m-1)
            continue;

        ans += max(0, min(c[i], n - m + 1) -
                          max(c[i - 1] + 1, c[i + m - s - 1] - m + 1) + 1);
        if (c[i] >= n - m + 1)
            break;
    }
    cout << ans;
    //    int n, k;
    //    cin >> n >> k;
    //    vector<vector<int>> a(15, vector<int>(15,1));
    //    for (int i = 1; i < 15; ++i) {
    //        for (int j = 1; j < 15; ++j) {
    //            a[i][j] = a[i-1][j] + a[i][j-1];
    //        }
    //    }
    //    long long ret = 0;
    //    for (int i = 0; i < n; ++i) {
    //        for (int j = 0; j < k; ++j){
    //            ret+=a[i][j];
    //        }
    //    }
    //    cout << ret;
    //    int t;
    //    cin >> t;
    //    while (t--) {
    //        int n;
    //        cin >> n;
    //        vector<int> a(n), b(n);
    //        cin >> a >> b;
    //        long long sum1 = 0, sum2 = 0;
    //        for (int i : a)
    //            sum1 += i;
    //        for (int i : b)
    //            sum2 += i;
    //        bool ans = false;
    //        for (int i = 0; i < n; ++i)
    //            if (sum1 >= sum2 - b[i])
    //                ans = true;
    //        if (n == 2) {
    //            if (a[0] >= b[1] || a[1] >= b[0])
    //                cout << "YES\n";
    //            else
    //                cout << "NO\n";
    //            continue;
    //        }
    //        if (ans)
    //            cout << "YES\n";
    //        else
    //            cout << "NO\n";
    //    }
}
