#include <bits/stdc++.h>

using namespace std;

//#pragma target("sse,sse2,sse3,ssse3,sse,popcnt,abm,mmx,avx,avx2,fma,tune=native")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")


template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a)
        in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i : a) {
        out << i << " ";
    }
    return out;
}

template<typename T, typename D>
istream &operator>>(istream &in, pair<T, D> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename D>
ostream &operator<<(ostream &out, const pair<T, D> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct LogOutput {
    template<typename T>
    LogOutput &operator<<(const T &x) {
#ifdef DOUT
        cout << x;
#endif
        return *this;
    }
} dout;

LogOutput fout;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

#define nl '\n'
#define elif else if
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define sz(v) (int)(v.size())
#define sqr(v) ((v) * (v))
#define vpi vector<pair<int, int>>
#define eb emplace_back
#define pb push_back
#define mod(x, m) ((x) >= 0 ? ((x) % m) : ((((x) % (m)) + (m))) % m)
#define vi vector<int>
#define pi pair<int, int>
#define ti tuple<int, int, int>
#define minq(x, y) x = min((x), (y))
#define maxq(x, y) x = max((x), (y))
#define forn(i, n) for (int i = 0; i < (n); ++i)

const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const int INF = 2139062143;
const int nINF = -2139062144;
const ull ULINF = numeric_limits<ull>::max();
const long double Pi = acos(-1);
auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

inline void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    cout.setf(ios::fixed);
    cout.precision(10);
}


#define int ll

const int N = 40;

int cnk[N][N];

int ans = 0;

void Rec(vector<int> &v, int sm, int n, int k) {
    assert(sm <= n);
    if (sm == n) {
        map<int, int> cnt;
        for (auto &i : v)
            cnt[i]++;
        int lans = 1;
        for (auto&[val, t] : cnt) {
            lans *= cnk[t + k - 1][k - 1];
        }
        ans += lans;
    }
    if (sm == 0) {
        for (int i = 1; i <= n; i++) {
            v.push_back(i);
            Rec(v, i, n, k);
            v.pop_back();
        }
    } else {
        for (int i = v.back(); sm + i <= n; i++) {
            v.push_back(i);
            Rec(v, sm + i, n, k);
            v.pop_back();
        }
    }
}

void Solve() {
    cnk[0][0] = 1;
    for (int n = 1; n < N; n++) {
        cnk[n][0] = 1;
        for (int k = 1; k <= n; k++) {
            cnk[n][k] = cnk[n - 1][k] + cnk[n - 1][k - 1];
        }
    }
    int n, k;
    cin >> n >> k;
    vector<int> v;
    Rec(v, 0, n, k);
    cout << ans << nl;

}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    int startTime = clock();
    while (t--) {
        Solve();
    }
    int endTime = clock();
    dout << '\n' << "Time: " << (endTime - startTime + 999) / 1000;
    return 0;
}