﻿#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <set>
#include <algorithm>
#include <cassert>
#include <map>
#include <queue>
#include <bitset>
#include <iomanip>
#include <unordered_set>
#include <ctime>
#include <cassert>
#include <string>
#pragma GCC optimize("Ofast")
#define X first
#define Y second
#define double long double
#define int long long
#define pii pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define klunok int
using namespace std;
const int N = 1e6, alp = 26, Log = 17;
const double pi = abs(acos(-1)), eps = 1e-6, eps2 = 1e-9, inf = 1e30;
int mod = 1e9 + 7, mod2 = 1791791791;

struct line {
	double a, b, c;
};

struct point {
	double x, y;
};

double det(double a, double b, double c, double d) {
	return a * d - b * c;
}

bool parallel(line m, line n) {
	return abs(det(m.a, m.b, n.a, n.b)) < eps;
}

point inter(line m, line n) {
	point res;
	double zn = det(m.a, m.b, n.a, n.b);
	if (abs(zn) < eps)
		return {-inf, -inf};
	res.x = -det(m.c, m.b, n.c, n.b) / zn;
	res.y = -det(m.a, m.c, n.a, n.c) / zn;
	return res;
}

line line_by_point(point p, point q) {
	line res;
	res.a = p.y - q.y;
	res.b = q.x - p.x;
	res.c = -res.a * p.x - res.b * p.y;
	return res;
}

vvi dp;

int n, k;

int f(int n, int mn) {
	if (!n)
		return 1;
	if (dp[n][mn] != -1)
		return dp[n][mn];
	dp[n][mn] = 0;
	for (int i = mn; i <= k; ++i)
		dp[n][mn] += f(n - 1, i);
	return dp[n][mn];
}

vvi res;
vi curr;

void rec(int mn, int s) {
	if (!s)
		res.push_back(curr);
	for (int i = mn; i <= s; ++i) {
		curr.push_back(i);
		rec(i, s - i);
		curr.pop_back();
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL); cout.tie(NULL);
	cin >> n >> k;
	dp.assign(16, vi(k + 1, -1));
	rec(1, n);
	int ans = 0;
	for (auto x : res) {
		vi cnt(n + 1, 0);
		for (int y : x)
			cnt[y]++;
		int curr = 1;
		for (int i = 1; i <= n; ++i) {
			curr *= f(cnt[i], 1);
		}
		ans += curr;
	}
	cout << ans;
}