#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;


const int MAX_N = 2e5;
int a[MAX_N], b[MAX_N];


void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int mx_i = 0;
    for (int i = 1; i < n; ++i) {
        if (a[i] > a[mx_i] || (a[i] == a[mx_i] && b[i] > b[mx_i])) {
            mx_i = i;
        }
    }

    set <pair <int, int>> all_b, all_b_rev;
    for (int i = 0; i < n; ++i) {
        all_b.insert({b[i], i});
        all_b_rev.insert({i, b[i]});
    }
    for (int i = 0; i < n; ++i) {
        if (i == mx_i) {
            continue;
        }
        pair <int, int> rem;
        auto it = all_b_rev.lower_bound({i, 0});
        if (it != all_b_rev.end()) {
            rem = *it;
            all_b_rev.erase(rem);
            all_b.erase({rem.second, rem.first});
        } else {
            rem = {0, 0};
        }
        while (a[i] && !all_b.empty()) {
            int delta = min(a[i], all_b.rbegin()->first);
            a[i] -= delta;
            auto qwe = *all_b.rbegin();
            all_b.erase(qwe);
            all_b_rev.erase({qwe.second, qwe.first});
            if (qwe.first != delta) {
                qwe.first -= delta;
                all_b.insert(qwe);
                all_b_rev.insert({qwe.second, qwe.first});
            }
        }
        if (rem.second) {
            all_b.insert({rem.second, rem.first});
            all_b_rev.insert(rem);
        }
        if (a[i]) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}


int main() {
    srand(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now().time_since_epoch()).count());
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
