#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;


const int MAX_N = 20;
int dp[MAX_N];



void rec(int i1, int i2, int k) {
    if (i1 == 0 && k == 0) {
        ++dp[i2];
        return;
    }

    for (int j = 1; j <= i1; ++j) {
        rec(i1 - j, i2, k - 1);
    }
}


vector <vector <int>> q;
vector <int> cur;

void rec1(int n, int last = 1) {
    if (!n) {
        q.push_back(cur);
        return;
    }

    for (int i = last; i <= n; ++i) {
        cur.push_back(i);
        rec1(n - i, i);
        cur.pop_back();
    }
}


void solve() {
    int n, k;
    cin >> n >> k;

    for (int i = 0; i < MAX_N; ++i) {
        rec(i, i, k);
    }

    ll ans = 0;

    rec1(n);
    for (auto x: q) {
        map <int, int> k;
        for (auto e: x) {
            ++k[e];
        }
        for (auto & e: k) {
            e.second = dp[e.second];
        }
        ll cur = 1;
        for (auto & e : k) {
            cur *= e.second;
        }
        ans += cur;
    }
    cout << ans;
}



int main() {
    srand(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now().time_since_epoch()).count());
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
