#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

/*int binpow(int a, int n, int MOD) {
    if(n == 0) return 1;
    if(n % 2 == 0) return binpow(a * a % MOD, n / 2);
    return a * binpow(a, n - 1) % MOD;
}

int binpow(int a, int n) {
    if(n == 0) return 1;
    if(n % 2 == 0) return binpow(a * a, n / 2);
    return a * binpow(a, n - 1);
}

int obr(int a, int MOD) {
    return binpow(a, MOD - 2);
}

int mlt(int a, int b, int MOD) {
    return a * b % MOD;
}

int div(int a, int b, int MOD) {
    return a * obr(b) % MOD;
}

int add(int a, int b, int MOD) {
    return (a + b) % MOD;
}

int sub(int a, int b, int MOD) {
    return (a - b + MOD) % MOD;
}

const int F_SIZE = 100;

int fact[F_SIZE];

int fm(int n, int MOD) {
    if(n == 0) return 1;
    if(n >= F_SIZE) return -1;
    if(fact[n] != 0) return fact[n];
    fact[n] = mlt(f(n - 1), n, MOD);
    return fact[n];
}

int f(int n) {
    if(n == 0) return 1;
    if(n >= F_SIZE) return -1;
    if(fact[n] != 0) return fact[n];
    fact[n] = f(n - 1) * n;
    return fact[n];
}*/

struct Event {
    int val;
    int t;

    Event(int t, int val) : t(t), val(val) {}

    bool operator< (const Event &rsh) const {
        return tie(val, rsh.t) < tie(rsh.val, t);
    }
};

int32_t main() {
    
    int n, m ,s;
    cin >> n >> m >> s;

    vector<int> val(m);
    vector<Event> ev;

    set<int> was;

    for(int i = 0;i < m;i++) cin >> val[i];
    for(int i = 0;i < m;i++) {
        if(was.count(val[i]) == 1) continue;
        was.insert(val[i]);
        int l = max(1, val[i] - m + 1);
        int r = val[i];
        ev.emplace_back(1, l);
        ev.emplace_back(-1, r);
    }
    sort(ev.begin(), ev.end());

    int j = -1;
    int bal = 0;
    int ans = 0;
    for(int i = 0;i < ev.size();i++) {
        if(ev[i].t == 1) {
            if(bal == 0) j = i;
            bal++;
        } else if(ev[i].t == -1) {
            if(bal + s >= m) {
                if(ev[j].t == -1) {
                    ans += ev[i].val - ev[j].val;
                } else {
                    ans += ev[i].val - ev[j].val + 1;
                }
                j = i;
            }
            bal--;
            if(bal == 0) j = -1;
            else if(j != i) {
                do {
                    j++;
                } while(j < ev.size() && ev[j].t == -1);
            }
        }
    }
    cout << ans;

    return 0;
}