#include <bits/stdc++.h>
using namespace std;
template<typename t> inline void umin(t &a, const t b) {a = min(a, b);}
template<typename t> inline void umax(t &a, const t b) {a = max(a, b);}
typedef pair<int, int> pii;
typedef long long ll;
#define ft first
#define sd second
#define _ <<' '<<
#define len(f) int((f).size())

const int N = 1005;

char mp[N][N];
int n, m, k;
char ans[N][N];

list<int> g[N * N];

bool valid(int i, int j) {
    if(min(i, j) < 0) return false;
    if(i >= n || j >= m) return false;
    return mp[i][j] == '.';
}

struct sofa {
    pii a, b, c, d;
};

vector<sofa> s;

bool valid(pii f) {return valid(f.ft, f.sd);}

map<pii, list<int> > mk;

void edge(int i, int j) {
    g[i].push_back(i);
    g[j].push_back(j);
}

void add(pii a, pii b, pii c, pii d) {
    int i = k++;
    set<int> nei;
    for(int j : mk[c]) {
        edge(i, j);
        nei.insert(j);
    }
    for(int j : mk[d]) {
        if(nei.find(j) != nei.end()) continue;
        edge(i, j);
    }
    mk[c].push_back(i);
    mk[d].push_back(i);
    s.push_back({a, b, c, d});
}

bool visited[N * N];
bool active[N * N];

vector<list<pii> > e;

void rec(int v, int c) {
    visited[v] = true;
    if(!c) {
        for(int u : g[v]) if(active[u]) return;
        active[v] = true;
    }
    for(int u : g[v]) if(!visited[u]) rec(u, c ^ 1);
}

int link[N][N];

int main() {
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) cin >> mp[i][j];
    }
    for(int i = 0; i < n; ++i) {
        for(int j = 1; j < m ;++j) {
            if(mp[i][j] == '.') continue;
            if(mp[i][j - 1] != mp[i][j]) continue;
            if(mp[i][j] >= 'a') {
                pii p0 = {i, j};
                pii p1 = {i, j - 1};
                pii p2 = {i - 1, j};
                pii p3 = {i - 1, j - 1};
                if(valid(p2) && valid(p3))
                    add(p0, p1, p2, p3);
            } else {
                pii p0 = {i, j};
                pii p1 = {i, j - 1};
                pii p2 = {i + 1, j};
                pii p3 = {i + 1, j - 1};
                if(valid(p2) && valid(p3))
                    add(p0, p1, p2, p3);
            }
        }
    }
    for(int i = 1; i < n; ++i) {
        for(int j = 0; j < m ;++j) {
            if(mp[i][j] == '.') continue;
            if(mp[i - 1][j] != mp[i][j]) continue;
            if(mp[i][j] >= 'a') {
                pii p0 = {i, j};
                pii p1 = {i - 1, j};
                pii p2 = {i - 1, j - 1};
                pii p3 = {i, j - 1};
                if(valid(p2) && valid(p3))
                    add(p0, p1, p2, p3);
            } else {
                pii p0 = {i, j};
                pii p1 = {i, j - 1};
                pii p2 = {i - 1, j + 1};
                pii p3 = {i, j + 1};
                if(valid(p2) && valid(p3))
                    add(p0, p1, p2, p3);
            }
        }
    }
    for(int i = 0; i < k; ++i)
        if(len(g[i]) == 1 && !visited[i]) rec(i, 0);
    for(int i = 0; i < k; ++i)
        if(!visited[i]) rec(i, 0);
    #define forr for(int i = 0; i < n; ++i) for(int j = 0; j < m; ++j)
    forr ans[i][j] = '.', link[i][j] = -1;
    for(int i = 0; i < k; ++i) {
        if(active[i]) {
            link[s[i].a.ft][s[i].a.sd] = len(e);
            link[s[i].b.ft][s[i].b.sd] = len(e);
            link[s[i].c.ft][s[i].c.sd] = len(e);
            link[s[i].d.ft][s[i].d.sd] = len(e);
            e.push_back({s[i].a, s[i].b, s[i].c, s[i].d});
        } else {
            link[s[i].a.ft][s[i].a.sd] = len(e);
            link[s[i].b.ft][s[i].b.sd] = len(e);
            e.push_back({s[i].a, s[i].b});
        }
    }
    forr {
        if(mp[i][j] == '.') continue;
        if(link[i][j] >= 0) continue;
        if(i + 1 < n && mp[i + 1][j] == mp[i][j]) {
            link[i][j] = link[i + 1][j] = len(e);
            e.push_back({pii(i, j), pii(i + 1, j)});
        }
        if(j + 1 < m && mp[i][j + 1] == mp[i][j]) {
            link[i][j] = link[i][j + 1] = len(e);
            e.push_back({pii(i, j), pii(i, j + 1)});
        }
    }
    set<int> ready;
    forr {
        if(mp[i][j] == '.') continue;
        if(ready.count(link[i][j])) continue;
        auto &E = e[link[i][j]];
        set<int> used;
        for(auto &c : E) {
            for(pii cc : initializer_list<pii> {{i - 1, j + 1}, {i - 1, j}, {i, j - 1}, {i + 1, j - 1}}) {
                if(cc.ft >= 0 && cc.sd >= 0) {
                    if(ans[cc.ft][cc.sd] != '.') {
                        if(abs(cc.ft - c.ft) + abs(cc.sd - c.sd) <= 1) {
                            used.insert(ans[cc.ft][cc.sd] - '0');
                        }
                    }
                }
            }
        }
        int v;
        for(v = 0; used.count(v); ++v);
        for(auto &c : E) {
            ans[c.ft][c.sd] = '0' + v;
        }
        ready.insert(link[i][j]);
    }
    for(int i = 0; i < n; ++i, cout << endl)
        for(int j = 0; j < m; ++j) cout << ans[i][j];
}
