#include<bits/stdc++.h>

using namespace std;
//#define int long long
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1;//(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

char field[1009][1009];
vector<int> g[1009 * 1009];
int n, m;

void razl(int x, int y) {

}

inline int getnum(int x, int y) {
    return (x-1) * m + (y-1);
}

inline pii getback(int x) {
    return {x / m + 1, x % m + 1};
}

pair<pii, pii> sognut(int x, int y) {
    if (field[x][y] >= 'A' && field[x][y] <= 'Z') {
        if (field[x + 1][y] == field[x][y]) {
            return {{x, y + 1}, {x + 1, y + 1}};
        }

        else {
            return {{x + 1, y}, {x + 1, y + 1}};
        }
    }

    else {
        if (field[x + 1][y] == field[x][y]) {
            return {{x, y - 1}, {x + 1, y - 1}};
        }

        else {
            return {{x - 1, y}, {x - 1, y + 1}};
        }
    }
}

void add_edge(int a, int b) {
    auto a1 = getback(a), b1 = getback(b);
    auto x1 = a1.x, y1 = a1.y, x2 = b1.x, y2 = b1.y;
    auto ret1 = sognut(x1, y1), ret2 = sognut(x2, y2);
    if (ret1.x == ret2.x || ret1.y == ret2.x || ret1.x == ret2.y || ret1.y == ret2.y) {
        g[a].push_back(b);
        g[b].push_back(a);
    }
}

char answ[1009][1009];
vector<pii> des = {{0, -1}, {-1, 0}, {1, -1}, {-1, 1}, {0, 2}, {2, 0}, {2, 1}, {1, 2}};

bool inf(int x, int y) {
    return (x >= 1 && y >= 1 && x <= n && y <= m);
}

void sogn_answ(int x, int y) {
    auto ret = sognut(x, y);
    vector<bool> used(10);
    int x1, y1;
    if (field[x][y] == field[x + 1][y]) {
        x1 = x, y1 = min(ret.x.y, y);
    }

    else {
        x1 = min(ret.x.x, x), y1 = y;
    }

    for (auto d : des) {
        int i = x1 + d.x, j = y1 + d.y;
        //cout << i << ' ' << j << ' ' << answ[i][j] << endl;
        if (inf(i, j) && answ[i][j] >= '0' && answ[i][j] <= '9') {
            used[answ[i][j] - '0'] = 1;
        }
    }

    for (int k = 0; k < 10; k++) {
        if (!used[k]) {
            for (int i = x1;  i <= x1+1; i++) {
                for (int j = y1; j <= y1 + 1; j++) {
                    answ[i][j] = k + '0';
                }
            }

            break;
        }
    }
}

vector<pii> des2 = {{-1, 0}, {2, 0}, {0, -1}, {0, 1}, {1, -1}, {1, 1}, {1, 0}, {0, 2}, {-1, 1}};
void ne_answ(int x, int y) {
    vector<bool> used(10);
    int x1, y1;
    x1 = x, y1 = y;

    //cout << x << ' ' << y <<":" << endl;
    for (auto d : des2) {
        int i = x1 + d.x, j = y1 + d.y;
       // cout << i << ' ' << j << endl;
        if (inf(i, j) && answ[i][j] >= '0' && answ[i][j] <= '9') {
            used[answ[i][j] - '0'] = 1;
        }
    }

    //cout << x << ' ' << y << endl;

    for (int k = 0; k < 10; k++) {
        if (!used[k]) {
            for (int i = x1;  i <= x1+1; i++) {
                for (int j = y1; j <= y1 + 1; j++) {
                    if (field[i][j] == field[x][y])
                        answ[i][j] = k + '0';
                }
            }

            break;
        }
    }
}

char useddiv[1009][1009];
vector<int> topoint[1009][1009];
bool toansw[1009][1009];

vector<int> way;
char used[1009 * 1009];

void dfs_way(int v) {
    way.push_back(v);
    used[v] = 2;
    for (auto u : g[v]) {
        if (used[u] == 2) continue;
        dfs_way(u);
    }
}

int dfs_leaf(int v) {
    used[v] = 1;
    if (g[v].size() <= 1) {
        return v;
    }

    for (auto u : g[v]) {
        if (used[u] == 0) {
            auto ret = dfs_leaf(u);
            if (ret != -1) return ret;
        }
    }

    return -1;
}

main() {
#ifdef karpovich
    freopen("input.txt", "r", stdin);
#endif // karpovich
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 1;  i <= n; i ++) {
        for (int j = 1; j <= m; j ++) {
            cin >> field[i][j];
            answ[i][j] = field[i][j];
        }
    }

    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= m; j ++) {
            if (field[i][j] != '.' && !useddiv[i][j]) {
                auto ret = sognut(i, j);

                if (field[i + 1][j] == field[i][j]) {
                    useddiv[i + 1][j] = 1;
                }

                else {
                    useddiv[i][j + 1] = 1;
                }

                vector<pii> ao;
                ao.push_back(ret.x);
                ao.push_back(ret.y);
                for (auto u : ao) {
                    if (!inf(u.x, u.y) || field[u.x][u.y] != '.') {
                        useddiv[i][j] = 2;
                    }
                }

                if (useddiv[i][j] == 0) {
                    for (auto u : ao) {
                        if (inf(u.x, u.y)) {
                            topoint[u.x][u.y].push_back(getnum(i, j));
                        }
                    }
                }
            }
        }
    }

    for (int i = 1; i<= n; i++) {
        for (int j = 1; j <= m; j ++) {
            for (int k = 0; k < topoint[i][j].size(); k++) {
                for (int u = k + 1; u < topoint[i][j].size(); u++) {
                    add_edge(topoint[i][j][k], topoint[i][j][u]);
                }
            }
        }
    }

    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= m; j ++) {
            if (!useddiv[i][j] && field[i][j] != '.') {
                int x = getnum(i, j);
                if (!used[x]) {
                    auto l = dfs_leaf(x);
                    if (l == -1) l = x;
                    dfs_way(l);

                    for (int t = 0; t < way.size(); t+=2) {
                        auto p = getback(way[t]);
                        toansw[p.x][p.y] = 1;
                    }

                    way.clear();
                }
            }
        }
    }

    int cnt = 0;

    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j<= m; j++) {
            if (toansw[i][j]) {
                sogn_answ(i, j);
                cnt++;
            }

            else if (!useddiv[i][j] && field[i][j] != '.') {
               ne_answ(i,j);
            }

            else if (useddiv[i][j] == 2) {
                ne_answ(i,j);
            }
        }
    }

    cout << cnt << "\n";
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cout << answ[i][j];
        }
        cout << "\n";
    }

    return 0;
}

