#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define pb push_back

const int N = 5e5 + 10;

int k, parent[N], sz[N], res[N];
vector <int> g[N];

int find_set(int a) {
	return (parent[a] == a ? a : parent[a] = find_set(parent[a]));
}

void unite_sets(int a, int b) {
	int za = a, zb = b;
	a = find_set(a);
	b = find_set(b);
	if (a != b) {
		if (sz[a] < sz[b]) swap(a, b);
		sz[a] += sz[b];
		parent[b] = a;
		g[za].pb(zb);
		g[zb].pb(za);
	}
}

void dfs(int v, int p = -1) {
	for (auto to : g[v]) {
		if (to == p) continue;
		res[to] = res[v] + 1;
		if (res[to] > k) res[to] -= k;
		dfs(to, v);
	}
}

int main()
{

//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	int n, m;
	cin >> n >> m >> k;
	for (int i = 0; i < n; i++) {
		int c;
		cin >> c;
		parent[i] = i;
		sz[i] = 1;
	}
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x --;
		y --;
		unite_sets(x, y);
	}
	res[0] = 1;
	dfs(0);
	for (int i = 0; i < n; i++) cout << res[i] << " ";
	cout << endl;
}
