#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("-O3")
//#pragma GCC optimize("-O2")
//#pragma GCC optimize("-O1")
//#pragma GCC optimize("-Os")
//#pragma GCC optimize("-s")
//#pragma GCC optimize("-O")
//#pragma GCC target("avx")

#define ll long long
#define ld long double
#define int ll
#define all(x) (x).begin(),(x).end()
#define F first
#define S second
#define pb push_back
#define pf push_front
#define endl '\n'
#define TIME 1.0*clock()/CLOCKS_PER_SEC
#define pii pair<int, int>
#define TIP pair<int, int>
#define ve vector<ll>
#define veve vector<ve>
#define ordF find_by_order
#define ordM order_of_key

typedef tree<TIP, null_type, less<TIP>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

const int N = 1100;
const int M = 2000;
const int INF = 1e18;
const int inf = 1e18;
const int MOD = 1e9 + 7;
mt19937_64 gen(time(0));
struct edge{
int from, to, flow, maxflow, cost;
edge(int a, int b, int c, int d, int e){
    from = a;
    to = b;
    flow = c;
    maxflow = d;
    cost = e;
}
edge();
};
vector < int > g[N];
vector < edge > e;
int id = 0;
void add_edge(int from, int to, int cost, int mx){
    e.pb({from, to, 0, mx, cost});
    g[from].pb(id);
    id++;
    e.pb({to, from, 0, 0, -cost});
    g[to].pb(from);
    id++;
}
int s = 0;
int k = 0;
int f = N;
int ans = 0;
bool ford_bellman(){
//    cerr << 1 <<"\n";
    vector < int > d(N, inf);
    d[s] = 0;
    vector < int > pr(N, -1);
    bool flag = 1;
    while(flag){
            flag = 0;
        for(int i = 0;i < id; i++){
            if(e[i].maxflow - e[i].flow > 0 && d[e[i].from] < inf && d[e[i].to] > d[e[i].from] + e[i].cost){
                d[e[i].to] = d[e[i].from] + e[i].cost;
                pr[e[i].to] = i;
                flag = 1;
            }
        }
    }
    if(d[f] == inf){
        return 0;
    }
    int v =  f;
    while(v != s){
//            cerr << v << "\n";
        e[pr[v]].flow++;
        e[pr[v] ^ 1].flow--;
        ans+=e[pr[v]].cost;
        v = e[pr[v]].from;
    }
            k++;
    return 1;
}
main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    cout.precision(10);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//    freopen("INPUT.TXT", "r", stdin);
//    freopen("OUTPUT.TXT", "w", stdout);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    ll n;
    cin >> n;
    vector< int > a(n);
    for(int i = 0;i < n; i++)
        cin >> a[i];
    vector < int > pref(n, 0);
    for(int i = 0;i < n - 1; i++)
        pref[i + 1] = pref[i] + a[i];

    ll kol = 0;
    kol = pref[n - 1] + a[n - 1];
    if(kol % 2 == 1){
        cout << -1;
        return 0;
    }
    for(int i = 1; i <= kol; i++){
        add_edge(0, i, 0, 1);
    }
    int c[n][n];
    for(int i = 0;i < n; i++)
        for(int j = 0; j < n; j++)
        cin >> c[i][j];
    for(int i = 0;i < n; i++){
        for(int j = 0;j < a[i]; j++){
            for(int i1 = 0; i1 < n; i1++){
                for(int j1 = 0; j1 < a[i1]; j1++){
                    add_edge(pref[i] + j + 1, kol + pref[i1] + j1 + 1, c[i][i1], 1);
                }
            }
        }
    }
    f = N - 1;
    for(int i = 1; i <=kol; i++){
        add_edge(i + kol , f, 0, 1);
    }
    s = 0;

    while(ford_bellman());
    cout << ans / 2;
    return 0;
}
