#include <iostream>
#include <iomanip>
#include <string>
#include <algorithm>

using namespace std;

int pw2(int x) {
	return (1 << x);
}

string toBinary(int m) {
	string r;
	r = "";
	while (m > 0) {
		r += (char)('0' + m % 2);
		m /= 2;
	}
	reverse(r.begin(), r.end());
	return r;
}

int main() {

	int n;
	cin >> n;

	int mx_len = (1 << n);

	for (int i = n; i >= 1; i--) {
		int curr_len = (1 << i);
		if (curr_len > 30) continue;
		int g = (1 << curr_len);
		int r = mx_len / curr_len;
		if (g <= r) {
			int maxn = pw2(curr_len);
			for (int m = 0; m < maxn; m++)
				cout << setw(curr_len) << setfill('0') << toBinary(m);
			break;
		}
	}


 	return 0;
}