#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("O3")
#pragma GCC target ("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set =
tree<T, null_type, less<T>, rb_tree_tag, 
tree_order_statistics_node_update>;

typedef long long ll;

const int N = 4e5;

int n, m, s, a[N], p[N], u[N];

int get(int x) {
	int l = 0, r = m + s;
	while (l + 1 < r) {
		int mid = (l + r) / 2;
		if (a[mid] >= x) r = mid;
		else l = mid;
	}
	return r;
} 

int main() {
  	ios_base::sync_with_stdio(0);
  	cin.tie(0); cout.tie(0);
  	//freopen(".in", "r", stdin);
  	//freopen(".out", "w", stdout);     
  	cin >> n >> m >> s;
  	for (int i = 1; i <= m; i++) {
  		cin >> a[i];
  	}
  	sort(a + 1, a + 1 + m);
 	for (int i = m + 1; i <= m + s; i++) a[i] = a[m] + (i - m);
  	for (int i = 1; i <= m + s; i++) {
  		p[i] = p[i - 1] + a[i] - a[i - 1] - 1;
  		u[i] = u[i - 1];
  		if (a[i] != a[i - 1]) u[i]++;
  	}
  	int ans = 0;
  	for (int i = 1; i <= m + s; i++) {
  		int l = get(a[i] - m + 1) - 1;
  		if (u[i] - u[l - 1] + s >= m && p[i] - p[l - 1] <= s) 
  			ans++;
  	}
  	cout << ans;
  	return 0;
}