//
//  main.cpp
//  torelax
//
//  Created by Rakhman on 11/15/20.
//

#include <cstring>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <queue>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <iterator>

#define ios ios_base::sync_with_stdio(0), cout.tie(0), cin.tie(0);
#define S second
#define F first
#define pb push_back
#define nl '\n'
#define NL cout << '\n';
#define EX exit(0)
#define all(s) s.begin(), s.end()
#define no_answer {cout << "NO"; exit(0);}
#define FOR(i, start, finish, k) for(llong i = start; i <= finish; i += k)

const long long MXN = 1e6 + 110;
const long long MNN = 1e2 + 1;
const long long MOD = 1e9 + 7;
const long long INF = 1e18;
const long long OO = 1e9;

typedef long long llong;
typedef unsigned long long ullong;

using namespace std;

llong n, s, b[MXN], M, m, c[MXN];
llong sum;

llong get_sum(llong pos, llong right){
    llong l = pos, r = m;
    while(r - l > 1){
        llong mid = (l + r) / 2;
        if(b[mid] > right){
            r = mid;
        }else{
            l = mid;
        }
    }
    if(b[r] <= right) return r;
    else return l;
}

int main() {
    cin >> n >> M >> s;
    for(llong i = 1; i <= M; i++){
        cin >> c[i];
    }
    sort(c + 1, c + M + 1);
    llong kinomo = 2;
    b[1] = c[1];
    for(llong i = 2; i <= M; i++){
        if(c[i] == b[kinomo - 1]){
            continue;
        }else{
            b[kinomo] = c[i];
            kinomo++;
        }
    }
    m = kinomo - 1;
    for(llong i = 1; i <= m; i++){
        llong r = get_sum(i, b[i] + M - 1);
        cout << i << ' ' << b[i] << ' ' << r << nl;
        if(M - (r - i + 1) > s){
            continue;
        }else{
            if(b[i] == 1){
                if(b[i] + M - 1 <= n) sum++;
                else break;
                continue;
            }
            llong left = b[i - 1] + 1;
            llong right = b[i];
            while(right - left > 1){
                llong mid = (right + left) / 2;
                if(M - (get_sum(i, mid + M - 1) - i + 1) > s){
                    left = mid;
                }else{
                    right = mid;
                }
            }
            llong ans = -1;
            if(M - (get_sum(i, left + M - 1) - i + 1) <= s){
                ans = left;
            }else{
                ans = right;
            }
            if(b[i] + M - 1 <= n) {
                sum += b[i] - ans + 1;
            }else{
                llong left = n - M + 1;
                if(ans <= left) sum += left - ans + 1;
                break;
            }
        }
    }
    cout << sum;
}

/*
10 5 2
7 1 3 5 6

11 6 2
5 5 5 5 5 5

restricting n
deleting copies
*/
