/*
#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")
ordered_set -> less -> less_equal
ordered_set find_by_order(k) -> k element
ordered_set order_of_key(k) -> returns the number of elements in a set strictly smaller than k
*/
#include <bits/stdc++.h>
#include <random>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T> using ordered_set=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const long long maxn = 3e5 + 123;
const long long inf = 1e9 + 123;
const long long linf = 1e18 + 123;
const long long mod = 1e9 + 7;
const double eps = 1e-9;
const double pi = acos(-1);
int dx[8] = {0, 1, -1, 0, 1, -1, 1, -1};
int dy[8] = {1, 0, 0, -1, 1, 1, -1, -1};

long long n, k, ans, sz[100];

/*void rec(int sum = 0, int cur = 1){
	if (sum > n){
		return;
	}
	if (cur > k){
		return;
	}
	cout << sum << " " << cur << "\n";
	if (sum == n){
		ans++;
		return;
	}
	for (int i = 0; i < (1 << n); i++){
		int sum1 = sum;
		for (int j = 0; j < n; j++){
			if (i & (1 << j)){
				sum1 += j + 1;
			}
		}
		rec(sum1, cur + 1);
	}
}*/

void rec(long long sum = n, long long cntr = 1, long long m = n){
	if (sum == 0){
		ans += cntr;
		return;
	}
	if (m == 0){
		return;
	}
	for (int i = 0; i <= sum / m; i++){
		rec(sum - i * m, cntr * sz[i], m - 1);
	}
}
int main(){
    //freopen("input.cpp", "r", stdin);
   	//freopen("output.cpp", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    sz[0] = 1;
    for (int i = 1; i <= n; i++){
    	int x = 1, ANS = 0;
    	for (int j = 1; j <= i + 1; j++){
    		ANS += x;
    		x += (k - 2);
    	}
    	sz[i] = ANS;
    }
    rec();
    cout << ans;
    exit(0);
}
