#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <unordered_map>
#include <vector>
#include <algorithm>
#include <stack>
#include <map>
#include <string>
#include <math.h>
#include <cassert>
using namespace std;

#define ALL(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
#ifdef QWERTY
#define db(x) cerr <<#x << " = " << x << endl
#else
#define db(x) 42;
#endif

typedef long long ll;

#define N 200200

int n, k;
ll ans = 0;
ll pw[N];
int cnt[20];

ll C[50][50];

void rec(int idx, int sum, ll cur) {
	if (sum == n) {
		ans += cur;
		return;
	}	

	if (idx == n + 1) return;

	for (int i = 0; i <= (n - sum) / idx; i++) {
		cnt[idx] = i;
		rec(idx + 1, sum + i * idx, cur * C[i + k - 1][k - 1]);
	}

}

void solve(int TC) {
	cin >> n >> k;
	pw[0] = 1;
	for (int i = 1; i <= n; i++) pw[i] = pw[i - 1] * k;


	for (int i = 0; i <= 40; i++) {
		C[i][0] = 1;
		for (int j = 1; j <= 40; j++) {
			if (i < j) {
				C[i][j] = 0;
			} else C[i][j] = C[i - 1][j - 1] + C[i - 1][j];
		}
	}


	rec(1, 0, 1);

	cout << ans;

}

int main() {
#ifdef QWERTY
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
#endif 
	int TC = 1;
	//cin >> TC;


	for (int i = 1; i <= TC; i++)
		solve(i);


	return 0;
}