#include <algorithm>
#include <iostream>
#include <iomanip>
#include <utility>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <stack>
#include <cmath>
#include <set>

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(),(a).end() 
#define vint vector<int>
#define vlint vector<lli>
#define vchar vector<char>
#define vbool vector<bool>
#define vfloat vector<float>
#define vdouble vector<double>
#define vvint vector<vint>
#define vvlint vector<vlint>
#define vvbool vector<vbool>
#define pii pair<int,int> 
#define pch pair<char,int>
#define plii pair<lli,lli>
#define vpii vector<pii>
#define vplii vector<plii>

#define fastio ios::sync_with_stdio(false); cin.tie(0);
typedef long long int lli;

using namespace std;
//bool parz[100000];
const long long  ooll = 9223372036854775807;  //2^63-1
const int ooi = 2147483647;   //2^31-1
const lli mod = 1000 * 1000 * 1000 + 7;
const lli modl = 998244353;
const int N = 200 * 1000;
lli fibonach[N];


static int chiamate = 0;
static string str;
static vector<string> sub;

lli gcd(lli a, lli b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

lli lcm(lli a, lli b)
{
	return (a * b) / gcd(a, b);
}

lli tvpr(lli n, lli k)
{
	return ((2 + (n - 1) * k) / 2) * n;
}

lli tvprn(lli n)
{
	return (n * (n + 1)) / 2;
}


vbool eratb(int n)
{
	int i, k;
	vbool parz(n + 1);
	for (i = 0; i <= n; i++)
	{
		parz[i] = 1;
	}

	for (i = 2; i <= n; i++)
	{
		if (parz[i])
		{
			for (k = 2 * i; k <= n; k += i)
			{
				parz[k] = 0;
			}
		}
	}
	return parz;
}

vint erati(int N)
{
	vbool parz = eratb(N);
	vint res;
	for (int i = 2; i <= N; i++)
	{
		if (parz[i])
		{
			res.push_back(i);
		}
	}
	return res;
}
bool parzcheck(int n)
{
	int i;
	for (i = 2; i <= sqrt(n); i++)
	{
		if (n % i == 0)
			return false;
	}
	return true;
}



bool ifnum(char a)
{
	if (a >= '0' && a <= '9')
	{
		return true;
	}
	else
	{
		return false;
	}
}

void fibon()
{
	int i;
	fibonach[0] = 1;
	fibonach[1] = 1;
	fibonach[2] = 2;
	for (i = 3; i <= 100000; i++)
	{
		fibonach[i] = 1LL * (fibonach[i - 1] + fibonach[i - 2]);
		fibonach[i] %= mod;
	}
}

string pox(int n)
{
	lli k = 1;
	string ans = "";
	while (k * 2 <= n)
	{
		k *= 2;
	}
	while (k >= 1)
	{
		if (k <= n)
		{
			ans += "1";
			n -= k;
		}
		else
		{
			ans += "0";
		}
		k /= 2;
	}
	return ans;
}

int hetpox(string s)
{
	int i, ans = 0;

	for (i = 0; i < s.length(); i++)
	{
		if (s[s.length() - 1 - i] == '1')
		{
			ans += int(pow(2, i));
		}
	}
	return ans;
}
lli LL(int n)
{
	return 1LL * n;
}
int btum(string a, string b)
{
	string anss = "";
	int ans = 0, i, j, k;
	if (a.length() < b.length())
	{
		swap(a, b);
	}
	for (i = a.length() - 1, j = b.length() - 1, k = 0; i >= 0 && j >= 0; i--, j--, k++)
		if (a[i] == '1' && b[j] == '0' || a[i] == '0' && b[j] == '1')
		{

			ans += int(pow(2, k));
			//cout << ans << endl;
		}
	for (j = a.length() - b.length() - 1; j >= 0; j--, k++)
	{
		if (a[j] == '1')
		{
			//cout << "x";
			ans += int(pow(2, k));
		}
	}
	return ans;
}



int digsum(lli n)
{
	int sum = 0;
	while (n != 0)
	{
		sum += n % 10;
		n /= 10;
	}
	return sum;
}

lli fact(int n)
{
	lli qan = 1, i;
	for (i = 2; i <= n; i++)
	{
		qan *= i;
	}
	return qan;
}

lli C(int n, int m)
{
	if (n == m)
	{
		return 1;
	}
	else
	{
		return fact(n) / (fact(m) * fact(n - m));
	}
}

void floid_varshal(int n, int d[100][100])
{
	for (int k = 1; k <= n; k++)
	{
		for (int i = 1; i <= n; i++)
		{
			for (int j = 1; j <= n; j++)
			{
				d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
			}
		}
	}
}
void test()
{
	cout << "\n---------------------------------------------------------\n";
}
int dp[1000001] = { -1 };
struct segtree {
	vlint tree;
	int size;
	void init(int n)
	{
		size = 1;
		while (size < n)
		{
			size *= 2;
		}
		tree.assign(size * 2 - 1, 0);
	}

	void set(int i, int v)
	{
		int ind = size - 1 + (i - 1);
		tree[ind] = v;
		ind--;
		ind /= 2;
		while (ind > 0)
		{
			tree[ind] = tree[ind * 2 + 1] + tree[ind * 2 + 2];
			ind--;
			ind /= 2;
		}
		tree[ind] = tree[ind * 2 + 1] + tree[ind * 2 + 2];
	}

	void sum(int l, int r)
	{

	}
	void show()
	{
		int k = 1, i, cnt = 0;
		for (i = 0; i < 2 * size - 1; i++)
		{
			cout << tree[i] << " ";
			cnt++;
			if (cnt == k)
			{
				cout << endl;
				k *= 2;
				cnt = 0;
			}
		}
	}
};
int CeilIndex(std::vector<int>& v, int l, int r, int key)
{
	while (r - l > 1) {
		int m = l + (r - l) / 2;
		if (v[m] > key)
			r = m;
		else
			l = m;
	}

	return r;
}
vector<int> tail;
int _LIS(vint& v)
{
	if (v.size() == 0)
		return 0;

	tail.resize(v.size());
	int ans = 1;

	tail[0] = v[0];
	for (size_t i = 1; i < v.size(); i++) {
		if (v[i] <= tail[0])
			tail[0] = v[i];
		else if (v[i] > tail[ans - 1])
			tail[ans++] = v[i];
		else
			tail[CeilIndex(tail, -1, ans - 1, v[i])] = v[i];
	}
	int i;
	for (i = 0; i < ans; i++)
	{
		cout << tail[i] << " ";
	}
	cout << endl;
	return ans;
}
void solve()
{
	double x;
	cin >> x;
	double ans = 25 + x / 100;
	if (ans > 2000)
	{
		ans = 2000;
	}
	else if (ans<100)
	{
		ans = 100;
	}
	cout << ans;
	if (int(x) % 100 == 0)
	{
		cout <<'.'<< 0 << 0;
	}
	else if (int(x) % 10 == 0)
	{
		cout << 0;
	}
}
int main() {
	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}
	return 0;
}