#pragma GCC optimize("O3")
#pragma unroll(2)
#include <bits/stdc++.h>
using namespace std;

#define DIM 1000009
#define INF ((long long)1e18+9ll)
#define fast ios_base::sync_with_stdio(false),cin.tie(0),cout.tie(0)
#define amen exit(0)
#define endl '\n'

long long i,j,k,l,n,m,s,res;

long long vis[DIM],finish,start,sz;

struct edge{
    long long v1,v2,cap,flow;
};

vector<edge>e;

vector<long long>a[DIM];

bool bfs(){
    for(int i=1;i<=sz;i++)vis[i]=0;

    vis[start]=1;

    queue<long long>q;

    q.push(start);

    while(!q.empty()){
        long long v=q.front();
        q.pop();

        for(auto to:a[v]){
            if(e[to].cap-e[to].flow>0 && vis[e[to].v2]==0){
                q.push(e[to].v2);
                vis[e[to].v2]=vis[v]+1;
            }
        }
    }
    return vis[finish]>0;
}

long long ptr[DIM];

long long dfs(long long v,long long flow){
    if(flow<=0)return 0;
    if(v==finish)return flow;

    for(;ptr[v]<a[v].size();){
        long long num=a[v][ptr[v]++];

        if(vis[e[num].v2]!=vis[v]+1 || e[num].cap-e[num].flow<=0)continue;

        long long k=dfs(e[num].v2,min(flow,e[num].cap-e[num].flow));

        if(k>0){
            e[num].flow+=k;
            e[num^1].flow-=k;
            return k;
        }
    }
    return  0;
}

long long dinic(){
    long long res=0;
    while(bfs()){
        for(int i=1;i<=sz;i++)ptr[i]=0;
        while(long long pushed=dfs(start,INF)){
            res+=pushed;
        }
    }
    return res;
}

long long mas1[DIM],mas2[DIM],pref[DIM],suff[DIM];

void addedge(long long v,long long u,long long cap){
    a[v].push_back(e.size());

    e.push_back({v,u,cap,0});

    a[u].push_back(e.size());

    e.push_back({u,v,0,0});
}

int main()
{
    fast;

    int nt;

    cin>>nt;
    while(nt--){
        cin>>n;

        long long summ=0,summ2=0;

        for(i=1;i<=n;i++)cin>>mas1[i],summ+=mas1[i];
        for(i=1;i<=n;i++)cin>>mas2[i],summ2+=mas2[i];

        long long pos=1,kilk=0;

        for(i=1;i<=n;i++){
            if(mas2[i]>summ-mas1[i]){
                pos=i;
                kilk++;
            }
        }
        if(kilk==0){
            pos=1;
            for(int i=2;i<=n;i++){
                if(mas2[i]>mas2[pos])pos=i;
                if(mas2[i]==mas2[pos] && mas1[i]>mas1[pos])pos=i;
            }
        }
        if(kilk>1){
            cout<<"NO"<<endl;
            continue;
        }

        pref[1]=++sz;
        for(int i=1;i<=n;i++){
            addedge(i,i+n,mas1[i]);
        }

        sz=2*n;
        pref[1]=++sz;

        addedge(1+n,pref[1],INF);

        long long sum=mas1[i];

        for(int i=2;i<=n;i++){
            pref[i]=++sz;
            addedge(pref[i-1],pref[i],INF);
            addedge(i+n,pref[i],INF);
        }

        suff[n]=++sz;
        addedge(2*n,suff[n],INF);

        for(int i=n-1;i>0;i--){
            suff[i]=++sz;
            addedge(suff[i+1],suff[i],INF);
            addedge(i+n,suff[i],INF);
        }

        for(int i=1;i<=n;i++){
            sz++;
            if(i-1>0)addedge(pref[i-1],sz,INF);
            if(i+1<=n)addedge(suff[i+1],sz,INF);
        }

        start=++sz;
        finish=++sz;

        for(i=1;i<=n;i++)addedge(start,i,INF);

        long long curr=sz-2,cnt=0;

        for(i=n;i>0;i--){
            if(pos!=i)addedge(curr,finish,mas2[i]),cnt+=mas2[i];
            curr--;
        }

        long long num=dinic();

        if(num==cnt)cout<<"YES"<<endl;
        else cout<<"NO"<<endl;

        for(i=1;i<=sz;i++)a[i].clear();

        e.clear();
    }

    amen;
}
