#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <bitset>
#include <fstream>

using namespace std;
using ll = long long;

ll const inf = 1e18;

ifstream fin("input.txt");
ofstream fout("output.txt");

signed main()
{
	ll t; cin >> t;
	while (t--)
	{
		ll n; cin >> n;
		vector<ll> a(n), b(n);
		ll sa = 0, sb = 0;
		for (ll i = 0; i < n; ++i)
		{
			cin >> a[i];
			sa += a[i];
		}
		for (ll i = 0; i < n; ++i)
		{
			cin >> b[i];
			sb += b[i];
		}

		if (sb - sa >= 2)
		{
			cout << "NO\n";
			continue;
		}
		else
		{
			ll ans = sb;

			for (ll i = 0; i < n; ++i)
			{
				ans -= (min(sb - b[i], a[i]));
			}

			if (ans >= 2)
				cout << "NO\n";
			else
				cout << "YES\n";
		}
	}




	return 0;
}