#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int L = 10e5;

int main()
{ 
    int max_card, table_number, hand, straight = 0, j = 0;
    cin >> max_card >> table_number >> hand;
    vector <int> arr(L);
    fill(arr.begin(), arr.end(), ++j);
    set <int> s;
    for (int i = 0; i < table_number; i++) {
        int temp;
        cin >> temp;
        s.insert(temp);
    }
    for (int i = 1; i < max_card - table_number + 1; i++) {
        int need_to_add = 0, out_of_hand = 0;
        for (int k = i; k < i + table_number; k++) {
            if(s.find(arr[k]) == s.end()){
                need_to_add++;
            }
            if (need_to_add > hand) {
                out_of_hand = 1;
                break;
            }
        }
        if (!out_of_hand) {
            straight += 1;
        }
    }
    cout << straight;
    return 0;
}