#include <iostream>
#include <vector>
#include <queue>


using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<int> gr [n];

    int sets[n][k];

    for (int i = 0; i < n; ++i) {
        for (int i2 = 0; i2 < k; ++i2) {
            sets[i][i2] = 0;
        }
    }

    int x;
    for (int i = 0; i < n; ++i) {
        cin >> x;
    }

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    int result[n];
    for (int i = 0; i < n; ++i) {
        result[i] = 0;
    }

    deque<int> q;
    q.push_back(0);
    result[0] = 1;

    for (int y: gr[0]) {
        sets[y][0] = 1;
    }

    while (q.size()) {
        int elem = q.front();
        q.pop_front();

        for (int y: gr[elem]) {
            if (result[y] == 0) {
                int slava = 0;
                for (int z = result[elem]; z < k; ++z) {
                    if (sets[y][z] == 0) {
                        slava = z;
                        break;
                    }
                    result[y] = slava + 1;
                    for (int iterator: gr[y]) {
                        sets[iterator][slava] = 1;
                    }
                    q.push_back(y);
                }
            }
        }
    }

    for (int x: result) {
        cout << x << " ";
    } 
}