#include <iostream>
#include <algorithm>
#include <cassert>

using namespace std;

typedef long long ll;

const int N = 2e5 + 10, INF = 2e9+10;

ll arr[N];

int main(){

    ll n, s, m;
    cin >> n >> m >> s;

    for (int i = 1; i <= m; i++) {
        cin >> arr[i];
    }
    arr[0] = 0;

    sort(arr, arr+m+1);
    ll k = m;
    auto it = unique(arr, arr+m+1);

    k = (int)(it - arr);

    ll ans = 0, last = 1;

    arr[k] = INF;
    for (int i = 1; i < k; i++) {

        while (arr[i] - arr[last] + 1 > m) {
            last++;
        }
        ll r = min(n, min(arr[last]+m-1, arr[i+1] - 1));
        ll l = min(n, max(arr[i] - m+1, arr[last-1]+1));
        if (r - l + 1 < m) {
            continue;
        } else {

            ll cost = m - (i - last + 1);
//            cout << i << "   " << l << " " << r << "   " << cost << endl;

            if (cost != 0 && cost <= s) {
                ans += r - (l + m-1) + 1;
            }
        }
    }
    for (last+=1; last < k; last++) {
        ll r = min(n, min(arr[last]+m-1, arr[k-1+1] - 1));
        ll l = min(n, max(arr[k-1] - m+1, arr[last-1]+1));
        if (r - l + 1 < m) {
            continue;
        } else {
            ll cost = m - (k-1 - last + 1);
//            cout << k-1 << "   " << l << " " << r << "  " << cost << endl;
            if (cost != 0 && cost <= s) {
                ans += r - (l + m-1) + 1;
            }
        }
    }
    cout << ans;

    return 0;
}