#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("O3", "Ofast", "unroll-loopps", "unswitch-loops", "fast-math", "no-stack-protector")

/*


 */

#define all(x) (x).begin(), (x).end()
#define size(x) (int)x.size()

typedef long long ll;

int n, m;
const int N = 1e3 + 5;

char c[N][N];

vector<pair<int, int>> g[N * N];

int used[N * N];

int tt = 1;

vector<int> vs;

void add(int a, int b, int c) {
    g[a].emplace_back(b, c);
    g[b].emplace_back(a, c);
}

pair<int, int> p[N * N];

bool dfs(int v) {
    if (used[v] == tt) return 0;
    used[v] = tt;
    for(auto to : g[v]) {
        if (p[to.first].first == -1) {
            p[to.first] = {v, to.second};
            return 1;
        }
    }
    for(auto to : g[v]) {
        if (dfs(p[to.first].first)) {
            p[to.first] = {v, to.second};
            return 1;
        }
    }
    return 0;
}

mt19937 gen;

int get(int a, int b) {
    vs.push_back(a * N + b);
    return a * N + b;
}

bool odd(int a) {
    return (((a / N) % 2) ^ ((a % N) % 2));
}

char res[N][N];

void put(int x, int y, int w, int h) {
    vector<int> free(10, 1);
    for(int i = 0; i < w; i++) {
        for(int j = 0; j < h; j++) {
            for(int dx : {-1, 0, 1}) {
                for(int dy : {-1, 0, 1}) {
                    if (dx * dy != 0) continue;
                    int xx = x + i + dx;
                    int yy = y + j + dy;
                    if (0 <= xx && 0 <= yy) {
                        if (res[xx][yy] != '.') {
                            free[res[xx][yy] - '0'] = 0;
                        }
                    }
                }
            }
        }
    }
    int q = -1;
    for(int i = 0; i < 10; i++) {
        if (free[i]) q = i;
    }
    assert(q != -1);
    for(int i = 0; i < w; i++) {
        for(int j = 0; j < h; j++) {
            res[x + i][y + j] = ('0' + q);
        }
    }
}


int main()
{
    for(int i = 0; i < N; i++) {
        for(int j = 0; j < N; j++) {
            res[i][j] = '.';
        }
    }
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> m;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> c[i][j];
        }
    }
    for(int i = 0; i < N; i++) {
        c[i][m] = ',';
        c[n][i] = ',';
    }
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if (i + 1 < n) {
                if (c[i][j] == c[i + 1][j] && c[i][j] != '.') {
                    if (c[i][j] <= 'Z') {
                        if (c[i][j + 1] == '.' && c[i + 1][j + 1] == '.') {
                            add(get(i, j + 1), get(i + 1, j + 1), get(i, j));
                        }
                    } else {
                        if (j > 0) {
                            if (c[i][j - 1] == '.' && c[i + 1][j - 1] == '.') {
                                add(get(i, j - 1), get(i + 1, j - 1), get(i, j - 1));
                            }
                        }
                    }
                }
            }
            if (j + 1 < m) {
                if (c[i][j] == c[i][j + 1] && c[i][j] != '.') {
                    if (c[i][j] <= 'Z') {
                        if (c[i + 1][j] == '.' && c[i + 1][j + 1] == '.') {
                            add(get(i + 1, j), get(i + 1, j + 1), get(i, j));
                        }
                    } else {
                        if (i > 0) {
                            if (c[i - 1][j] == '.' && c[i - 1][j + 1] == '.') {
                                add(get(i - 1, j), get(i - 1, j + 1), get(i - 1, j));
                            }
                        }
                    }
                }
            }
        }
    }
    vector<int> l, r;
    for(int i = 0; i < N * N; i++) {
        p[i] = {-1, -1};
    }
    for(auto v : vs) {
        if (odd(v)) l.push_back(v);
        else r.push_back(v);
    }
    shuffle(all(l), gen);
    int ans = 0;
    for(int run = 1; run; ) {
        run = 0;
        tt++;
        for(int x : l) {
            if (used[x] != tt && dfs(x)) {
                run = 1;
                ans++;
            }
        }
    }
    cout << ans << endl;
    for(int i = 0; i < N * N; i++) {
        if (p[i].first != -1) {
            put(p[i].second / N, p[i].second % N, 2, 2);
        }
    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if (res[i][j] == '.' && c[i][j] != '.') {
                if (c[i][j] == c[i + 1][j]) put(i, j, 2, 1);
                else put(i, j, 1, 2);
            }
        }
    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cout << res[i][j];
        }
        cout << endl;
    }
}
