//#pragma comment(linker, "/STACK:1073741824")
//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt")
//#pragma GCC target("avx,avx2")
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<unordered_set>
#include<unordered_map>
#include<algorithm>
#include<iostream>
#include<string.h>
#include<numeric>
#include<iomanip>
#include<cstring>
#include<fstream>
#include<cassert>
#include<vector>
#include<string>
#include<memory>
#include<chrono>
#include<random>
#include<cmath>
#include<ctime>
#include<queue>
#include<stack>
#include<map>
#include<set>
using namespace std;
//no more #define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for (int i = 0; i < (n); i++)
#define rforn(i, n) for (int i = n - 1; i >= 0; i--)
#define cmn(a, b) (a) = min((a), (b))
#define cmx(a, b) (a) = max((a), (b))
#define fastio ios::sync_with_stdio(false), cin.tie(0)
typedef long long ll;
typedef long double ld;
bool putSpace = true;
bool newLine = false;
bool newLineA = false;
bool pairEndLine = false;
template<class T>
istream& operator >> (istream& in, vector<T>& v) {
	for (auto& i : v) {
		in >> i;
	}
	return in;
}
template<class T>
ostream& operator<<(ostream& out, const vector<T>& v) {
	for (auto i : v) {
		out << i;
		if (!newLine) {
			if (putSpace) {
				out << ' ';
			}
		}
		else {
			out << '\n';
		}
	}
	if (!newLine && newLineA) {
		out << '\n';
	}
	return out;
}
template<class T, class U>
istream& operator >> (istream& in, pair<T, U>& p) {
	in >> p.first >> p.second;
	return in;
}
template<class T, class U>
ostream& operator<<(ostream& out, const pair<T, U>& p) {
	out << p.first << ' ' << p.second;
	if (pairEndLine) {
		cout << '\n';
	}
	return out;
}
long long gettime() {
	return chrono::high_resolution_clock::now().time_since_epoch().count() / (long long)1000000;
}
//#define TRUE_RANDOM
#ifdef TRUE_RANDOM
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
mt19937_64 rnd_64(chrono::high_resolution_clock::now().time_since_epoch().count());
#else
mt19937 rnd(239);
mt19937_64 rnd_64(239);
#endif
long long randnum(long long l, long long r) {
	return l + rnd_64() % (r - l + 1);
}
ll correct(vector<pair<pair<ll, ll>, ll>> v, ll w) {
	ll n = v.size();
	vector<ll> dp(w + 1, -1e18);
	dp[0] = 0;
	for (auto i : v) {
		vector<ll> ndp(w + 1, -1e18);
		forn(j, w + 1) {
			cmx(ndp[j], dp[j]);
			if (j + i.first.first <= w) {
				cmx(ndp[j + i.first.first], dp[j] + i.first.second);
			}
		}
		dp = ndp;
	}
	ll ans = 0;
	for (auto i : dp)cmx(ans, i);
	return ans;
}
bool comp(pair<pair<ll, ll>, ll> a, pair<pair<ll, ll>, ll> b) {
	return a.first.second * b.first.first > a.first.first * b.first.second;
}
bool trash(pair<pair<ll, ll>, ll> a, pair<pair<ll, ll>, ll> b) {
	return a.first.second > b.first.second;
}
pair<vector<ll>, ll> slow(vector<pair<pair<ll, ll>, ll>> v, ll w) {
	vector<pair<pair<ll, ll>, ll>> heavy, light;
	for (auto i : v) {
		if (i.first.first > w) {
			continue;
		}
		if (i.first.first * 2 > w) {
			heavy.push_back(i);
		}
		else {
			light.push_back(i);
		}
	}
	sort(all(light), comp);
	ll ans = 0, curw = 3 * w / 2;
	vector<ll> res;
	for (auto i : light) {
		if (curw >= i.first.first) {
			curw -= i.first.first;
			ans += i.first.second;
			res.push_back(i.second + 1);
		}
	}
	for (auto start : heavy) {
		if (3 * w / 2 >= start.first.first) {
			curw = 3 * w / 2 - start.first.first;
			ll cur = start.first.second;
			vector<ll> temp;
			temp.push_back(start.second + 1);
			for (auto i : light) {
				if (curw >= i.first.first) {
					curw -= i.first.first;
					cur += i.first.second;
					temp.push_back(i.second + 1);
				}
			}
			if (cur > ans) {
				ans = cur;
				res = temp;
			}
		}
	}
	return make_pair(res, ans);
}
void test() {
	const ll n = 10;
	ll cnt = 0;
	while (true) {
		if (cnt % 100000 == 0)cout << cnt << '\n';
		cnt++;
		vector<pair<pair<ll, ll>, ll>> v(n);
		ll w;
		w = randnum(1, 10);
		for (auto& i : v) {
			i.first.first = randnum(1, 10);
			i.first.second = randnum(1, 10);
			i.second = -1;
		}
		if (slow(v, w).second < correct(v, w)) {
			cout << slow(v, w).second << ' ' << correct(v, w) << '\n';
			slow(v, w);
		}
	}
}
signed main() {
	fastio;
	//test();
	ll q;
	cin >> q;
	while (q--) {
		ll n, w;
		cin >> n >> w;
		vector<pair<pair<ll, ll>, ll>> v(n);
		forn(i, n) {
			cin >> v[i].first;
			v[i].second = i;
		}
		vector<ll> temp = slow(v, w).first;
		cout << temp.size() << '\n' << temp << '\n';
	}
	return 0;
}