#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

#ifdef DEBUG
const int N = 100, INF = 1e18;
#define __int128 long long
#else
const int N = 5e5 + 100, INF = 1e18;
#endif

int C[31][15], n, k, sum, ans;
vector < int > v;

int f(int n, int k) {
    return C[n + k - 1][k];
}

void gen() {
    if (sum == n) {
        int p = 1, q = 1;
        for (int i = 1; i < v.size(); i++) {
            if (v[i] == v[i - 1]) {
                q++;
            } else {
                p *= f(q + 1, k - 1);
                q = 1;
            }
        }
        p *= f(q + 1, k - 1);
        ans += p;
        return;
    }
    int e;
    if (v.empty()) e = 1;
    else e = v.back();
    for (int i = e; i <= n - sum; i++) {
        v.push_back(i);
        sum += i;
        gen();
        sum -= i;
        v.pop_back();
    }
}

void solve() {
    C[0][0] = 1;
    for (int n = 1; n <= 30; n++) {
        C[n][0] = 1;
        for (int k = 1; k <= min(15ll, n); k++) {
            __int128 a = 1;
            for (int i = k + 1; i <= n; i++) {
                a *= i;
            }
            for (int i = 2; i <= n - k; i++) {
                a /= i;
            }
            C[n][k] = a;
        }
    }
    cin >> n >> k;
    gen();
    cout << ans;
}
