#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

using namespace std;
const ll inf = (ll) 1e18, mod = (ll) 1e9 + 7;
const ll N = 500000;

vector<ll> solve_tup(ll n, ll W, vector <ll> &weight, vector <ll> &cost) {
    ll dp[2][W+1];
    ll p[n][W+1];
    for (ll curw = 0; curw <= W; ++curw) {
        dp[0][curw] = -inf;
        dp[1][curw] = -inf;
    }
    dp[0][0] = 0;
    for (ll i = 0; i < n; ++i) {
        for (ll curw = 0; curw <= W; ++curw) {
            dp[1][curw] = dp[0][curw];
            p[i][curw] = curw;

            if (curw-weight[i] >= 0 && dp[0][curw-weight[i]] != -inf) {
                if (dp[1][curw] < dp[0][curw-weight[i]]+cost[i]) {
                    p[i][curw] = curw-weight[i];
                    dp[1][curw] = dp[0][curw-weight[i]]+cost[i];
                }
            }
        }
        for (ll curw = 0; curw <= W; ++curw) {
            dp[0][curw] = dp[1][curw];
            dp[1][curw] = -inf;
        }
    }
    vector <ll> ans;
    ll ind = 0;
    for (ll curw = 0; curw <= W; ++curw) {
        if (dp[0][ind] < dp[0][curw])
            ind = curw;
    }

    for (ll i = n-1; i >= 0; --i) {
        if (p[i][ind] != ind) {
            ans.pb(i);
            ind = p[i][ind];
        }
    }
    reverse(ans.begin(),ans.end());

    return ans;
}

vector <ll> weight,cost;
bool comp(pair<pair<ll,ll>,ll> &a, pair<pair<ll,ll>,ll> &b) {
    if (a.ft.ft*b.ft.sd != a.ft.sd*b.ft.ft)
        return a.ft.ft*b.ft.sd < a.ft.sd*b.ft.ft;
    return weight[a.sd]>weight[b.sd];
}

vector <ll> solve_umn(ll n, ll W) {
    vector<pair<pair<ll, ll>, ll>> z;
    for (ll i = 0; i < n; ++i) {
        z.pb({{cost[i], weight[i]}, i});
    }

    sort(z.begin(), z.end(), comp);
    ll curw = 0;
    vector<ll> ans;

    for (ll i = 0; i < n; ++i) {
        if (curw + weight[z[i].sd] <= W) {
            ans.pb(z[i].sd);
            curw += weight[z[i].sd];
        }
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef FREOPEN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll t;
    cin >> t;

    for (ll z = 0; z < t; ++z) {
        ll n , W;
        cin >> n >> W;
        W *= 3;
        W /= 2;
        weight.resize(n);
        cost.resize(n);
        for (ll i = 0; i < n; ++i) {
            cin >> weight[i] >> cost[i];
        }
        vector <ll> ans;
        if (n*W <= (ll)1e7) {
            ans = solve_tup(n,W,weight,cost);
        }
        else {
            ans = solve_umn(n,W);
        }
        cout << ans.size() << '\n';
        for (auto i: ans) {
            cout << i+1 << ' ';
        }
        cout << '\n';
    }
    return 0;
}
