#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <queue>
#include <ctime>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>
#include <chrono>
#include <list>
using namespace std;

//#define int ll

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int , int> pii;
typedef pair <ll , ll> pll;


#define ff first
#define ss second
#define mp make_pair
#define pf push_front
#define pb push_back
#define IO ios_base::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
#define print(x) { for (auto xxxxxxxxx : (x)) cout << xxxxxxxxx << ' '; cout << '\n'; }
#define printp(x) { for (auto xxxxxxxxx : (x)) cout << "{" << xxxxxxxxx.ff << ", " << xxxxxxxxx.ss << "} "; cout << '\n'; }
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const ll mod=1e9+7;
const ll inf=2e18+5;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll random(ll l, ll r){ return uniform_int_distribution<ll>(l, r)(rng);}

int n , k;

vector <int> st;
vector < vector <ull> > dp;
string ans = "0";

string operator+(string a , string b) {
    reverse(all(a));
    reverse(all(b));
    if (a.size() < b.size())
        swap(a , b);
    for (int i = 0; i < a.size(); i++) {
        if (i < b.size()) {
            a[i] += (b[i] - '0');
        }
        if (a[i] > '9') {
            a[i] -= 10;
            if (i + 1 >= a.size())
                a += '0';
            a[i + 1]++;
        }
    }
    reverse(all(a));
    return a;
}

string operator*(string a , ull b) {
    string ans = "0";
    while (b) {
        string cur = a;
        ll x = b % 10;
        b /= 10;
        reverse(all(cur));
        for (int i = 0; i < cur.size(); i++) {
            ll y = cur[i] - '0';
            y *= x;
            if (y > 9 && i + 1 >= cur.size())
                cur += '0';
            cur[i + 1] += y / 10;
            cur[i] = (y % 10) + '0';
        }
        reverse(all(cur));
        ans = ans + cur;
        a += '0';
    }
    return ans;
}

void add() {
    vector <int> cnt(n + 1 , 0);
    for (auto x : st) {
        cnt[x]++;
    }
    string cur = "1";
    for (auto x : cnt) {
        if (x == 0)
            continue;
        for (int j = 0; j < k; j++) {
            cur = cur*dp[x][j];
            //cout << cur << '\n';
        }
    }
    ans = ans + cur;
}

void F(int sum , int pr) {
    if (sum == n) {
        add();
        return;
    }
    for (int i = pr; i >= 1; i--) {
        if (sum + i > n)
            continue;

        st.push_back(i);
        F(sum + i , i);
        st.pop_back();
    }
}

void solve(){
    cin >> n >> k;
    dp.resize(n + 1 , vector <ull> (k , 0));
    dp[0] = vector <ull> (k , 1);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < k; j ++) {
            for (int t = j; t >= 0; t--) {
                dp[i][j] += dp[i - 1][t];
            }
        }
    }
    F(0 , n);
    cout << ans << '\n';
}
/*

 */
signed main() {
    IO
    //freopen(".in" , "r" , stdin);freopen(".out" , "w" , stdout);
    int t=1;
    //cin >> t;
    while(t--) solve();
}