#include <bits/stdc++.h>

typedef long long int ll;

#define pll pair<ll, ll>
#define pt pair<ll, ll>
#define f first
#define s second
#define int long long
#define ld long double
#define all(x) x.begin(), x.end()
#define pii pair<int,int>
#define pb push_back

using namespace std;
mt19937 rnd(time(0));
const int mod = 1e9 + 7;
const int N = 2e5 + 10;
const int INF = 1e18;

vector<pair<pair<int, int>, int>> x;
int w;

void shuffle() {
    int n = x.size();
    for (int i = 0; i < n; ++i) {
        int i1 = (rnd() % n + n) % n;
        int i2 = (rnd() % n + n) % n;
        swap(x[i1], x[i2]);
    }
}

bool comp(pair<pair<int, int>, int> x, pair<pair<int, int>, int> y) {
    return x.f.s * y.f.f> y.f.s * x.f.f;
}

void solve() {
    int n = x.size();
    int dp[n + 1][w + 1];
    int p[n + 1][w + 1];
    for (int i = 0; i < n + 1; ++i) {
        fill(dp[i], dp[i] + w + 1, -INF);
        for (int j = 0; j < w + 1; ++j)p[i][j] = -1;
    }
    dp[0][0] = 0;
    for (int i = 1; i <= n; ++i) {
        int cost = x[i - 1].f.s;
        int W = x[i - 1].f.f;
        dp[i][0] = 0;
        p[i][0] = -1;
        for (int s = 0; s <= w; ++s) {
            dp[i][s] = dp[i - 1][s];
            p[i][s] = s;
        }
        for (int s = 0; s <= w - W; ++s) {
            if (dp[i - 1][s] != -INF && dp[i - 1][s] + cost > dp[i][s + W]) {
                dp[i][s + W] = dp[i - 1][s] + cost;
                p[i][s + W] = s;
            }
        }
    }
    int id = -1;
    int mx = -INF;
    for (int i = 0; i < w + 1; ++i) {
        if (dp[n][i] > mx) {
            mx = dp[n][i];
            id = i;
        }
    }

    vector<int> res;
    int s = id;
    id = n;
    while (id != 0 && s != -1) {
        if (p[id][s] != s) {
            res.pb(x[id - 1].s + 1);
        }
        s = p[id][s];
        id--;
    }
    cout << res.size() << endl;
    for (int T : res) cout << T << " ";
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n >> w;


        vector<pair<pair<int, int>, int>> v;
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            int W, C;
            cin >> W >> C;
            v.pb({{W, C}, i});
            sum += W;
        }
        x.clear();
        int mx = 0;
        for (int i = 0; i < n; ++i) {
            x.pb(v[i]);
        }
        sort(all(x), comp);

        if (w <= 50) {
            solve();
            continue;
        }
        w *= 3;
        if (w % 2 != 0)w--;
        w /= 2;

        vector<int> res;
        mx = 0;
        for (int it = 0; it < 100; ++it) {
            vector<int> take;
            int c = 0;
            int W = 0;
            for (int i = 0; i < x.size(); ++i) {
                auto q = x[i].f;
                if (W + q.f <= w) {
                    W += q.f;
                    c += q.s;
                    take.pb(x[i].s);
                }
            }
            if (c > mx) {
                mx = c;
                res = take;
            }
            shuffle();
        }
        cout << res.size() << endl;
        for (int p : res) cout << p + 1 << " ";
        cout << endl;
    }
}