#include<bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
typedef long double ld;
typedef long long var;
typedef pair<int, int> prii;
typedef pair<ll, ll> prll;
typedef vector<int> veci;
typedef vector<ll> vecl;
typedef vector<veci> graph;
typedef map<int, int> mapii;
typedef set<int> seti;
typedef bitset<64> bits;
#define WHITE 0
#define GRAY  1
#define BLACK 2
#define psh push_back
#define pp pop_back
#define all(a) a.begin(),a.end()
#define binser binary_search
#define qsort sort
#define msort stable_sort
#define hsort heap_sort
#define vec vector
#define forn(i, n) for(int i=0;i<(n);i++)
#define mod(a) ((a)%(MOD))
#define $ '\n'
#define MAX LONG_LONG_MAX
#define MIN LONG_LONG_MIN
#define coutop(type, code) \
    ostream &operator << (ostream &out, const type &_) { \
        {code}\
        return out;\
    }
#define cinop(type, code) \
    istream &operator >> (istream &in, type &_) { \
        {code}\
        return in;\
    }
#define len(a) ((int)a.size())

template<class T>
void sortf(vector<T> &v) {
    stable_sort(v.begin(), v.end());
}

template<class T>
void sortb(vector<T> &v) {
    stable_sort(v.rbegin(), v.rend());
}

template<class T>
T max3(T a, T b, T c) {
    return max(a, max(b, c));
}

template<class T>
T min3(T a, T b, T c) {
    return min(a, min(b, c));
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &t : v)
        in >> t;
    return in;
}

ostream &operator<<(ostream &out, const vector<char> &v) {
    for (const char &t : v)
        out << t;
    out << endl;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &v) {
    for (const T &t : v)
        out << t << ' ';
    return out;
}

template<class T>
ostream &operator<<(ostream &out, const pair<T, T> &v) {
    out << v.fir << ' ' << v.sec;
    return out;
}

template<class T>
istream &operator>>(istream &in, pair<T, T> &v) {
    in >> v.fir >> v.sec;
    return in;
}


void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
}

struct point {
    int x, y;

    point(int x, int y) : x(x), y(y) {}

    point() = default;

    point(point s, point f) : x(f.x - s.x), y(f.y - s.y) {}

    friend istream &operator>>(istream &is, point &p) {
        is >> p.x >> p.y;
        return is;
    }

    bool operator==(point other) { return x == other.x && y == other.y; }
};

int scalar(point a, point b) { return a.x * b.x + a.y * b.y; }

int cross(point a, point b) { return a.x * b.y - a.y * b.x; }

bool intersect(point a, point b, point c, point d) { //ab intersects cd
    if (a == c && b == d) return true;
    if (a == c || a == d || b == c || b == d) return false;
    if (cross(point(a, b), point(c, d)) == 0) {
        if (cross(point(a, b), point(a, c)) != 0) return false;
        return (scalar(point(a, c), point(a, d)) <= 0) ||
               (scalar(point(b, c), point(b, d)) <= 0) ||
               (scalar(point(c, a), point(c, b)) <= 0);
    } else {
        return (cross(point(a, c), point(a, b)) * cross(point(a, d), point(a, b)) <= 0) &&
               (cross(point(c, a), point(c, d)) * cross(point(c, b), point(c, d)) <= 0);
    }
}

void solve() {
    int n;
    cin >> n;
    vector<point> points(n);
    cin >> points;
    vector<pair<int, int>> free;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            free.emplace_back(i, j);
        }
    }
    int sz = 0;
    while (!free.empty()) {
        auto s = free.back();
        free.pop_back();
        vector<pair<int, int>> rem;
        for (auto p : free) {
            if (!intersect(points[s.first], points[s.second], points[p.first], points[p.second]))
                rem.push_back(p);
        }
        free = rem;
        sz++;
    }
    cout << 2 - sz % 2 << endl;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            free.emplace_back(i, j);
        }
    }
    for (int my = sz % 2;; my = !my) {
        if (my) {
            cout << free.back().first + 1 << ' ' << free.back().second + 1 << endl;
            vector<pair<int, int>> rem;
            auto s = free.back();
            for (auto p : free) {
                if (!intersect(points[s.first], points[s.second], points[p.first], points[p.second]))
                    rem.push_back(p);
            }
            free = rem;
        } else {
            int i, j;
            cin >> i >> j;
            if (i == 0 && j == 0) exit(0);
            --i, --j;
            vector<pair<int, int>> rem;
            for (auto p : free) {
                if (!intersect(points[i], points[j], points[p.first], points[p.second]))
                    rem.push_back(p);
            }
            free = rem;
        }
    }
}