#include<bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
typedef long double ld;
typedef long long var;
typedef pair<int,int>prii;
typedef pair<ll,ll>prll;
typedef vector<int>veci;
typedef vector<ll>vecl;
typedef vector<veci> graph;
typedef map<int,int> mapii;
typedef set<int> seti;
typedef bitset<64> bits;
#define WHITE 0
#define GRAY  1
#define BLACK 2
#define psh push_back
#define pp pop_back
#define all(a) a.begin(),a.end()
#define binser binary_search
#define qsort sort
#define msort stable_sort
#define hsort heap_sort
#define vec vector
#define forn(i,n) for(int i=0;i<(n);i++)
#define mod(a) ((a)%(MOD))
#define $ '\n'
#define MAX LONG_LONG_MAX
#define MIN LONG_LONG_MIN
#define coutop(type, code) \
    ostream &operator << (ostream &out, const type &_) { \
        {code}\
        return out;\
    }
#define cinop(type, code) \
    istream &operator >> (istream &in, type &_) { \
        {code}\
        return in;\
    }
#define len(a) ((int)a.size())
template <class T> void sortf(vector<T> &v) {
    stable_sort(v.begin(), v.end());
}

template <class T> void sortb(vector<T> &v) {
    stable_sort(v.rbegin(), v.rend());
}

template <class T> T max3(T a, T b, T c) {
    return max(a, max(b, c));
}

template <class T> T min3(T a, T b, T c) {
    return min(a, min(b, c));
}

template <typename T> istream &operator>> (istream &in, vector<T> &v) {
    for (T &t : v)
        in >> t;
    return in;
}

ostream &operator<< (ostream &out, const vector<char> &v) {
    for (const char &t : v)
        out << t;
    out << endl;
    return out;
}

template <typename T> ostream &operator<< (ostream &out, const vector<T> &v) {
    for (const T &t : v)
        out << t << ' ';
    return out;
}

template <class T> ostream &operator<< (ostream &out, const pair<T, T> &v) {
    out << v.fir << ' ' << v.sec;
    return out;
}
template <class T> istream &operator>> (istream &in, pair<T, T> &v) {
    in >> v.fir >> v.sec;
    return in;
}


void solve();
signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
}

void solve() {
    int n, m, s;
    cin >> n >> m >> s;
    veci a(m); cin >> a;
    sortf(a);
    a.resize(unique(all(a)) - a.begin());
    int ans = 0;
    auto cnt = [&](int l, int r){
        return upper_bound(all(a), r - 1) - lower_bound(all(a), l);
    };
    for (int l = 0; l < len(a); l++) {
        int lo = l ? a[l - 1] + 1 : 1, hi = min(a[l], n - m + 1);
        if (lo > hi) continue;
        if (cnt(lo, lo + m) >= m - s) {
            ans += min(a[l], n - m + 1) - lo + 1;
    //        cerr << l << " (lo: " << lo << "): + " << a[l] - lo + 1 << $;
            continue;
        }
        if (cnt(hi, hi + m) < m - s) continue;
        while (lo + 1 < hi) {
            int mm = (lo + hi) / 2;
            if (cnt(mm, mm + m) < m - s) lo = m;
            else hi = m;
        }
    //    cerr << l << " (hi: " << hi << "): + " << a[l] - hi + 1 << $;
    //    if (cnt(hi, hi + m) >= m - s)
        ans += min(a[l], n - m + 1) - hi + 1;
    }

    cout << ans << $;
}