#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
using namespace std;
#define ll  unsigned long long
//#define dd double
#define y second
#define x first
#define int long long
#define pii pair<int,int>
mt19937 rnd(42);
ll mod = 998244353;


const long double pi = acos(-1);
const long double eps = 1e-9;

struct dot {
    long long x, y;
    dot()
    {
        x = 0;
        y = 0;
    }
    dot(long long _x, long long _y)
    {
        x = _x;
        y = _y;
    }
    dot operator+(dot p)
    {
        return dot(x + p.x, y + p.y);
    }
    dot operator-(dot p)
    {
        return dot(x - p.x, y - p.y);
    }
    long long operator%(dot p)
    {
        return x * p.y - y * p.x;
    }

    long long operator*(dot p)
    {
        return x * p.x + y * p.y;
    }

    dot operator*(long long k)
    {
        return dot{ x * k, y * k };
    }

    long double getlen()
    {
        return sqrt(x * x + y * y);
    }

    long long getsquarelen()
    {
        return x * x + y * y;
    }

    bool operator==(dot p)
    {
        return (p.x == x) && (p.y == y);
    }
    bool operator<(dot p){
        if(x!=p.x)
            return x<p.x;
        return y<p.y;
    }
    pair<long double, long double> normalize()
    {
        return make_pair(x / getlen(), y / getlen());
    }

    bool iscent(dot p1, dot p2)
    {
        if ((x <= p1.x && x >= p2.x) || (x >= p1.x && x <= p2.x)) {
            if ((y <= p1.y && y >= p2.y) || (y >= p1.y && y <= p2.y)) {
                return 1;
            }
        }
        return 0;
    }
};

bool iscent(dot p1, dot p2, pair<long double, long double> c)
{
    if ((c.x <= p1.x + eps && c.x + eps >= p2.x) || (c.x + eps >= p1.x && c.x <= p2.x + eps)) {
        if ((c.y <= p1.y + eps && c.y + eps >= p2.y) || (c.y + eps >= p1.y && c.y <= p2.y + eps)) {
            return 1;
        }
    }
    return 0;
}

dot infv = dot(LLONG_MAX, LLONG_MAX);

long double getangle(dot a, dot b)
{
    return atan2(a % b, a * b);
}

long double getgoodangle(dot a, dot b)
{
    long double res = atan2(a % b, a * b);
    if (res < 0)
        res += 2 * pi;
    return res;
}

double getverygoodangle(dot a, dot b)
{
    double res = atan2(a % b, a * b);
    if (res < 0)
        res += 2 * pi;
    if (res > pi)
        res = 2 * pi - res;
    return res;
}

struct line {
    long long a, b, c;
    dot on1, on2;
    line(dot p, dot q)
    {
        a = p.y - q.y;
        b = q.x - p.x;
        c = -a * p.x - b * p.y;
        on1 = p;
        on2 = q;
    }
    line(long long k, long long _b)
    {
        a = k;
        b = -1;
        c = _b;
        on1 = dot(1, a + c);
        on2 = dot(2, 2 * a + c);
    }
    line(long long _a, long long _b, long long _c)
    {
        a = _a;
        b = _b;
        c = _c;
    }
    bool ison(dot p)
    {
        if (abs(a * p.x + b * p.y + c) < eps)
            return 1;
        return 0;
    }
    pair<long double, long double> intersect(line l)
    {
        if (l.b != 0) {
            long double x = ((((long double)b) * l.c / l.b - c) / (a - ((long double)b) * l.a / l.b));
            long double y = (-x * l.a - l.c) / l.b;
            return make_pair(x, y);
        }
        else {
            long double x = -((long double)l.c) / l.a;
            long double y = (-x * a - c) / b;
            return make_pair(x, y);
        }
    }
};



long double getdist(line l, dot a)
{
    if (l.ison(a))
        return 1;
    dot parr = l.on1 - l.on2;
    dot norm = dot(-parr.y, parr.x);
    dot r = l.on1 - a;
    double ang = getverygoodangle(r, norm);
    if (ang > pi / 2) {
        norm = norm * -1;
        ang = pi - ang;
    }
    ang = pi / 2 - ang;
    return r.getlen() * sin(ang);
}

dot perp(line l, dot a)
{
    dot parr = l.on1 - l.on2;
    dot norm = dot(-parr.y, parr.x);
    dot r = l.on1 - a;
    double ang = getverygoodangle(r, norm);
    if (ang > pi / 2) {
        norm = norm * -1;
        ang = pi - ang;
    }
    ang = pi / 2 - ang;
    double dd = r.getlen() * sin(ang);
    dot ddd = norm * dd;
    return a + ddd;
}




ll bpow(ll a, int p, int m) {
    a %= mod;
    ll ans = 1;
    while (p) {
        if (p & 1) {
            ans *= a;
            ans %= m;
        }
        a *= a;
        a %= m;
        p = (p >> 1);
    }
    return ans;
}

ll obr(ll n) {
    return bpow(n, mod - 2, mod);
}

void inc(string &s){
    int cary = 0;
    for(int i = s.size()-1;i>=0;i--)
    {
        if(s[i]=='1')s[i]='0';
        else {
            s[i]='1';
            break;
        }
    }
}
int cw(pii o, pii a, pii b){
    return(o.x-a.x)*(o.y-b.y)-(o.y-a.y)*(o.x-b.x);
}

bool inter(pii a1, pii a2, pii b1, pii b2){
    if(a1==b1)return 0;
    if(a1==b2)return 0;
    if(a2==b1)return 0;
    if(a2==b2)return 0;
    if(cw(a1,b1,a2)>0&&cw(b1,a2,b2)>0&&cw(a2,b2,a1)>0&&cw(b2,a1,b1)>0)return 1;
    if(cw(a1,b1,a2)<0&&cw(b1,a2,b2)<0&&cw(a2,b2,a1)<0&&cw(b2,a1,b1)<0)return 1;
    return 0;
}

signed main() {
    ios::sync_with_stdio(0);
    cout.tie(0);
    //cout<<cw({0,0},{0,1},{1,1});
    int n;cin>>n;
    vector<dot> ps(n);
    for (int i = 0; i < n; i++) {
        cin >> ps[i].x >> ps[i].y;
    }

    int mind = min_element(ps.begin(), ps.end()) - ps.begin();
    swap(ps[0], ps[mind]);
    sort(ps.begin() + 1, ps.end(), [&](dot& p, dot& q) {
        long long t = (p - ps[0]) % (q - ps[0]);
        if (t == 0)
            return (p - ps[0]).getlen() < (q - ps[0]).getlen();
        return t > 0;
    });
    vector<int> ch;
    ch.push_back(0);
    for (int i = 1; i < n; i++) {
        while (ch.size() >= 2 && (ps[ch.back()] - ps[ch[ch.size() - 2]]) % (ps[i] - ps[ch[ch.size() - 2]]) <= 0)
            ch.pop_back();
        ch.push_back(i);
    }
    int l = ch.size();
    vector<set<int> > e(n);
    for(int i = 0;i<n;i++)
        for(int j = 0;j<n;j++)
            if(i!=j)e[i].insert(j);
    int r = 3*n-l-3;
    vector<pii> newe;
    if(r%2==1){
        cout<<1<<endl;
        newe.push_back({0,1});
        cout<<1<<" "<<2<<endl;
        e[0].erase(1);
        e[1].erase(0);
    }
    else cout<<2<<endl;
    while(1) {
        int a, b;
        cin >> a >> b;
        if (a == 0 && b == 0)return 0;
        a--;
        b--;
        newe.push_back({a,b});
        for (int i = 0; i < n; i++) {
            bool k = 0;
            for (auto j = e[i].begin(); j != e[i].end();) {
                if(k!=1)j++;else k=0;
                if (inter({ps[i].x, ps[i].y}, {ps[*j].x, ps[*j].y}, {ps[a].x, ps[a].y}, {ps[b].x, ps[b].y})) {
                    e[i].erase(j);
                    k=1;
                }
            }
        }
        e[a].erase(b);
        e[b].erase(a);
        for (int i = 0; i < n; i++)
            if (!e[i].empty()) {
                newe.push_back({0,1});
                cout << i + 1 << " " << *e[i].begin() + 1 << endl;
                //for()
                int u = *e[i].begin();
                for (int k = 0; k < n; k++) {
                    bool s = 0;
                    for (auto j = e[k].begin(); j != e[k].end();) {
                        if(s==0)j++;else s=0;
                        if (inter({ps[u].x, ps[u].y}, {ps[i].x, ps[i].y}, {ps[k].x, ps[k].y}, {ps[*j].x, ps[*j].y})) {
                            e[k].erase(j);
                            s=1;
                        }
                    }
                }
                e[i].erase(u);
                e[u].erase(i);
                break;
            }
    }
}
/*
 6
1 2
2 3
3 2
2 1
2 2
3 1
2
1 7
1 2
6 4
1 3
5 6
1 4
 */