import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.security.PrivilegedExceptionAction;
import java.util.*;


public class MainClass {
    public static class pair implements Comparable<pair>{
        int a;
        int b;
        public pair(int a, int b){
            this.a = a;
            this.b = b;
        }

        @Override
        public int compareTo(pair o) {
            if(this.a == o.a){
                return o.b - this.b;
            }
            return o.a - this.a;
        }
    }
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(System.out);
        int t = Integer.parseInt(reader.readLine());
        for(int q = 0; q < t; ++q){
            int n = Integer.parseInt(reader.readLine());
            int[] a = new int[n];
            int[] b = new int[n];
            StringTokenizer st = new StringTokenizer(reader.readLine());
            for(int i = 0; i < n; ++i){
                a[i] = Integer.parseInt(st.nextToken());
            }
            st = new StringTokenizer(reader.readLine());
            for(int i = 0; i < n; ++i){
                b[i] = Integer.parseInt(st.nextToken());
            }
            ArrayList<pair> arr = new ArrayList<>();
            for(int i = 0; i < n; ++i){
                arr.add(new pair(b[i], a[i]));
            }
            Collections.sort(arr);
            long at = 0;
            long ab = 0;
            for(int i = 1; i < n; ++i){
                int a2 = arr.get(i).a;
                int b2 = arr.get(i).b;
                long ch1 = Math.min(a2, ab);
                long ch2 = Math.min(b2, at);
                a2 -= ch1;
                b2 -= ch2;
                at -= ch2;
                ab -= ch1;
                at += a2;
                ab += b2;
            }
            if(at <= arr.get(0).b){
                writer.println("YES");
            }
            else{
                writer.println("NO");
            }
        }
        writer.close();
    }
}