#include <bits/stdc++.h>

using namespace std;

const int N = 1000000;

vector<int> g[N];
vector<int> gg[N];
vector<bool> marked(N, false);
vector<bool> used(N, false);
vector<bool> usedd(N, false);
vector<int> color(N, -1);

void dfs(int v, bool cur_state) {
    if (used[v]) {
        return;
    }
    used[v] = true;
    marked[v] = cur_state;

    for (auto e : g[v]) {
        dfs(e, !cur_state);
    }
}

void dfss(int v) {
    if (usedd[v]) {
        return;
    }
    usedd[v] = true;
    color[v] = 0;

    bool fl = true;
    for (auto e : gg[v]) {
        if (color[e] >= 0 && color[e] == color[v]) {
            fl = false;
            break;
        }
    }

    while (!fl) {
        color[v]++;

        fl = true;
        for (auto e : gg[v]) {
            if (color[e] >= 0 && color[e] == color[v]) {
                fl = false;
                break;
            }
        }
    }
    for (auto e : g[v]) {
        dfss(e);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    int n, m;

    cin >> n >> m;

    string raw[n];

    int v[n][m];
    int status[n][m];

    int res[n][m];
    char ans[n][m];


    for (int i = 0; i < n; ++i) {
        cin >> raw[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            status[i][j] = 0;
            v[i][j] = -1;
            res[i][j] = -1;
        }
    }
    int cur_v = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (raw[i][j] == '.') {
//                v[i][j] = -1;
                continue;
            }
            int dx = 0;
            int ddx = 0;
            int dy = 0;
            int ddy = 0;

            if (i < n - 1 && raw[i][j] == raw[i + 1][j]) {
                dx = 1;
                if (raw[i][j] < 'a') {
                    ddy = 1;
                } else {
                    ddy = -1;
                }
            } else if (j < m - 1 && raw[i][j] == raw[i][j + 1]) {
                dy = 1;
                if (raw[i][j] < 'a') {
                    ddx = 1;
                } else {
                    ddx = -1;
                }
            } else {
                continue;
            }

            if (i + ddx < 0 || j + ddy < 0 || i + dx + ddx < 0 || j + dy + ddy < 0 || i + ddx >= n || j + ddy >= m ||
                i + dx + ddx >= n || j + dy + ddy >= m ||
                raw[i + ddx][j + ddy] != '.' || raw[i + dx + ddx][j + dy + ddy] != '.') {
                status[i][j] = -1;
                status[i + dx][j + dy] = -1;
                continue;
            } else {
                status[i][j] = 1;
                status[i + dx][j + dy] = 1;
            }

            v[i][j] = cur_v;
            v[i + dx][j + dy] = cur_v;

            if (v[i + ddx][j + ddy] != -1) {
                g[cur_v].push_back(v[i + ddx][j + ddy]);
                g[v[i + ddx][j + ddy]].push_back(cur_v);
            }

            if (v[i + dx + ddx][j + dy + ddy] != -1 && v[i + dx + ddx][j + dy + ddy] != v[i + ddx][j + ddy]) {
                g[cur_v].push_back(v[i + dx + ddx][j + dy + ddy]);
                g[v[i + dx + ddx][j + dy + ddy]].push_back(cur_v);
            }
            v[i + ddx][j + ddy] = cur_v;
            v[i + dx + ddx][j + dy + ddy] = cur_v;
            cur_v++;
        }
    }

    for (int i = 0; i < cur_v; ++i) {
        if (g[i].size() < 2) {
            dfs(i, true);
        }
    }
    for (int i = 0; i < cur_v; ++i) {
//        cerr << g[i].size() << endl;
        dfs(i, true);
    }
    int rescount = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (raw[i][j] == '.') {
//                v[i][j] = -1;
                continue;
            }
            int dx = 0;
            int ddx = 0;
            int dy = 0;
            int ddy = 0;

            if (i < n - 1 && raw[i][j] == raw[i + 1][j]) {
                dx = 1;
                if (raw[i][j] < 'a') {
                    ddy = 1;
                } else {
                    ddy = -1;
                }
            } else if (j < m - 1 && raw[i][j] == raw[i][j + 1]) {
                dy = 1;
                if (raw[i][j] < 'a') {
                    ddx = 1;
                } else {
                    ddx = -1;
                }
            } else {
                continue;
            }

            if (i + ddx < 0 || j + ddy < 0 || i + dx + ddx < 0 || j + dy + ddy < 0 || i + ddx >= n || j + ddy >= m ||
                i + dx + ddx >= n || j + dy + ddy >= m ||
                raw[i + ddx][j + ddy] != '.' || raw[i + dx + ddx][j + dy + ddy] != '.') {
                res[i][j] = cur_v;
                res[i + dx][j + dy] = cur_v;
                cur_v++;
                continue;
            }

            int vert = v[i][j];
            res[i][j] = vert;
            res[i + dx][j + dy] = vert;
            if (marked[vert]) {
                rescount++;
                res[i + ddx][j + ddy] = vert;
                res[i + dx + ddx][j + dy + ddy] = vert;
            }
        }
    }

//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < m; ++j) {
//            cout << res[i][j] << ' ';
//        }
//        cout << '\n';
//    }
//    vector<pair<int, int>> edges;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (res[i][j] == -1) {
//                ans[i][j] = '.';
                continue;
            }
            if (i > 0 && res[i][j] != res[i - 1][j]) {
                gg[res[i][j]].push_back(res[i - 1][j]);
                gg[res[i - 1][j]].push_back(res[i][j]);
            }

            if (j > 0 && res[i][j] != res[i][j - 1]) {
                gg[res[i][j]].push_back(res[i][j - 1]);
                gg[res[i][j - 1]].push_back(res[i][j]);
            }
        }
    }
    for (int i = 0; i < cur_v; ++i) {
        dfss(i);
    }
    cout << rescount << '\n';
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (res[i][j] == -1) {
//                ans[i][j] = '.';
                cout << '.';
            } else {
                cout << color[res[i][j]];
            }
        }

        cout << '\n';
    }
}