//#define _GLIBCXX_DEBUG 1
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
using namespace std;
#define int long long


signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m, s;
    cin >> n >> m >> s;
    set<int> cards_set;
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        cards_set.insert(x);
    }
    vector<int> cards;
    for (int x : cards_set)
        cards.push_back(x);

    const int START = 0, FINISH = 1;
    vector<pair<int, int>> events;

    for (int i = 0; i + (m - s) <= cards.size(); i++) {
        int l = i, r = i + (m - s);
        int left_can = max<int>(1, cards[r - 1] - m + 1);
        int right_can = min(cards[l], n - m + 1);
        if (left_can <= right_can) {
            events.push_back({START, left_can});
            events.push_back({FINISH, right_can + 1});
            //cout << "can from " << left_can << " to " << right_can << endl;
        }
    }
    sort(events.begin(), events.end());

    int prev_start = 0;
    int cur_opened = 0;
    int ans = 0;
    for (auto &event : events) {
        int type = event.first, x = event.second;

        if (type == START)
            cur_opened++;
        else
            cur_opened--;
        if (type == START && cur_opened == 1) {
            prev_start = x;
        }
        else if (type == FINISH && cur_opened == 0) {
            ans += (x - prev_start);
        }
    }

    cout << ans;
}
