#include <functional>
#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,avx")

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = 2e5 + 1;
const ll mod = 1000000007;

void ex(ll exitCode = 0) {
#ifdef _DEBUG
	//system("pause");
#endif // _DEBUG
	exit(exitCode);
}

void solve() {
	ll n;
	cin >> n;
	vector<pair<ll, ll>> vec(n);
	ll s = 0;
	ll k = 0;
	for (auto& i : vec) {
		cin >> i.second;
		s += i.second;
	}
	for (auto& i : vec) cin >> i.first;
	sort(all(vec));
	ll cnt = 0;
	for (auto i : vec) {
		cnt++;
		if (i.first + i.second <= s) {
			s -= i.first;
			k += i.first;
		}
		else {
			if (k >= i.second + i.first - s) {
				ll kek = i.second + i.first - s;
				kek = min(kek, i.second);
				i.second -= kek;
				k -= kek;
			}
			if (i.first + i.second <= s) {
				s -= i.first;
				k += i.first;
			}
			else {
				if (cnt == n) cout << "YES";
				else cout << "NO";
				return;
			}
		}
	}
	cout << "YES";
}

ll t;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
	ex();
}