#include <iostream>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n, m, s;
    cin >> n >> m >> s;
    vector<int> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    map<int, int> mas;
    sort(a.begin(), a.end());
    mas[n + 1] = 0;
    mas[a[0]]++;
    mas[a[0] + 5]--;
    for (int i = 1; i < m; ++i) {
        if (a[i] != a[i - 1]) {
            mas[a[i]]++;
            mas[a[i] + 5]--;
        }
    }
    vector<pair<int, int>> mase;
    for (auto next : mas) {
        mase.push_back({next.first, next.second});
    }
    while (mase.back().first > n) {
        mase.pop_back();
    }
    mase.push_back({n + 1, 0});
    int now = 0;
    int cnt = 0;
    for (auto next : mase) {
        now += next.second;
        if (now + s >= m) {
            auto it = (*upper_bound(mase.begin(), mase.end(), next)).first;
            cnt += it - next.first;
        }
    }
    cout << cnt;
    return 0;
}
