#include <algorithm>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <string>
#include <cstdio>
#include <tuple>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(0)

#define ff first
#define ss second
#define pb push_back
#define mp make_pair
#define sqr(a) ((a) * (a))
#define vout(a) cout << #a << ": " << (a) << '\n'

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = 0x7fffffff;
const ll MOD = (1 << 30) + 1;
const ld EPS = 1e-8;
const ld PI = 3.14159265358979323;
const int MAXN = 2e5 + 100;

int a[MAXN];
vector <int> b;

int main() {
    fast();
    int n, m, s;
    cin >> n >> m >> s;
    for (int i = 0; i < m; i++)
        cin >> a[i];
    sort(a, a + m);
    for (int j = min(s, a[0] - 1); j > 0; j--)
        b.pb(1);
    b.pb(0);
    for (int i = 0; i < m - 1; i++) {
        if (a[i + 1] - a[i] - 1 > 0)
            b.pb(a[i + 1] - a[i] - 1);
        if (i == 0 || (i > 0 && a[i - 1] != a[i]))
            b.pb(0);
    }
    for (int j = 1; j <= min(s, n - a[m - 1]); j++)
        b.pb(1);
    if (b.size() < m) {
        cout << 0 << '\n';
        return 0;
    }
    int l = 0;
    int ans = 0;
    int r = m - 1;
    int cnt = 0;
    for (int i = 0; i <= r; i++)
        cnt += b[i];
    while (r != b.size()) {
        if (cnt <= s)
            ans++;
        if (b[l] != 0)
            cnt -= b[l];
        if (b[r + 1] != 0)
            cnt += b[r];
        l++;
        r++;
    }

    cout << ans << '\n';
    return 0;
}
