/*
         ,--"""",--.__,---[],-------._
       ,"   __,'            \         \--""""""==;-
     ," _,-"  "/---.___     \       ___\   ,-'',"
    /,-'      / ;. ,.--'-.__\  _,-"" ,| `,'   /
   /``""""-._/,-|:\       []\,' ```-/:;-. `. /
             `  ;:::      ||       /:,;  `-.\
                =.,'__,---||-.____',.=
                =(:\_     ||__    ):)=
               ,"::::`----||::`--':::"._
             ,':::::::::::||::::::::::::'.
    .__     ;:::.-.:::::__||___:::::.-.:::\     __,
       """-;:::( O )::::>_|| _<::::( O )::::-"""
   =======;:::::`-`:::::::||':::::::`-`:::::\=======
    ,--"";:::_____________||______________::::""----.          , ,
         ; ::`._(    |    |||     |   )_,'::::\_,,,,,,,,,,____/,'_,
       ,;    :::`--._|____[]|_____|_.-'::::::::::::::::::::::::);_
      ;/ /      :::::::::,||,:::::::::::::::::::::::::::::::::::/
     /; ``''''----------/,'/,__,,,,,____:::::::::::::::::::::,"
     ;/                :);/|_;| ,--.. . ```-.:::::::::::::_,"
    /;                :::):__,'//""\\. ,--.. \:::,:::::_,"
   ;/              :::::/ . . . . . . //""\\. \::":__,"
   ;/          :::::::,' . . . . . . . . . . .:`::\
   ';      :::::::__,'. ,--.. . .,--. . . . . .:`::`
   ';   __,..--'''-. . //""\\. .//""\\ . ,--.. :`:::`
   ;    /  \\ .//""\\ . . . . . . . . . //""\\. :`::`
   ;   /       . . . . . . . . . . . . . . . . .:`::`
   ;   (          . . . . . . . . . . . . . . . ;:::`
   ,:  ;,            . . . . . . . . . . . . . ;':::`
   ,:  ;,             . . . . . . . . . . . . .;`:::
   ,:   ;,             . . . . . . . . . . . . ;`::;`
    ,:  ;             . . . . . . . . . . . . ;':::;`
     :   ;             . . . . . . . . . . . ,':::;
      :   '.          . . . . . . . .. . . .,':::;`
       :    `.       . . . . . . . . . . . ;::::;`
        '.    `-.   . . . . . . . . . . ,-'::::;
          `:_    ``--..___________..--'':::::;'`
             `._::,.:,.:,:_ctr_:,:,.::,.:_;'`
________________`"\/"\/\/'""""`\/"\/""\/"____________________________
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstdio>
#include <set>
#include <fstream>
#include <climits>
#include <cmath>
#include <deque>
#include <map>
#include <ctime>
#include <random>
#include <unordered_set>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <cassert>
#include <bits/stdc++.h>

#define ff first
#define ss second
#define pb push_back
#define pp pop_back
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define IO ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define out(a) cout << a << " ";
#define in(x) cin >> x;
#define ends cout << endl;
#define here cout << "here" << endl;
using namespace std;

vector <ll> b;
vector <ll> a;

int search(int x) {
    int l = 0, r = a.size(), m;
    while (r - l > 1) {
        m = (r + l) / 2;
        if (a[m] > x) r = m;
        else l = m;
    }
    return l;
}

void solve() {
    ll n, m, s;
    cin >> n >> m >> s;
    b.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }
    b.pb(0);
    ll res = 0;
    sort(b.begin(), b.end());
    a.pb(b[0]);
    for(int i=1;i<b.size();i++){
        if(b[i]!=b[i-1])    a.pb(b[i]);
    }
    for (int i = 1; i <= m && a[i] + m - 1 <= n; i++) {
        int j = search(a[i] + m - 1);
        //cout << i << ' ' << j << endl;
        if(s - (m - (j - i + 1)) >= 0) {
            ll shift = s - (m - (j - i + 1));
            //cout << max(shift + 1, a[i] + m - a[j]) << ' ' << s - (m - (j - i + 1)) << ' ' << a[i] + m - a[j] << ' ' << min(max(shift + 1, a[i] + m - a[j]), a[i] - a[i - 1]) << endl;
            res += min(max(shift + 1, a[i] + m - a[j]), a[i] - a[i - 1]);
        }
    }
    cout << res << endl;
}

int main(){
    solve();
    return 0;
}
