//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2")
// 293206GT
#include <array>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <climits>
#include <limits>
#include <set>
#include <map>
#include <queue>
//#include <unordered_map>
//#include <unordered_set>
//#include <unordered_set>
//#include <stack>
#include <string>
#include <algorithm>
#include <random>
#include <bitset>
#include <chrono>
//#include <cstdlib>
//#include <cstring>

//#include <bits/extc++.h>
//using namespace __gnu_pbds;
//template<class T>
//using OrderedSet = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
//#define int ll
// #define int long long
using namespace std;
#define put(a) cout << (a) << '\n'
#define sqr(x) ((x) * (x))
typedef pair<int, int> pii;
typedef long double ld;
typedef pair<ld, ld> pld;
typedef unsigned long long ull;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vpii;
#define ts to_string
#define sts string ts

sts(string s) { return s; }

sts(bool b) { return b ? "true" : "false"; }

sts(char c) { return string(1, c); }

sts(const char *s) { return (string) s; }

template<class A, class B>
sts(pair<A, B>);

template<class T>
sts(T v) {
    string s = "{", sep = "";
    for (auto x : v) {
        s += sep;
        sep = ", ";
        s += ts(x);
    }
    return s + "}";
}

template<class A, class B>
sts(pair<A, B> p) { return "(" + ts(p.first) + ", " + ts(p.second) + ")"; }

void dbgPrint() { cerr << endl; }

template<class A, class... B>
void dbgPrint(A a, B... b) {
    cerr << ' ' << ts(a);
    dbgPrint(b...);
}

#ifdef LOCAL
#define dbg(...) cerr << "line #" << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbgPrint(__VA_ARGS__)
#else
#define dbg(...)
#endif

#define sz(a) (int) (a).size()
#define len(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define rep(x, y, a) for (int x = (y); x < (int)(a); ++x)
#define asd(n) rep(i, 0, n)
#define jkl(n) rep(j, 0, n)
#define UB upper_bound
#define LB lower_bound
#define mp make_pair
namespace IO {

    template<class A, class B>
    ostream &operator<<(ostream &out, vector<pair<A, B>> a);

    template<class A>
    ostream &operator<<(ostream &out, vector<A> a);

    template<class A, class B>
    ostream &operator<<(ostream &out, pair<A, B> a) {
        out << a.first << " " << a.second;
        return out;
    }

    template<class A, class B>
    ostream &operator<<(ostream &out, vector<pair<A, B>> a) {
        for (pair<A, B> x : a)
            out << x.first << " " << x.second << '\n';
        return out;
    }

    template<class A>
    ostream &operator<<(ostream &out, vector<A> a) {
        for (A x : a) out << x << ' ';
        return out;
    }

    template<class A, class B>
    istream &operator>>(istream &in, pair<A, B> &a) {
        in >> a.first >> a.second;
        return in;
    }

    template<class A>
    istream &operator>>(istream &in, vector<A> &a) {
        for (A &x : a) in >> x;
        return in;
    }
}  // namespace IO

template<class A, class B>
inline int chkmax(A &a, B b) {
    if (a < (A) b) {
        a = (A) b;
        return 1;
    }
    return 0;
}

template<class A, class B>
inline int chkmin(A &a, B b) {
    if (a > (A) b) {
        a = (A) b;
        return 1;
    }
    return 0;
}

using namespace IO;

void solve();

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
     cin >> q;
    while (q--) solve();
}

vector<ll> p10;

vector<int> getD(ll x) {
    string cur = to_string(x);
    reverse(all(cur));
    assert(len(cur) <= 19);
    while (len(cur) < 19) cur.push_back('0');
    vector<int> res(19);
    for (int i = 0; i < 19; i++) {
        res[i] = cur[i] - '0';
    }
    return res;
}

ll calc(ll x, int i, int j, int dig) {
    vector<int> cur(19, -1);
    for (int k = i; k <= j; k++) {
        cur[k] = dig;
    }
    if (dig == 0 && j + 1 >= len(to_string(x))) return 0;

    ll ans = 0;
    vector<int> xd = getD(x);
    int last = i;
    for (int k = 18; k >= 0; k--) {
        if (k > j) {
            ans += xd[k] * p10[last];
        } else if (k < i) {
            ans += xd[k] * p10[k];
        } else {
            if (cur[k] < xd[k]) ans += p10[last];
            if (cur[k] != xd[k]) break;
        }
    }
    for (int k = len(to_string(x)) - 2; k >= j; k--) {
        if (k > j) {
            ans += 9 * p10[k - j] * p10[last];
        } else {
            ans += p10[last];
        }
    }
//    dbg(x, i, j, dig, ans);
    return ans;
}

void solve() {
    p10.resize(19, 1);
    for (int i = 1; i <= 18; i++) {
        p10[i] = p10[i - 1] * 10;
    }

    ll l, r;
    cin >> l >> r;
//    l = r = ll(1e18);
//    l -= 228;
    r++;
    pair<ll, ll> ans{0, 0};
    for (int i = 0; i < 19; i++) {
        for (int j = i; j < 19; j++) {
            for (int x = 0; x < 10; x++) {
                ll cnt = calc(r, i, j, x) - calc(l, i, j, x);
                assert(cnt >= 0);
                if (cnt) {
//                    if (j - i + 1 == 2) dbg(i, j, x, cnt);
//                    dbg(i, j, x, cnt);
                    if (ans.first > j - i + 1) continue;
                    if (ans.first < j - i + 1) ans = {j - i + 1, cnt};
                    else ans.second += cnt;
                }
            }
        }
    }
    cout << ans.first << ' ' << ans.second << '\n';
}
