#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>
#include <random>
#include <unordered_map>
 
using namespace std;

vector <vector <long long> > ans;
long long n, k;

void f(vector <long long>& a, long long last, long long sum) {
	if (sum == n) {
		ans.push_back(a);
		return;
	}
	for (long long i = last; i <= n and sum + i <= n; i++) {
		a.push_back(i);
		f(a, i, sum + i);
		a.pop_back();
	}
}

int main() {
	cin >> n >> k;
	vector <long long> emp;
	f(emp, 1, 0);
	vector <vector <long long> > tans;
	for (auto i : ans) {
		vector <long long> d(n, 0);
		for (long long j : i) d[j - 1]++;
		tans.push_back(d);
	}
	long long anss = 0;
	vector <vector<long long>> dp(n + k, vector <long long> (n + k));
	for (long long i = 1; i < n + k; i++) {
		for (long long j = 0; j <= i; j++) {
			if (j == 0) {
				dp[i][j] = 1;
				continue;
			}
			if (i == 1) {
				dp[i][j] = 1;
				continue;
			}
			dp[i][j] = dp[i - 1][j - 1] + dp[i - 1][j];
		}
	}
	for (long long i = 0; i < (long long)tans.size(); i++) {
		long long tanst = 1;
		for (long long j = 0; j < n; j++) {
			if (tans[i][j] == 0) continue;
			tanst *= dp[tans[i][j] + k - 1][tans[i][j]];
		}
		anss += tanst;
	}
	cout << anss;	
}