#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>
#include <random>
#include <unordered_map>
 
using namespace std;

vector <vector <int> > ans;
int n, k;

void f(vector <int>& a, int last, int sum) {
	if (sum == n) {
		ans.push_back(a);
		return;
	}
	for (int i = last; i <= n and sum + i <= n; i++) {
		a.push_back(i);
		f(a, i, sum + i);
		a.pop_back();
	}
}

int main() {
	cin >> n >> k;
	vector <int> emp;
	f(emp, 1, 0);
	vector <vector <int> > tans;
	for (auto i : ans) {
		vector <int> d(n, 0);
		for (int j : i) d[j - 1]++;
		tans.push_back(d);
	}
	int anss = 0;
	vector <vector<int>> dp(n + k, vector <int> (n + k));
	for (int i = 1; i < n + k; i++) {
		for (int j = 0; j <= i; j++) {
			if (j == 0) {
				dp[i][j] = 1;
				continue;
			}
			if (i == 1) {
				dp[i][j] = 1;
				continue;
			}
			dp[i][j] = dp[i - 1][j - 1] + dp[i - 1][j];
		}
	}
	for (int i = 0; i < (int)tans.size(); i++) {
		int tanst = 1;
		for (int j = 0; j < n; j++) {
			tanst *= dp[tans[i][j] + k - 1][tans[i][j]];
		}
		anss += tanst;
	}
	cout << anss;	
}