﻿#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>


int64_t input[1 << 20];
int64_t n, m, s;


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> m >> s;
	for (int i = 0; i < m; i++) {
		std::cin >> input[i];
	}


	std::sort(input, input + m);
	int x = std::unique(input, input + m) - input;

	int64_t res = 0;
	for (int i = 0; i < x; i++) {
		int pos = std::lower_bound(input, input + x, input[i] - m + 1) - input;

		if (((m - (i - pos + 1)) > s) || (input[i] < m)) {
			continue;
		}

		int r = ((i + 1) == x) ? (n + 1) : input[i + 1];
		int64_t beg = input[i], end = r;

		while ((beg + 1) < end) {
			int64_t mid = (beg + end) / 2;
			int p = std::lower_bound(input, input + x, mid - m + 1) - input;
			if ((m - (i - p + 1)) > s) {
				end = mid;
			} else {
				beg = mid;
			}
		}
		res += end - input[i];
	}

	std::cout << res << '\n';
}