#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <deque>
#include <iomanip>
#include <cassert>
#include <queue>

using namespace std;

#define int long long

#pragma GCC optimize("unroll-loops")

int ans = 0;
vector<bool> b;

int cnt = 0;

int maxn;

void solve(int v, int leftw, int c, vector<pair<pair<int, int>, int>> &a, vector<bool> &x) {
    ++cnt;
    if (leftw < 0) {
        return;
    }
    if (v == a.size()) {
        if (c > ans) {
            b = x;
            ans = c;
            cnt += x.size();
        }
        return;
    }
    if (cnt > maxn) {
        if (c > ans) {
            b = x;
            ans = c;
            cnt += x.size();
        }
        return;
    }
    if (leftw >= a[v].first.second) {
        x.push_back(1);
        solve(v + 1, leftw - a[v].first.second, c - a[v].first.first, a, x);
        x.pop_back();
    }
    x.push_back(0);
    solve(v + 1, leftw, c, a, x);
    x.pop_back();
}

bool cmp(pair<pair<int, int>, int> x, pair<pair<int, int>, int> y) {
    if (x.first.second < y.first.second) {
        return true;
    }
    if (x.first.second == y.first.second) {
        if (x.first.first < y.first.first) {
            return true;
        }
    }
    return false;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> q;
    while (q--) {
        ans = 0;
        b.clear();
        int n, w;
        cin >> n >> w;
        vector<pair<pair<int, int>, int>> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].first.second >> a[i].first.first;
            a[i].second = i;
            a[i].first.first *= -1;
        }
        sort(a.begin(), a.end(), cmp);
        vector<bool> x;
        maxn = n * 3000;
        cnt = 0;
        solve(0, w * 3 / 2, 0, a, x);
        vector<int> answ;
        if (b.size() == 0) {
            cout << 0 << '\n';
            continue;
        }
        for(int i = 0; i < b.size(); ++i) {
            if (b[i]) {
                answ.push_back(a[i].second);
            }
        }
        cout << answ.size() << '\n';
        for(int i : answ) {
            cout << i + 1 << ' ';
        }
        cout << '\n';
    }
}
