#include <iostream>
#include <vector>
#include <unordered_map>
#include <string>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <set>
#include <unordered_set>
#include <deque>
#include <functional>
#include <queue>
#include <cmath>
#include <array>
/// #include <bits/stdc++.h>

#define int long long
/// #define endl '\n'

using namespace std;

const int MAXN = 2e5;

bool cmp(array<int, 3> a, array<int, 3> b) {
   return a[1] * b[0] > b[1] * a[0];
}

array<int, 2> get(const vector<int> &prefw, const vector<int> &prefc, int k) {
    int l = 0, r = prefw.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (prefw[m] > k) {
            r = m;
        } else {
            l = m;
        }
    }
    return {prefw[l], prefc[l]};
}
 
signed main () {
    int tst;
    cin >> tst;
    while (tst--) {
        int n, w;
        cin >> n >> w;
        vector<array<int, 3>> arr1, arr2;
        for (int i = 0; i < n; ++i) {
            int x, y;
            cin >> x >> y;
            if (x * 2 > w) {
                arr2.push_back({x, y, i});
            } else {
                arr1.push_back({x, y, i});
            }
        }
        sort(arr1.begin(), arr1.end(), cmp);
        int sz = arr1.size();
        vector<int> prefw(sz + 1, 0), prefc(sz + 1, 0);
        for (int i = 0; i < sz; ++i) {
            prefw[i + 1] = prefw[i] + arr1[i][0];
            prefc[i + 1] = prefc[i] + arr1[i][1];
        }
        auto res = get(prefw, prefc, 3 * w / 2);
        int ans = res[1];
        vector<int> ansv;
        int x = 0;
        for (auto elem : arr1) {
            x += elem[0];
            if (x <= res[0]) {
                ansv.push_back(elem[2]);
            }
        }
        vector<int> ansa;
        ansa = ansv;
        int anss = -1;
        for (auto elem : arr2) {
            if (elem[0] > 3 * w / 2) {
                continue;
            }
            auto res = get(prefw, prefc, 3 * w / 2 - elem[0]);
            if (res[1] + elem[1] > ans) {
                anss = elem[2];
                ans = res[1] + elem[1];
            }
        }
        if (anss != -1) {
            for (auto elem : arr2) {
                if (elem[2] == anss) {
                    auto res = get(prefw, prefc, 3 * w / 2 - elem[0]);
                    vector<int> ansv;
                    int x = 0;
                    for (auto elem : arr1) {
                        x += elem[0];
                        if (x <= res[0]) {
                            ansv.push_back(elem[2]);
                        }
                    }
                    ansv.push_back(elem[2]);
                    ansa = ansv;
                }
            }
        }
        cout << ansa.size() << "\n";
        for (auto elem : ansa) {
            cout << elem + 1 << " ";
        }
        cout << "\n";
    }
    return 0;
}
 
/**
 3
 3 10
 5 100
 5 100
 4 99
 3 100
 97 100
 98 101
 99 90
 3 100
 55 100
 99 150
 200 200
 */
