//
// Created by watemus on 06.12.2020.
//

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define FF first
#define SS second

using ll = long long;
using ld = long double;

#define int ll

template<typename T>
using vec = std::vector<T>;

template<typename T>
using uset = std::unordered_set<T>;

template<typename T1, typename T2>
using umap = std::unordered_map<T1, T2>;

constexpr ll INFL = 1000000000000000069;
constexpr int INFI = 1000000069;
const ld PI = acos(-1);

#ifdef LOCAL
std::mt19937 rnd(69);
#else
std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());
#endif

vec<pair<int, int>> DD = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

#ifdef LOCAL
#else
#endif

const int T = 1e7;

int mx[T], mn[T],  agn[T], lt[T], rt[T];

int cnt_nodes = 0;

int new_node() {
  int u = cnt_nodes++;
  mn[u] = mx[u] = 0;
  lt[u] = -1;
  rt[u] = -1;
  agn[u] = 0;
  return u;
}

inline void push(int u, int l, int r) {\
  mx[u] += agn[u];
  mn[u] += agn[u];
  if (r - l > 1) {
    if (lt[u] == -1) {
      lt[u] = new_node();
    }
    if (rt[u] == -1) {
      rt[u] = new_node();
    }
    agn[lt[u]] += agn[u];
    agn[rt[u]] += agn[u];
  }
  agn[u] = 0;
}

void modify(int u, int l, int r, int lq, int rq, int x) {
  push(u, l, r);
  if (lq <= l && r <= rq) {
    agn[u] += x;
    push(u, l, r);
    return;
  }
  if (rq <= l || r <= lq) {
    return;
  }
  int mid = (l + r) / 2;
  if (lt[u] == -1) lt[u] = new_node();
  if (rt[u] == -1) rt[u] = new_node();
  modify(lt[u], l, mid, lq, rq, x);
  modify(rt[u], mid, r, lq, rq, x);
  mx[u] = max(mx[lt[u]], mx[rt[u]]);
  mn[u] = min(mn[lt[u]], mn[rt[u]]);
}

int get(int u, int l, int r, int lq, int rq, int x) {
  push(u, l, r);
  if (u == -1 || mx[u] < x || r <= lq || rq <= l)
    return 0;
  int ans = 0;
  if (mn[u] >= x && lq <= l && r <= rq) {
    return r - l;
  }
  int mid = (l + r) / 2;
  return get(lt[u], l, mid, lq, rq, x) + get(rt[u], mid, r, lq, rq, x);
}

void print(int u, int l, int r) {
  push(u, l, r);
  if (r - l == 1) {
    cerr << mn[u] << ' ';
  } else {
    int mid = (l + r) / 2;
    if (lt[u] == -1) lt[u] = new_node();
    if (rt[u] == -1) rt[u] = new_node();
    print(lt[u], l, mid);
    print(rt[u], mid, r);
  }
}

void run() {
  int n, s, m;
  int root = new_node();
  cin >> n >> m >> s;
  vec<int> a(m);
  for (int i = 0; i < m; i++) {
    cin >> a[i];
  }
  sort(ALL(a));
  a.resize(unique(ALL(a)) - a.begin());
  for (auto el : a) {

//    print(root, 1, n + 1);
//    cerr << endl;
    modify(root, 1, n + 1, max(el - m + 1, 1LL), min(el + 1, n + 1), 1);
  }
//  print(root, 1, n + 1);
//  cerr << endl;
  int ans = get(root, 1, n + 1, 1, n - m + 1+ 1, m - s);
  cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
  std::freopen("input.txt", "r", stdin);
#else
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
#endif
  int t = 1;
  // cin >> t;
  while (t--) {
    run();
  }
  return 0;
}


