#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef vector<ll> vll;
typedef complex<double> cd;

const char el = '\n';
const int inf = 1000'000'000, mod = 1000'000'007, mod2 = 998'244'353;
const ll llinf = 1e18;
const ld pi = 3.141592653589793238462643383279502884197169399375105820974944592307816406286208998628034825;

//#define forn(i, n) for (int i = 0; i < (int)n; ++i)
//#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)
#define firn(i, n) for (int (i) = 1; (i) != (n); (i)++)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << el
#define popcount(x) __builtin_popcount(x)
#define popcountll(x) __builtin_popcountll(x)
#define fi first
#define se second
#define re return
#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())

template<typename T> bool uin(T &a, T b) { if (b < a) { a = b; return true; } return false; }
template<typename T> bool uax(T &a, T b) { if (b > a) { a = b; return true; } return false; }
template<class iterator> void output(iterator begin, iterator end, char p = ' ', ostream & out = cout) { while (begin != end) { out << (*begin) << p; begin++; } out << el; }
template<class T> void output(T x, char p = ' ', ostream & out = cout) { output(all(x), p, out); }

mt19937 rnd(time(nullptr));
mt19937_64 rnd_64(time(nullptr));

#define int ll
struct obj {
    ll w, c, i;
    obj() {}
    obj(int w, int c, int i): w(w), c(c), i(i) {}
};
bool operator <(const obj &a, const obj &b) {
    return a.c * 1ll * b.w > b.c * 1ll * a.w;
}
struct Fenwick {
    vector<int> f;
    Fenwick(int n) {
        f.assign(n, 0);
    }
    void upd(int x, int d) {
        for (; x < (int)f.size(); x |= x + 1)
            f[x] += d;
    }
    int sum(int r) {
        int ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1)
            ans += f[r];
        return ans;
    }
};
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) {
        int n;
        ll W;
        cin >> n >> W;
        vector<obj> a;
        forn(i, n) {
            int w, c;
            cin >> w >> c;
            if (w > W) continue;
            a.emplace_back(w, c, i);
        }
        sort(all(a));
        ll curw = 0, curc = 0;
        vector<bool> ok(n, false);
        forn(i, a.size()) {
            if ((curw + a[i].w) * 2 > 3 * W) continue;
            ok[a[i].i] = true;
            curw += a[i].w;
            curc += a[i].c;
        }
        ll ans = curc;
        vector<pair<ll, ll>> b;
        forn(i, a.size()) {
            b.emplace_back(a[i].w, i);
        }
        vector<int> pos(n, -1);
        forn(i, a.size()) pos[a[i].i] = i;
        sort(all(b));
        int uk = 0;
        Fenwick F(n), C(n);
        int imx = -1;
        ll mx = 0;
        for (int i = (int)b.size() - 1; i >= 0; i--) {
            if (a[b[i].y].w * 2 <= W) break;
            for (; uk < (int)b.size() && b[uk].x + a[b[i].y].w <= W; uk++)
                F.upd(b[uk].y, b[uk].x), C.upd(b[uk].y, a[b[uk].y].c);
            int l = -1, r = (int)a.size();
            while(r - l > 1) {
                int m = (l + r) >> 1;
                if (F.sum(m) > (W - a[b[i].y].w) * 2) r = m;
                else l = m;
            }
            if (uax(mx, a[b[i].y].c + C.sum(l))) {
                imx = b[i].y;
            }
        }
        if (ans >= mx) {
            int cnt = 0;
            forn(i, n) cnt += ok[i];
            cout << cnt << el;
            forn(i, n) if (ok[i]) cout << i + 1 << ' ';
            cout << el;
        }
        else {
            vector<int> viv;
            viv.push_back(a[imx].i);
            curc = curw = 0;
            forn(i, a.size()) {
                if (a[i].w + a[imx].w > W) continue;
                if (curw + a[i].w > (W - a[imx].w) * 2) continue;
                curc += a[i].c;
                curw += a[i].w;
                viv.push_back(a[i].i);
            }
            cout << (int)viv.size() << el;
            for (auto i : viv) cout << i + 1 << ' ';
            cout << el;
        }
    }
    return 0;
}
