﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <queue>


using namespace std;

#define ll long long
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ft first
#define sd second


void solve() {
	int t1, v1, t2, v2;
	cin >> t1 >> v1 >> t2 >> v2;
	if (v2 >= 10 && t2 < 0)
		cout << "A storm warning for tomorrow! Be careful and stay home if possible!";
	else if (t2 < t1)
		cout << "MCHS warns! Low temperature is expected tomorrow.";
	else if (v2 > v1)
		cout << "MCHS warns! Strong wind is expected tomorrow.";
	else
		cout << "No message";
}

const int maxN = 20;
long long int dp[maxN][maxN][maxN];

int32_t main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int n, k;
	cin >> n >> k;
	dp[0][0][0] = 1;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			for (int q = 0; q < k; q++) {
				for (int newN = 1; newN <= n; newN++) {
					if (newN + i > n) break;
					if (newN < j) continue;
					if (newN == j) {
						for(int l = q; l < k; l++)
							dp[i + newN][newN][l] += dp[i][j][q];
					}
					else {
						for (int l = 0; l < k; l++)
							dp[i + newN][newN][l] += dp[i][j][q];
					}
				}
			}
		}
	}
	long long int res = 0;
	for (int i = 1; i <= n; i++) {
		for (int q = 0; q < k; q++)
			res += dp[n][i][q];
	}
	cout << res;
}