#include <iostream>
#include <algorithm>
#include <iomanip>
#include <set>
#include <vector>
#include <cmath>

using namespace std;

typedef long long ll;

bool comp(pair<int, int> & a, pair<int, int>& b) {
    return a.first > b.first;
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i ++) {
        int n;
        cin >> n;
        vector<pair<int, int>> gods(n);
        for (int i = 0; i < n; i ++) cin >> gods[i].first;
        for (int i = 0; i < n; i ++) cin >> gods[i].second;
        sort(gods.begin(), gods.end(), comp);
        int add = 0;
        bool ans = true;
        int j = 1;
        int count = 0;
        for (int i = 0; i < n; i ++) {
            if (i == j) {
                j ++;
            }
            int total = gods[i].second;
            while (j < n && total > 0) {
                int d = min(total, gods[j].first);
                total -= d;
                gods[j].first -= d;
                if (gods[j].first == 0)
                    j ++;
            }
            if (total > add) {
                count ++;
                if (count == 2) {
                    ans = false;
                    break;
                }
                add += gods[i].first;
            }
            else {
                add -= total;
                add += gods[i].first;
            }
        }
        if (ans)
            cout << "YES\n";
        else
            cout << "NO\n";
    }
}
