#include <iostream>
#include <algorithm>
#include <iomanip>
#include <set>
#include <vector>

typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
    int n, m, s;
    cin >> n >> m>> s;
    set<int> values;
    for (int i = 0; i < m; i ++) {
        int v;
        cin >> v;
        values.insert(v);
    }
    vector<int> pos;
    pos.push_back(0);
    for (int i : values)
        pos.push_back(i);
    pos.push_back(n + 1);
    int l = 1, r=0;
    int space = s;
    ll ans = 0;
    while (r < n) {
        if (pos[r] - pos[l] + 1 <= m) {
            if (space >= 0 && space + pos[r] - pos[l] + 1 >= m) {
                ans += min(pos[r] - pos[l] + 1 + space - m + 1, pos[l] - pos[l-1] + pos[r + 1] - pos[r] - 1);
            }
            if (r < n - 1) {
                space -= pos[r + 1] - pos[r] - 1;
            }
            r ++;
        }
        else {
            space += pos[l + 1] - pos[l] - 1;
            l++;
        }
    }
    cout << ans;
}

