#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, w;

int calc(const vector< tuple<int, int, int> >& aa) {
	int curw = 0;
	int curc = 0;
	for(auto [ww, cc, ii]: aa) {
		if(curw + ww <= w) {
			curw += ww;
			curc += cc;
		}
	}
	return curc;
}

signed main() {
	int t;
	cin >> t;

	for(int q = 0; q < t; q++) {
		int clock_start = clock();

		cin >> n >> w;
		w = w + w / 2;

		vector< tuple<int, int, int> > aa(n);
		for(int i = 0; i < n; i++) {
			cin >> get<0>(aa[i]) >> get<1>(aa[i]);
			get<2>(aa[i]) = i;
		}

		sort(aa.begin(), aa.end(), [](auto a, auto b) {
			return get<0>(b) * get<1>(a) > get<0>(a) * get<1>(b);
		});

		int oldans = calc(aa);

		double temp = 1;
		for(int i = 0; i < 200; i++) {
			auto aanew = aa;
			for(int j = 0; j < (int)(temp * (n + 1)); j++) {
				swap(aanew[rand() % n], aanew[rand() % n]);
			}
			int newans = calc(aanew);
			if(newans > oldans || rand() < RAND_MAX * exp(-(oldans - newans) / temp)) {
				aa = aanew;
				oldans = newans;
			}
			temp *= 0.99;
		}

		cerr << temp << "\n";

		vector<int> ans;
		for(auto [ww, cc, ii]: aa) {
			if(w >= ww) {
				w -= ww;
				ans.push_back(ii);
			}
		}

		cout << ans.size() << "\n";

		for(int x: ans) {
			cout << x + 1 << " ";
		}
		cout << "\n";
	}

	return 0;
}