#include <iostream>
#include <vector>
#include <algorithm>

#define endl '\n'

using namespace std;

typedef long long ll;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        ll n, W;
        cin >> n >> W;
        vector<ll> w(n + 1), cost(n + 1);
        for (int i = 0; i < n; i++)
            cin >> w[i] >> cost[i];
        vector<ll> l, b;
        for (int i = 0; i < n; i++) {
            if (w[i] * 2 > 3 * W)
                continue;
            if (w[i] * 2 > W)
                b.push_back(i);
            else
                l.push_back(i);
        }
        b.push_back(n);
        sort(l.begin(), l.end(), [&](int i, int j) {
            return cost[i] * w[j] > cost[j] * w[i];
        });
        vector<ll> precost(1), prew(1);
        for (int i : l) {
            precost.push_back(precost.back() + cost[i]);
            prew.push_back(prew.back() + w[i]);
        }
        ll ans = 0;
        int pos = -1;
        for (int i : b) {
            ll ostw = 3 * W / 2 - w[i];
            int j = upper_bound(prew.begin(), prew.end(), ostw) - prew.begin() - 1;
            if (cost[i] + precost[j] > ans) {
                ans = cost[i] + precost[j];
                pos = i;
            }
        }
        if (pos == -1) {
            cout << 0 << endl;
            continue;
        }
        if (pos == n) {
            vector <int> ans;
            ll curw = 0;
            for (int i : l) {
                curw += w[i];
                if (curw * 2 > 3 * W)
                    break;
                ans.push_back(i);
            }
            cout << ans.size() << endl;
            for (auto &now : ans)
                cout << now + 1 << ' ';
            cout << endl;
            continue;
        }
        ll ostw = 3 * W / 2 - w[pos];
        int j = upper_bound(prew.begin(), prew.end(), ostw) - prew.begin() - 1;
        cout << j + 1 << endl;
        for (int i = 0; i < j; i++)
            cout << l[i] + 1 << ' ';
        cout << pos + 1 << ' ';
        cout << endl;
    }
    return 0;
}