#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <iomanip>
#include <map>
#include <cmath>
#include <bitset>
#include <utility>
#include <queue>
#include <iterator>
#include <climits>
#include <random>
#include <sstream>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
#include <cassert>
using namespace std;
typedef long long int ll;

struct el {
    int a, b, ind;
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    int t;

    cin >> t;
    while (t --> 0) {
        int n;
        vector<int> a, b;
        ll sa = 0, sb = 0;

        cin >> n;
        a.resize(n);
        for (int &elem : a) {
            cin >> elem;
            sa += elem;
        }
        b.resize(n);
        for (int &elem : b) {
            cin >> elem;
            sb += elem;
        }

        vector<el> c;
        for (int i = 0; i < n; ++i) {
            c.push_back({a[i], b[i], i});
        }
        sort(c.rbegin(), c.rend(), [](el a, el b) {
            return a.a + a.b < b.a + b.b;
        });

        int k = 0;
        for (int i = 0; i < n; ++i) {
            if (b[i] > sa - a[i]) {
                ++k;
            }
        }

        if (k >= 2) {
            cout << "NO\n";
        } else {
            vector<pair<int, int>> st;
            for (int i = 0; i < n; ++i) {
                st.emplace_back(a[i], i);
            }
            for (int i = 1; i < n && !st.empty(); ++i) {
                pair<int, int> tmp = {-1, -1};
                while (c[i].b > 0 && !st.empty()) {
                    auto cur = st.back();
                    st.pop_back();
                    if (c[i].ind != cur.second) {
                        if (c[i].b > cur.first) {
                            c[i].b -= cur.first;
                        } else {
                            st.emplace_back(cur.first - c[i].b, cur.second);
                            c[i].b = 0;
                        }
                    } else {
                        tmp = cur;
                    }
                }
                if (tmp != make_pair(-1, -1)) {
                    st.emplace_back(tmp.first, tmp.second);
                }
            }
            int sum = 0;
            for (int i = 1; i < n; ++i) {
                sum += c[i].b;
            }
            cout << (sum <= c[0].a ? "YES" : "NO") << '\n';
        }
    }
    return 0;
}
