#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <iomanip>
#include <map>
#include <cmath>
#include <bitset>
#include <utility>
#include <queue>
#include <iterator>
#include <climits>
#include <random>
#include <sstream>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
#include <cassert>
using namespace std;
typedef long long int ll;
#define int long long

struct el {
    int a, b, ind;
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    int t;

    cin >> t;
    while (t --> 0) {
        int n;
        vector<int> a, b;
        ll sa = 0, sb = 0;

        cin >> n;
        a.resize(n);
        for (int &elem : a) {
            cin >> elem;
            sa += elem;
        }
        b.resize(n);
        ll maxb = 0;
        for (int &elem : b) {
            cin >> elem;
            sb += elem;
            maxb = max(elem, maxb);
        }


        int k = 0;
        for (int i = 0; i < n; ++i) {
            if (b[i] > sa - a[i]) {
                ++k;
            }
        }

        if (k >= 2) {
            cout << "NO\n";
        } else {
            int sum = 0;
            for (int i = 0; i < n; ++i) {
                sum += max(0ll, a[i] - (sb - maxb - b[i]));
            }
            cout << (sa - sum >= sb - maxb ? "YES" : "NO") << '\n';
        }

    }
    return 0;
}
