#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define INF 0x3f3f3f3f
#define INFLL (int64_t)(1e18)
#define EPS 1e-9
#define MOD 1000000007

template <class T> istream &operator>>(istream &is, vector<T> &a) {
    for (size_t i = 0; i < a.size(); ++i)
        is >> a[i];
    return is;
}

bool comp(tuple<int, int, int> a, tuple<int, int, int> b) {
    auto [w1, c1, i1] = a;
    auto [w2, c2, i2] = b;
    return c1 * w2 < c2 * w1;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //    int n, k;
    //    cin >> n >> k;
    //    vector<vector<int>> a(15, vector<int>(15,1));
    //    for (int i = 1; i < 15; ++i) {
    //        for (int j = 1; j < 15; ++j) {
    //            a[i][j] = a[i-1][j] + a[i][j-1];
    //        }
    //    }
    //    long long ret = 0;
    //    for (int i = 0; i < n; ++i) {
    //        for (int j = 0; j < k; ++j){
    //            ret+=a[i][j];
    //        }
    //    }
    //    cout << ret;
    //    int t;
    //    cin >> t;
    //    while (t--) {
    //        int n;
    //        cin >> n;
    //        vector<int> a(n), b(n);
    //        cin >> a >> b;
    //        long long sum1 = 0, sum2 = 0;
    //        for (int i : a)
    //            sum1 += i;
    //        for (int i : b)
    //            sum2 += i;
    //        bool ans = false;
    //        for (int i = 0; i < n; ++i)
    //            if (sum1 >= sum2 - b[i])
    //                ans = true;
    //        if (n == 2) {
    //            if (a[0] >= b[1] || a[1] >= b[0])
    //                cout << "YES\n";
    //            else
    //                cout << "NO\n";
    //            continue;
    //        }
    //        if (ans)
    //            cout << "YES\n";
    //        else
    //            cout << "NO\n";
    //    }
    int t;
    cin >> t;
    while (t--) {
        int n;
        long long W;
        cin >> n >> W;
        vector<tuple<int, int, int>> r(n);
        for (int i = 0; i < n; ++i) {
            int w, c;
            cin >> w >> c;
            r[i] = {w, c, i};
        }
        sort(all(r), comp);
        long long cur = 0;
        vector<int> ans;
        int ind = n - 1;
        while (2 * cur <= 3 * W && ind >= 0) {
            cur += get<0>(r[ind]);
            ans.push_back(get<2>(r[ind]));
            --ind;
        }
        if (2 * cur > 3 * W)
            ans.pop_back();
        cout << ans.size() << "\n";
        for (int i : ans)
            cout << i + 1 << " ";
        cout << "\n";
    }
}
