#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
typedef long long ll;

ll fact(ll n) {
	ll c = 1;
	for (int i = 2; i <= n; i++) {
		c *= i;
	}
	return c;
}

ll C(ll n, ll k) {
	return fact(n) / fact(n - k) / fact(k);
}

vector<vector<int>> rec(int a, int b) {
	if (a == 0) {
		return { {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0} };
	}

	vector<vector<int>> ans;
	for (int i = 1; i <= min(b,a); i++) {
		vector<vector<int>> t = rec(a - i, i);
		for (int j = 0; j < t.size(); j++) {
			vector<int> er = t[j];
			er[i] ++;
			ans.push_back(er);
		}
	}
	return ans;
}

signed main() {
	//freopen("inputik.txt", "r", stdin);
	//freopen("outputik.txt", "w", stdout);
	int n, k;
	cin >> n >> k;
	vector<vector<int>> kek = rec(n, n);
	ll ans = 0;
	for (int i = 0; i < kek.size(); i++) {
		ll mm = 1;
		for (int j = 0; j < 16; j++) {
			mm *= C(k+kek[i][j]-1,k-1);
		}
		ans += mm;
	}
	cout << ans;
}