#include <bits/stdc++.h>

using namespace std;

typedef double long dl;
typedef __int128 ll;

void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cout.setf(ios::fixed);
    cout.precision(10);
#ifdef _DEBUG
    freopen("..\\src\\input.txt", "r", stdin);
    freopen("..\\src\\output.txt", "w", stdout);
#endif
}

ostream& operator<<(ostream& out, ll &a){
    string s;
    while (a){
        s += char(a % 10 + '0');
        a /= 10;
    }
    reverse(s.begin(), s.end());
    out << s;
    return out;
}


int main() {
    input();
    int n, k;
    cin >> n >> k;
    vector<ll> fact(31);
    fact[0] = 1;
    for (int i = 1; i < 31; i++)
        fact[i] = fact[i - 1] * i;
    vector<set<vector<ll>>> p(15);
    for (int i = 0; i < 15; i++) {
        p[i].insert({i + 1});
        for (int j = 0; j < i; j++) {
            for (auto c : p[j]) {
                vector<ll> temp = c;
                temp.push_back({i - j});
                sort(temp.begin(), temp.end());
                p[i].insert(temp);
            }
        }
    }
    ll ans = 0;
    for (auto i : p[n - 1]) {
        ll temp = 1;
        ll last = 0;
        int k1 = 0;
        for (int j = 0; j < i.size(); j++){
            if (last == i[j]){
                k1++;
            }
            else {
                temp *= fact[k1 + k - 1] / fact[k1] / fact[k - 1];
                k1 = 1;
            }
            last = i[j];
        }
        temp *= fact[k1 + k - 1] / fact[k1] / fact[k - 1];
        ans += temp;
    }
    cout << ans;
    return 0;
}