// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define int long long

vector<vector<int>> q[16];
int fact[20];

void get(vector<int> a, int pos, int left) {
	if (left == 0) {
		q[a.size()].emplace_back(a);
		return;
	}
	if (pos == a.size()) {
		return;
	}
	for (int i = 1; i <= left; ++i) {
		if (pos > 0 && a[pos] + i > a[pos - 1]) break;
		vector<int> b = a;
		b[pos] += i;
		get(b, pos + 1, left - i);
	}
}

void gget(vector<int> a, int pos, int left, int &am) {
	if (left == 0) {
		++am;
		return;
	}
	if (pos == a.size()) {
		return;
	}
	for (int i = 1; i <= left; ++i) {
		if (pos > 0 && a[pos] + i > a[pos - 1]) break;
		vector<int> b = a;
		b[pos] += i;
		gget(b, pos + 1, left - i, am);
	}
}

long long C(int n, int k) {
	return fact[n] / fact[k] / fact[n - k];
}

signed main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
		cout.tie(nullptr);
		cout << fixed << setprecision(15);
	#endif
	fact[0] = 1;
	for (int i = 1; i < 20; ++i) fact[i] = fact[i - 1] * i;
	int n, k;
	cin >> n >> k;
	for (int len = 1; len <= n; ++len) {
		int left = n - len;
		get(vector<int>(len, 1), 0, left);
	}
	long long ans = 0;
	for (int len = 1; len <= n; ++len) {
		// cout << "len : " << len << '\n';
		for (auto &v : q[len]) {
			int cnt = 0;
			vector<int> am;
			for (int i = 0; i < v.size(); ++i) {
				if (i && v[i - 1] != v[i]) {
					am.emplace_back(cnt);
					cnt = 0;
				}
				++cnt;
			}
			am.emplace_back(cnt);
			// for (auto x : v) {
			// 	cout << x << ' ';
			// }
			// cout << '\n';
			// for (auto x : am) {
			// 	cout << x << ' ';
			// }
			// cout << '\n';
			// cout << '\n';
			for (auto x : am) {
				for (int i = 1; i <= min(x, k); ++i) {
					ans += C(k, i) * C(x - 1, i - 1);
				}
			}
		}
	}
	cout << ans;
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s    ";
	#endif
	return 0;
}