#include<bits/stdc++.h>

using namespace std;
#define int long long
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1;//(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

int const maxn = 1e5 + 5;
int suffc[maxn];
int suffw[maxn], ww[maxn], COST[maxn], used[maxn];
vector < vector < int > > Q, G, D;

pair < int, vector < int > > solveG(vector < int > ok, int n, int www, int bad) {
    for (int i = 1; i <= n; ++i) used[i] = 0;
    used[bad] = 1;
    vector < int > f;
    int S = 0;
    for (auto key : ok) {
        f.push_back(key);
        used[key] = 1;
        www -= ww[key];
        S += COST[key];
    }
    assert(www >= 0);
    for (auto key : G) {
        if (used[key[2]]) continue;
        if (-key[1] <= www) {
            www += key[1];
            S += key[0];
            f.push_back(key[2]);
        }
    }
    return {S, f};
}

pair < int, vector < int > > solveQ(vector < int > ok, int n, int www, int bad) {
    for (int i = 1; i <= n; ++i) used[i] = 0;
    used[bad] = 1;
    vector < int > f;
    int S = 0;
    for (auto key : ok) {
        f.push_back(key);
        used[key] = 1;
        www -= ww[key];
        S += COST[key];
    }
    assert(www >= 0);
    for (auto key : Q) {
        if (used[key[2]]) continue;
        if (key[0] <= www) {
            www -= key[0];
            S += key[1];
            f.push_back(key[2]);
        }
    }
    return {S, f};
}

pair < int, vector < int > > solveW(vector < int > ok, int n, int www, int bad) {
    for (int i = 1; i <= n; ++i) used[i] = 0;
    used[bad] = 1;
    vector < int > f;
    int S = 0;
    for (auto key : ok) {
        f.push_back(key);
        used[key] = 1;
        www -= ww[key];
        S += COST[key];
    }
    assert(www >= 0);
    for (auto key : D) {
        if (used[key[2]]) continue;
        if (key[0] <= www) {
            www -= key[0];
            S -= key[1];
            f.push_back(key[2]);
        }
    }
    return {S, f};
}

main() {
#ifdef karpovich
    freopen("input.txt", "r", stdin);
#endif // karpovich
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t, n, W, w, cost;
    cin >> t;
    while (t--) {
        cin >> n >> W;
        W = W * 3 / 2;
        int www = W;
        Q = {};
        G = {};
        D = {};
        for (int i = 1; i <= n; ++i) {
            cin >> w >> cost;
            ww[i] = w, COST[i] = cost;
            Q.push_back({w, cost, i});
            G.push_back({cost, -w, i});
            D.push_back({w, -cost, i});
        }
        if (n <= 10) {
            int good_c = 0, good_mask = 0;
            for (int mask = 0; mask < (1 << n); ++mask) {
                int fw = 0, fc = 0;
                for (int j = 0; j < n; ++j) {
                    if ((mask&(1 << j)) > 0) {
                        fw += ww[j + 1], fc += COST[j + 1];
                    }
                }
                if (fw <= W && fc > good_c) {
                    good_c = fc, good_mask = mask;
                }
            }
            vector < int > out;
            for (int j = 0; j < n; ++j) {
                if ((good_mask&(1 << j)) > 0) out.push_back(j + 1);
            }
            cout << out.size() << '\n';
            for (auto key : out) cout << key << " ";
            cout << '\n';
            continue;
        }
        sort(G.rbegin(), G.rend());
        sort(D.begin(), D.end());
        sort(Q.begin(), Q.end(), [](vector < int > L, vector < int > R) {
            return L[1] * R[0] > R[1] * L[0];
        });
        int C = 0;
        vector < int > ans, check;
        for (auto key : Q) {
            if (W >= key[0]) {
                W -= key[0], C += key[1];
                ans.push_back(key[2]);
            }
            else check.push_back(key[2]);
        }
        vector < int > out = ans;
        for (int lst = (int)ans.size() - 1; lst >= max((int)ans.size() - 15, 0ll); --lst) {
            vector < int > ok;
            for (int j = 0; j < (int)ans.size(); ++j) {
                if (j != lst) ok.push_back(ans[j]);
            }
            pair < int, vector < int > >  cc = solveG(ok, n, www, ans[lst]);
            if (cc.first > C) {
                C = cc.first, out = cc.second;
            }
            cc = solveQ(ok, n, www, ans[lst]);
            if (cc.first > C) {
                C = cc.first, out = cc.second;
            }
            cc = solveW(ok, n, www, ans[lst]);
            if (cc.first > C) {
                C = cc.first, out = cc.second;
            }
        }
        for (int lst = 0; lst < min((int)ans.size(), 15ll); ++lst) {
            vector < int > ok;
            for (int j = 0; j < (int)ans.size(); ++j) {
                if (j != lst) ok.push_back(ans[j]);
            }
            pair < int, vector < int > >  cc = solveG(ok, n, www, ans[lst]);
            if (cc.first > C) {
                C = cc.first, out = cc.second;
            }
            cc = solveQ(ok, n, www, ans[lst]);
            if (cc.first > C) {
                C = cc.first, out = cc.second;
            }
            cc = solveW(ok, n, www, ans[lst]);
            if (cc.first > C) {
                C = cc.first, out = cc.second;
            }
        }
        cout << out.size() << '\n';
        for (auto key : out) cout << key << " ";
        cout << '\n';
    }

    return 0;
}

