#include <bits/stdc++.h>
#define f first
#define s second
#define x first
#define y second
#define _ << ' ' <<
#define int long long
#define all(x) x.begin(), x.end()

//#pragma GCC optimize("O3")

#ifdef LOCAL
#else
    #define err if(0) cerr
#endif // LOCAL

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 305;

pii pts[N];

int operator ^(pii a, pii b)
{
    return a.x * b.y - a.y * b.x;
}

pii operator -(pii a, pii b)
{
    return {a.x - b.x, a.y - b.y};
}

bool inter(pii a, pii b)
{
    pii A = pts[a.x];
    pii B = pts[a.y];
    pii C = pts[b.x];
    pii D = pts[b.y];
    if (A == C || A == D || B == C || B == D)
        return false;
    int f = (C - A) ^ (B - A);
    int s = (D - A) ^ (B - A);
    if (f * s >= 0)
        return false;
    f = (A - D) ^ (C - D);
    s = (B - D) ^ (C - D);
    if (f * s >= 0)
        return false;
    return true;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> pts[i].x >> pts[i].y;
    vector <pii> edges;
    edges.reserve(n * (n - 1) / 2);
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j)
            edges.push_back({i, j});
    int cnt = 0;
    while (edges.size())
    {
        ++cnt;
        auto cur = edges[0];
        swap(edges[0], edges[edges.size() - 1]);
        edges.pop_back();
        for (int i = 0; i < edges.size(); ++i)
        {
            if (inter(cur, edges[i]))
            {
                swap(edges[i], edges[edges.size() - 1]);
                edges.pop_back();
                --i;
            }
        }
    }
    if (cnt & 1)
    {
        cout << 1 << endl;
        for (int i = 0; i < n; ++i)
            for (int j = i + 1; j < n; ++j)
                edges.push_back({i, j});
        while (edges.size())
        {
            ++cnt;
            auto cur = edges[0];
            swap(edges[0], edges[edges.size() - 1]);
            edges.pop_back();
            for (int i = 0; i < edges.size(); ++i)
            {
                if (inter(cur, edges[i]))
                {
                    swap(edges[i], edges[edges.size() - 1]);
                    edges.pop_back();
                    --i;
                }
            }
            cout << cur.x + 1 _ cur.y + 1 << endl;
            int r, m;
            cin >> r >> m;
            if (r == 0 && m == 0)
                return;
            cur = {min(--r, --m), max(r, m)};
            for (int i = 0; i < edges.size(); ++i)
            {
                if (edges[i] == cur)
                {
                    swap(edges[i], edges[edges.size() - 1]);
                    edges.pop_back();
                }
            }
            for (int i = 0; i < edges.size(); ++i)
            {
                if (inter(cur, edges[i]))
                {
                    swap(edges[i], edges[edges.size() - 1]);
                    edges.pop_back();
                    --i;
                }
            }
        }
    }
    else
    {
        cout << 2 << endl;
        for (int i = 0; i < n; ++i)
            for (int j = i + 1; j < n; ++j)
                edges.push_back({i, j});
        while (edges.size())
        {
            pii cur;
            int r, m;
            cin >> r >> m;
            if (r == 0 && m == 0)
                return;
            cur = {min(--r, --m), max(r, m)};
            for (int i = 0; i < edges.size(); ++i)
            {
                if (edges[i] == cur)
                {
                    swap(edges[i], edges[edges.size() - 1]);
                    edges.pop_back();
                }
            }
            for (int i = 0; i < edges.size(); ++i)
            {
                if (inter(cur, edges[i]))
                {
                    swap(edges[i], edges[edges.size() - 1]);
                    edges.pop_back();
                    --i;
                }
            }
            ++cnt;
            cur = edges[0];
            swap(edges[0], edges[edges.size() - 1]);
            edges.pop_back();
            for (int i = 0; i < edges.size(); ++i)
            {
                if (inter(cur, edges[i]))
                {
                    swap(edges[i], edges[edges.size() - 1]);
                    edges.pop_back();
                    --i;
                }
            }
            cout << cur.x + 1 _ cur.y + 1 << endl;
        }
    }
}

signed main() {

#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
#else
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cout.tie(0);

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}


