/**
 *    author:  tourist
 *    created: 09.05.1945 00:43:00
**/
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define fi first
#define se second
#define pb emplace_back
#define all(x) x.begin(),x.end()
#define re return
#define mp make_pair
#define sz(x) ((int)(x).size())
#define rep(i, n) for (int i = 0; i < (n); i++)
#define rrep(i, n) for (int i = (n) - 1; i >= 0; i--)
#define sqr(x) ((x)*(x))

#define in(x); { for (auto &qwertyuiop : x) cin >> qwertyuiop; }
#define out(x); { for (auto qwertyuiop : x) cout << qwertyuiop << ' '; cout << endl; }
#define unq(x); { sort(x.begin(), x.end()); x.resize(unique(x.begin(), x.end()) - x.begin()); }

#define endl '\n'

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")

//#define int long long

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> ii;
typedef vector<ii> vii;
typedef vector<string> vs;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef pair<double, double> pdd;
typedef double D;
typedef complex<double> cmp;

typedef pair <short, short> pss;

typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<vector<bool>> vvb;
typedef vector<vector<char>> vvc;

double getTime() { return clock() / (double) CLOCKS_PER_SEC;};
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int mod = 1e9 + 7;
const ll INF = 3e18;
const int N = 1e5 + 5;
const int base0 = 437;
const int base1 = 343;
const int d = 400;
const D pi = acos(-1);
const long double eps = 1e-4;


void solve()
{
    int n, ansi, ansj;
    ll W, ans = -1;
    cin >> n >> W;
    vll w(n), cost(n);
    rep(i, n)
    {
        cin >> w[i] >> cost[i];
    }
    vector<double> p1 = {0.1, 0.25, 0.5, 1, 1.25, 1.5, 2, 5};
    vector<double> p2 = {0.11, 0.251, 0.51, 1, 1.251, 1.51, 2, 5};
    rep(i, sz(p1))
    {
        rep(j, sz(p2))
        {
            vector<pair<double, int>> v(n);
            rep(k, n)
            {
                v[k].fi = pow(cost[k], p1[i]) / pow(w[k], p2[j]);
                v[k].se = k;
            }
            sort(all(v), greater<>());
            ll cur_w = 0, cur_cost = 0;
            rep(k, n)
            {
                int id = v[k].se;
                if (cur_w + w[id] <= 3 * W / 2) {
                    cur_cost += cost[id];
                    cur_w += w[id];
                }
            }
            if (cur_cost > ans) {
                ans = cur_cost;
                ansi = i; ansj = j;
            }
        }
    }
    vector<pair<double, int>> v(n);
    rep(k, n)
    {
        v[k].fi = pow(cost[k], p1[ansi]) / pow(w[k], p2[ansj]);
        v[k].se = k;
    }
    sort(all(v), greater<>());
    ll cur_w = 0, cur_cost = 0;
    vi arr;
    rep(k, n)
    {
        int id = v[k].se;
        if (cur_w + w[id] <= 3 * W / 2) {
            cur_cost += cost[id];
            cur_w += w[id];
            arr.pb(id);
        }
    }
    cout << sz(arr) << endl;
    rep(i, sz(arr)) cout << arr[i] + 1 << ' ';
    cout << endl;
}

signed main()
{
//    freopen("input.txt ", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int qq = 1;
    cin >> qq;
    while(qq--)
        solve();
}
