/*
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("section-anchors")
#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
#pragma GCC optimize("vpt")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("move-loop-invariants")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("function-sections")
#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
#pragma GCC optimize("btr-bb-exclusive")
*/
#include <iostream>
#include<algorithm>
#include<cmath>
#include<set>
#include<vector>
#include<string>
#include<map>
#include<queue>
  
using namespace std;
#define int long long
const int inf = 2e9;
const long long INF = 9e18;
const long double PI = 3.141;
const long double EPS = 1e-10;
  
int n, m, s;
vector <int> a;
  
int binary(int l, int r) {
    while (r - l>= 1) {
        int z = (l + r) >> 1;
        int pos1 = upper_bound(a.begin(), a.end(), z + m - 1) - a.begin() - 1;
        int k = pos1 - (lower_bound(a.begin(), a.end(), z) - a.begin()) + 1;
        if(z+m-1>n){
        	r=z-1;
		continue;
	}
	if (m - k <= s){
            z = ((l + r) >> 1)-1;
            pos1 = upper_bound(a.begin(), a.end(), z + m - 1) - a.begin() - 1;
            k = pos1 - (lower_bound(a.begin(), a.end(), z) - a.begin()) + 1;
            if ((m - k > s||z+1==l)&&z+m<=n){
                l = r = z+1;
                break;
            }else{
                r=z;
            }
        } else {
            l = z + 1;
        }
    }
    int pos1 = upper_bound(a.begin(), a.end(), r + m - 1) - a.begin() - 1;
    int k = pos1 - (lower_bound(a.begin(), a.end(), r) - a.begin()) + 1;
    if(m-k<=s&&r+m-1<=n){  
        return r;
    }else{
        return -1;
    }
}
  
void solve() {
    cin >> n >> m >> s;
    set <int> q;
    for (int i = 0; i < m; ++i) {
        int b; cin >> b;
        q.insert(b);
    }
    for (auto i : q)
        a.push_back(i);
    int ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        int pos2 = upper_bound(a.begin(), a.end(), a[i] + m - 1) - a.begin() - 1;
        if (pos2 - i + 1 + s >= m&&a[i]+m-1<=n)
            ++ans;
    }
  //cout<<ans<<endl;
    for (int i = 1; i < a.size(); ++i) {   
        int inx = binary(max(a[i] - s, a[i - 1]+1), min(n-m+1,a[i]-1));
        if(max(a[i] - s, a[i - 1]+1)<=inx&&inx<=min(n-m+1,a[i]-1)){
            ans += a[i] - inx;
        }
    }           
  //cout<<ans<<endl;
    int inx = binary(max(a[0] - s, 1ll), min(n-m+1,a[0]-1));
    //cout<<inx<<' ';
    if(max(a[0] - s, 1ll)<=inx&&inx<=min(n-m+1,a[0]-1)){
        ans += a[0] - inx;
    }
    cout << ans ;
}
  
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}