//order_of_key(k): Number of items strictly smaller than k .
//find_by_order(k): K-th element in a set (counting from zero).
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define full(x,n) x,x+n+1
#define full(x) x.begin(),x.end()
#define finish return 0

#define putb push_back
#define f first
#define s second

//logx(a^n)=loga(a^n)/logx(a)
//logx(a*b)=logx(a)+logx(b)
//logx(y)=log(y)/log(x)
//logb(n)=loga(n)/loga(b)

#define ordered_set tree<ll,null_type,less<ll>,rb_tree_tag,tree_order_statistics_node_update>
#define putf push_front
#define gainb pop_back

//(a+b)^n=sum of C(n,i)*a^i*b^(n-i) 0<=i<=n
//(a-b)^n=sum of C(n,i)*a^i*b^(n-i) for even i-for odd i

#define gainf pop_front
#define len(x) (int)x.size()

// 1/b%mod=b^(m-2)%mod
// (a>>x)&1==0
// a^b=(a+b)-2(a&b)

typedef double db;
typedef long long ll;

//sum of squares n*(n+1)*(2n+1)/6
//sum of cubes [n*(n+1)/2]^2
//sum of squares for odds n*(4*n*n-1)/3
//sum of cubes for odds n*n*(2*n*n-1)

const int ary=1e5+5;
const int mod=1e9+7;
const ll inf=1e18;

using namespace std;
using namespace __gnu_pbds;
int s,m,n,a[ary],nn,b[ary];
ll p[ary],ans;
int get(int l,int r,int x){
	int id=nn;
	while(l<=r){
		int md=(l+r)/2;
		if(b[md]>=x){
			r=md-1;
			id=md;
		}
		else{
			l=md+1;
		}
	}
	return id;
}
int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);cout.tie(0);
	cin>>n>>m>>s;
	for(int i=1;i<=m;i++){
		cin>>a[i];
	}
	sort(a+1,a+m+1);
	for(int i=1;i<=m;i++){
		if(i==1||a[i]>a[i-1]){
			nn++;
			b[nn]=a[i];
			p[nn]=p[nn-1]+b[nn]-b[nn-1]-1;
		}
	}
	for(int i=0;i<=nn;i++){
		int l,r;
		if(i==0){
			l=1,r=b[1];
		}
		else if(i==nn){
			if(b[i]==n){
				continue;
			}
			l=b[i]+1,r=n;
		}
		else{
			l=b[i]+1,r=b[i+1];
		}
		if(l+m-1>n){
			continue;
		}
		int lk=l;
		int mx=0;
		while(l<=r){
			int md=(l+r)/2;
			if(md+m-1>n){
				r=md-1;
				continue;
			}
			int id=get(i+1,nn,md+m-1);
			ll x=p[id];
			x-=p[i];
			if(b[id]>md+m-1){
				x-=(b[id]-(md+m-1)-1);
			}
			else if(b[id]==md+m-1){
				x=x;
			}
			else{
				x+=((md+m-1)-b[id]);
			}
			x-=max((md-b[i]-1),0);
			if(x<=s){
				l=md+1;
				mx=max(mx,md);
			}
			else{
				r=md-1;
			}
		}
		if(mx){
			ans+=mx-lk+1;
		}
	}
	cout<<ans;
}
