// Muallif: Azimjon Mehmonali o'g'li

//=========================================================

//#pragma optimization_level 3
//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math,O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
//#pragma GCC optimization("unroll-loops")

//=========================================================
#ifdef DEBUG
#define xtp xtp1
#else
#define xtp(x)
#endif
//=========================================================

#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> ii;
typedef vector<ii> vii;

#define F first
#define S second
#define pb push_back
#define endl "\n"

#define ALL(a) (a).begin(), (a).end()
#define rALL(a) (a).rbegin(), (a).rend()
#define SORT(a) sort(ALL(a))
#define rSORT(a) sort(rALL(a))
#define REV(a) reverse(ALL(a))
#define sqr(x) ((x) * (x))

#define TEZ                  \
	ios::sync_with_stdio(0); \
	cin.tie(0);

const long double PI = 3.1415926535897;
const int mod = 1000000007LL;
const int INF = 1e18;

void f() {
    int n;
    cin >> n;

    vii a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].S;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].F;
    }

    SORT(a);

    int l, r;
    l = 0, r = n - 1;
    int sr = -2;
    for (; l < n && r >= 0;) {
            if (l == r) {
                    sr = r;
                r--;
            }
            if (r == -1 && sr > 0) {
            r = sr;
            sr = -1;
        }
        if (r == -1) {
            break;
        }
        if (sr == -1 && r == l) {
            l++;
            if (l >= n) {
                cout << "YES" << endl;
                return;
            }
        }

        while (r >= 0 && l != r && a[l].F - a[r].S >= 0) {
            a[l].F -= a[r].S;
            a[r].S = 0;
            r--;
        }
        if (r == -1 && sr != -1) {
            r = sr;
            sr = -1;
        }
        if (r == -1) {
            break;
        }
        if (l == r) {
                    sr = r;
                r--;
            }
            if (r == -1) {
            break;
        }
        if (sr == -1 && r == l) {
            l++;
            if (l >= n) {
                cout << "YES" << endl;
                return;
            }
        }
        l++;/*
        if (l < n && a[l].F) {
            int z = min(a[l].F, a[r].S);
            a[l].F -= z;
            a[r].S -= z;
        }*/
    }

    if (l + 1 < n) {
        cout << "NO" << endl;
    } else {
        cout << "YES" << endl;
    }
}

signed main() {
	TEZ;

	int t;
	cin >> t;

	while (t--)
        f();

	return 0;
}
