#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <random>
#include <chrono>
#include <set>
using namespace std;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
    return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(a)
#endif
using llong = long long;
using uint = unsigned int;
using ullong = unsigned long long;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

int main()
{
    int t1, t2, v1, v2;
    cin >> t1 >> v1 >> t2 >> v2;
    if (t2 < 0 && v2 >= 10)
        cout << "A storm warning for tomorrow! Be careful and stay home if possible!";
    else if (t2 < t1)
        cout << "MCHS warns! Low temperature is expected tomorrow.";
    else if (v2 > v1)
        cout << "MCHS warns! Strong wind is expected tomorrow.";
    else
        cout << "No message";
}