#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define add push_back
#define all(a) a.begin(), a.end()

const int N = 100005;

ll n, m, s, ans = 0;
vector<ll> cards;
map<ll, bool> used;

int upper(ll number){
    ll left = 0, right = cards.size() - 1, ans = 0;
    while(left <= right){
        ll mid = (left + right) / 2;
        if(cards[mid] >= number){
            right = mid - 1;
            ans = mid;
        }
        else {
            left =  mid + 1;
        }
    }
    return ans;
}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0);
    
    cin >> n >> m >> s;
    for(int i = 0; i < m; i++){
        ll k;
        cin >> k;
        if(!used[k]){
            cards.add(k);
            used[k] = true;
        }
    }
    sort(all(cards));
    // for(int i = 0; i  <m; i++){
    //     cout << cards[i] << " ";
    // }
    // cout << endl;
    if(cards.size() + s < m){
        cout << 0;
        return 0;
    }
    for(int i = 0; i < cards.size(); i++){
        if(i + 1 + s < m){
            continue;
        }
        else {
            ans++;
        }
        ll lfind = upper(cards[i] - m + 1);
        // cout << lfind << " ";
        ll qan = i - lfind + 1;
        if(qan + s < m){
            continue;
        }
        if(i == cards.size() - 1){
            ans += min(cards[i - (m - s) + 1] - cards[lfind], n - cards[i] + 1);
            continue;
        }
        ans += min(cards[i - (m - s) + 1] - cards[lfind], cards[i + 1] - cards[i]);
    }
    // cout << endl;    
    cout << ans;
    return 0;
}