#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <bitset>
#include <fstream>
#include <unordered_set>

using namespace std;
using ll = long long;

ll const inf = 1e18;

ifstream fin("input.txt");
ofstream fout("output.txt");

string tobit(int n, int l)
{
	string s(l, '0');
	for (int i = 0; i < l; i ++)
	{
		if (n & (1ll << i))
			s[i] = '1';
	}
	return s;
}

signed main()
{
	int n; cin >> n;
	vector<unordered_set<string>> s(5);

	for (int t = 0; t < 5; ++t)
	{
		for (int i = 0; i < (1ll << (1ll << t)); ++i)
		{
			s[t].insert(tobit(i, (1ll << t)));
		}
	}

	string st = "";
	int l = 0;
	while (st.size() < (1ll << n))
	{
		if (!s[l].empty())
		{
			st += *s[l].begin();
			s[l].erase(s[l].begin());
		}
		else
		{
			l++;
			for (int i = 0; i < st.size(); i += (1ll << (l)))
			{
				s[l].erase(st.substr(i, (1ll << (l))));
			}
		}
	}
	cout << st << '\n';
	cin >> n;


	return 0;
}