#include <iostream>
#include <vector>
using namespace std;

vector<int> read_vec(int n) {
    vector<int> out(n);
    for (int i = 0; i < n; i++) {
        cin >> out[i];
    }
    return out;
}

struct data {
    int val;
    int ind;
    int arr;
};

data find_min_ind(vector<int> v, int a, int min_=-1000000, int not_i = -1) {
    int ind  = -1;
    int min_val = 1000000;
    for (int i = 0; i < v.size(); i++) {
        if (min_ < v[i] && v[i] < min_val && not_i != i && v[i] != 0) {
            min_val = v[i];
            ind = i;
        }
    }
    return {min_val, ind, a};
}

bool comp(data p1, data p2) {
    return  p1.val < p2.val;
}

int count_of(vector<int> v, int n) {
    int c = 0;
    for (int i : v) {
        if (i == n) {
            c++;
        }
    }
    return c;
}

bool task(int n, vector<int> v1, vector<int> v2) {
    bool out = false;

    while (1) {
        auto p1 = find_min_ind(v1, 0, -100000);
        auto p2 = find_min_ind(v2, 1, -100000, p1.ind);
        if (p1.ind != -1 && p2.ind != -1) {
            //auto p_min = min(p1, p2, comp);
            //auto p_max = max(p1, p2, comp);
            data p_max;data p_min;
            if (p1.val > p2.val)
            {
                p_max = p1;
                p_min = p2;
            }
            else if (p1.val == p2.val) {
                p_max = p2;
                p_min = p1;
            }
            else if (p1.val < p2.val) {
                p_max = p2;
                p_min = p1;
            }

            if (p_max.arr == 0) {
                v1[p_max.ind] = p_max.val - p_min.val;
            }
            else {
                v2[p_max.ind] = p_max.val - p_min.val;
            }

            if (p_min.arr == 0) {
                v1[p_min.ind] = 0;
                //v2[p_max.ind] = p_max.val - p_min.val;
            }
            else {
                v2[p_min.ind] = 0;
                //v1[p_max.ind] = p_max.val - p_min.val;
            }
        }
        else {

        }
        if ((v2.size() - count_of(v2, 0)) <= 1) {
            out = true;
            break;
        }
        else if (count_of(v1, 0) == v1.size() ) {
            out = false;
            break;
        }
    }
    return out;
}


int main() {
    int n = 0;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int nt;
        cin >> nt;
        vector<int> v1 = read_vec(nt);
        vector<int> v2 = read_vec(nt);

        if (task(nt, v1, v2))
            cout << "YES\n";
        else
            cout << "NO\n";

    }
    return 0;
}