#include <iostream>
#include <vector>
#include <queue>


using namespace std;

long long main() {
    long long n, m, k;
    cin >> n >> m >> k;

    vector<long long> gr [n];

    long long sets[n][k];

    for (long long i = 0; i < n; ++i) {
        for (long long i2 = 0; i2 < k; ++i2) {
            sets[i][i2] = 0;
        }
    }

    long long x;
    for (long long i = 0; i < n; ++i) {
        cin >> x;
    }

    for (long long i = 0; i < m; ++i) {
        long long u, v;
        cin >> u >> v;
        --u, --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    long long result[n];
    for (long long i = 0; i < n; ++i) {
        result[i] = 0;
    }

    queue<long long> q;
    q.push(0);
    result[0] = 1;

    for (long long y: gr[0]) {
        sets[y][0] = 1;
    }

    while (q.size()) {
        long long elem = q.front();
        q.pop();

        for (long long y: gr[elem]) {
            if (result[y] == 0) {
                long long slava = 0;
                for (long long z = result[elem]; z < k; ++z) {
                    if (sets[y][z] == 0) {
                        slava = z;
                        break;
                    }
                }
                result[y] = slava + 1;
                for (long long iterator: gr[y]) {
                    sets[iterator][slava] = 1;
                }
                q.push(y);
            }
        }
    }

    for (long long x: result) {
        cout << x << ' ';
    }

    return 0;
}