#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;

template <class T> bool ckmin(T &a,T b){ return a > b? a=b, true : false;}
template <class T> bool ckmax(T &a,T b){ return a < b? a=b, true : false;}

#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define mt make_tuple
#define F first
#define S second

// const int N = 2e5 + 500;
const int mod = 1e9 + 7; //998244353
const int INF = INT_MAX >> 1;
const ll LINF = LLONG_MAX >> 1;
const ld eps = 1e-9;

void solve() {
    int n; ll W; cin >> n >> W;
    vi w(n+1), cost(n+1), med, hev { n };
    for (int i = 0; i < n; ++i) {
        cin >> w[i] >> cost[i];
        if (2*w[i] > W) hev.eb(i);
        else med.eb(i);
    }
    sort(med.begin(), med.end(), [&](int l, int r) { return (ll)cost[l]*w[r] > (ll)cost[r]*w[l]; });
    sort(hev.begin(), hev.end(), [&](int l, int r) { return w[l] > w[r]; });

    int ptr = 0, hevid = -1, cnt = 0;
    ll ans = -1, sumW = 0, sum_cost = 0;
    for (int i : hev) {
        sumW += w[i]; sum_cost += cost[i];
        while(ptr < med.size() && sumW + w[med[ptr]] <= 3*W/2) 
            sumW += w[med[ptr]], sum_cost += cost[med[ptr]], ++ptr;
        // cout << "hevid = " << i+1 << ", w=" << w[i] << ", count = " << ptr << endl;
        if (sum_cost > ans && sumW <= 3*W/2) {
            ans = sum_cost;
            hevid = i;
            cnt = ptr;
        }
        sumW -= w[i]; sum_cost -= cost[i];
    }

    vi res;
    if (hevid != n) res.push_back(hevid + 1);
    for (int i = 0; i < cnt; ++i) res.push_back(med[i]+1);
    cout << res.size() << '\n';
    for (int i : res) cout << i << ' ';
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    //freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
    int t; cin >> t; while(t--) solve();

    return 0;
}